C     BAED.FOR
C     Last change:  RJH   5 Jan 99   10:22 am
C 
C*********************************************************************
C*                    Designed and written by                        *
C*                    Raymond J. Heemstra                            *
C*                    BDM-Oklahoma, Inc.                             *
C*                    Bartlesville, OK 74005                         *
C*********************************************************************
      SUBROUTINE BAEDIT(FILENAME,OUTNAME,ABORT,NEWSIM)
      COMMON /IGXYZ/ NP1,NP2,NP3
      INCLUDE 'BAEDPARM.INC'
      INCLUDE 'BED.INC'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'interip.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      LOGICAL AnswerB4
      CHARACTER*(*) FILENAME,OUTNAME
      CHARACTER*80 BUFFER
      CHARACTER*80 NOTICE(3)
      CHARACTER*3 STATYP
      LOGICAL THERE,ABORT,B4FILE
      LOGICAL ACCEPT,CANCEL
      LOGICAL NEWSIM,NEWMEM
      LOGICAL ALLOCATED
      INTEGER NDATASET
      REAL KX,KY,KZ
      INTEGER MISSING
      LOGICAL REMEM
      ALLOCATABLE :: DX(:,:,:),DY(:,:,:),DZ(:,:,:),DZNET(:,:,:),
     &    RDXL(:),RDYL(:),RDZL(:),RDZNET(:),ZT(:),
     &    VAREL(:,:),RKEL(:),EL(:,:,:),
     &    RPHL(:),RKXL(:),RKYL(:),RKZL(:),
     &    VP(:,:,:),KX(:,:,:),KY(:,:,:),KZ(:,:,:),
     &    IROCK(:,:,:),IPVT(:,:,:),PBOT(:,:,:),
     &    SO(:,:,:),SW(:,:,:),PN(:,:,:),
     &    LRCK(:),PIL(:),SOIL(:),SWIL(:),SGIL(:),PID(:,:,:),PWF(:,:,:)
      DATA MISSING /16534/
      ABORT=.FALSE.
      NEWMEM=.TRUE.
      REMEM=.FALSE.
      IOLD=LP1
      JOLD=LP2
      KOLD=LP3
!      NEWFILE=.FALSE.
!      LP1=NP1
!      LP2=NP2
!      LP3=NP3
!      NX=LP1
!      NY=LP2
!      NZ=LP3
      ITYPE=1
      NDATASET=0
      NERR=1
!      CALL AboutB4(1,'Open on LU 1','Debug')
10    OPEN(UNIT=1,FILE=FILENAME,STATUS='OLD',IOSTAT=ISTAT)
      IF (ISTAT .EQ. 16521) THEN
        CALL AboutB4(1,'IOSTAT=16521','Debug 1')
!    Finder dialog box to allow a new input file name be entered.
        IF (AnswerB4(1,'Open new input file?','-- QUESTION --')) THEN
          CALL IScreenBell('on')
          CALL InPopUp('on')
          CALL InMouseOptions(MouseExit,IntYes)
          CALL InHighlight('CYA','BLA')
          THERE=.FALSE.
          DO WHILE (.NOT.THERE)
            FILENAME='notitle.sim'      !  default file name
            CALL InStringXYDef(0,0,'Input file name ',2,
     &                          FILENAME,LENFILE)
            CALL InMouseOptions(MouseExit,IntNo)
            CALL InPopUp('off')
            INQUIRE(FILE=FILENAME,EXIST=THERE)
            IF (THERE) THEN
              IF (AnswerB4(1,'File already exists, wish to edit?',
     &            'Input file name request')) THEN
                THERE=.TRUE.
                NEWSIM=.FALSE.
                NEWMEM=.TRUE.
                STATYP='OLD'
              ELSE
                THERE=.FALSE.
                STATYP='NEW'
                NEWSIM=.TRUE.
                NEWMEM=.TRUE.
              END IF
            ELSE
              THERE=.TRUE.
              STATYP='NEW'
              NEWSIM=.TRUE.
              NEWMEM=.TRUE.
            END IF
          END DO
          OPEN(1,FILE=FILENAME,STATUS=STATYP,IOSTAT=ISTAT)
          IF(ISTAT .NE. 0) THEN
            NERR=2
            CALL IOSTAT_MSG(ISTAT,BUFFER)
            CALL AboutB4(1,TRIM(BUFFER),'Error Content')
            WRITE(BUFFER,*,ERR=9999) 'INPUT OPEN ERROR ',ISTAT
            CALL AboutB4(1,TRIM(BUFFER),'Error alert')
            STOP
          ENDIF
        ELSE          !  answer is NO, do not open new input file
          NEWSIM=.FALSE.
          RETURN
        END IF        !  end of AnswerB4
!  Normal new input data file entrance
      ELSE IF(ISTAT.EQ.MISSING) THEN     !  A new, missing, file name is asked.
        CALL AboutB4(1,'Creating a new file!','Information (BAED)')
        OPEN(UNIT=1,FILE=FILENAME,STATUS='UNKNOWN',IOSTAT=ISTAT)  ! create file!
        IF (ISTAT.NE.0) THEN
          CALL IOSTAT_MSG(ISTAT,BUFFER)
          CALL AboutB4(1,TRIM(BUFFER),'Error Content')
          STOP
        END IF
      ELSE IF (ISTAT .NE. 0.AND.ISTAT.NE.16521) THEN    !  some other error
        CALL IOSTAT_MSG(ISTAT,BUFFER)
        CALL AboutB4(1,TRIM(BUFFER),'Error Content')
      ENDIF

      INQUIRE(UNIT=1,EXIST=THERE)   !  check if file is there now
      IF (THERE) THEN        !  yes file is there
!        CALL AboutB4(1,'Found file there'//TRIM(FILENAME),'debug 3')
        READ(1,*,END=77) BUFFER  !  if new than end=77
        REWIND(1)
        THERE=.FALSE.
        NERR=3
        OUTNAME=FILENAME
      ELSE
        CALL AboutB4(1,'File not there'//TRIM(FILENAME),'debug 4')
        GO TO 10
      ENDIF

77    CONTINUE
      IF (THERE .AND. (.NOT.NEWSIM)) THEN
        NEWMEM=.TRUE.
        REWIND(1)
      END IF
C  BOASTVHS -- NHEAD = 1  THEN II,JJ,KK
C  BOAST2   -- NHEAD = 1  THEN RESTART DATA
C  BOAST3   -- MAXIMUM NHEAD = 8
!
!    Find the run time grid size
      NHEAD=1
60    CONTINUE
      IF (NEWSIM) THEN        !  A new file
        NERR=5
        WRITE(NOTICE(1),*,ERR=9999)
     &     'As requested, creating a new file '//TRIM(FileName)
        WRITE(NOTICE(2),*,ERR=9999)
     &     'If you wish preliminary input reservoir data that works,'
        WRITE(NOTICE(3),*,ERR=9999)
     &     'push the DEFAULT, before entering new reservoir data!'
        CALL AboutB4(3,NOTICE,'Special Notice (BAED)')
        REMEM=.TRUE.
!   Default all possible Headers and values into the new input data
!   file which can then be changed by the user. (BADEFALT taken out
!   for new memory allocation version of EdBoast)
        ITYPE=3
!        CALL AboutB4(1,'New file requested','BAED Debug')
        CALL GRIDSAED(ACCEPT,CANCEL,FileName,DX,DY,DZ,DZNET,
     &   RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,EL,NEWSIM,NEWMEM)
        IF (NEWSIM) THEN
          NEWMEM=.TRUE.
!         NEWSIM=.FALSE. ! caused System ERROR-- Data transfer beyond...
        ELSE
          NEWMEM=.FALSE.
        END IF
        IF (ACCEPT) THEN
          IF (NP1.EQ.0) THEN
            NP1=10
          END IF
          IF(NP2.EQ.0) THEN
            NP2=10
          END IF
          IF(NP3.EQ.0) THEN
            NP3=2
          END IF
          IROWS=NP1
          JCOLS=NP2
          KLAYERS=NP3
          NX=IROWS
          NY=JCOLS
          NZ=KLAYERS
          IREOPT=-1
          IPLOTP=0
          IRNUM=0
          IRSTRT=0
          NNRST=0
          TMAXRST=0.0
!       CALL EXTEN(FileName(1:12),RESIN,'RIN')
c       RESIN ='DUMMY.RIN'
c       RESOUT='DUMMY.ROT'
          II=NX
          JJ=NY
          KK=NZ
          NDATASET=1
          CALL EXTEN(FILENAME,OUTNAME,'SIM')
!          WRITE(BUFFER,'(A,3I4)')
!     &         'Entering BADEFALT with II,JJ,KK of ',II,JJ,KK
!          CALL AboutB4(1,BUFFER,'Info')
!          CALL BADEFALT(FILENAME,DX,DY,DZ,DZNET,
!     &         RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,EL,
!     &         RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,IROCK,IPVT,
!     &         PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF)
!          WRITE(BUFFER,'(A,3I4)')
!     &         'You chose II,JJ,KK of ',II,JJ,KK
!          CALL AboutB4(1,BUFFER,'Info')
        ELSE
          RETURN
        END IF
      ELSE         !   Edit an old file
!    Find the run time grid size
        DO 70 I=1,NHEAD
          READ(1,80,END=999) HEADING(I)
80        FORMAT(A80)
70      CONTINUE
        READ(1,*,ERR=993) IREOPT,IPLOTP

C    Need to READ past II,JJ,KK then REWIND in order to allocate enough
C    memory for all the arrays.  If II, JJ, or KK is changed then a
C    reallocation is in order.  Must work this out.
        NERR=6
        IF(IREOPT.LT.0) THEN
          READ(1,80,ERR=9999) HEADING(NHEAD+1)
          READ(1,*,ERR=993) IROWS,JCOLS,KLAYERS  !  must be same as from PEEK
        ELSE
          READ(1,*) IRNUM,IRSTRT,NNRST,TMAXRST
          READ(1,*) RESIN
          READ(1,*) RESOUT
          READ(1,*) (REDATE(I),I=1,IRNUM )
          IF (IREOPT.EQ.0) THEN
            NERR=7
            READ(1,80,ERR=9999) HEADING(NHEAD+1)
            READ(1,*,ERR=993) IROWS,JCOLS,KLAYERS
          ELSE IF(IREOPT.EQ.1) THEN   !  old restart binary file has grid size
             IROWS=NP1                !  in NP1, NP2, & NP2 or II,JJ,KK
             JCOLS=NP2
             KLAYERS=NP3
          END IF
        ENDIF
        REWIND(1)
        IF(IROWS .EQ. 0 .OR. JCOLS .EQ. 0 .OR.
     &                       KLAYERS .EQ. 0) THEN
C
C   This is a BOAST3 input file
C
          NHEAD = 6
          ITYPE = 3
          GO TO 60
        ELSE
          NERR=8
          WRITE(BUFFER,*,ERR=9999) 'II,JJ,KK=',IROWS,JCOLS,KLAYERS,
     &       ' ITYPE=',ITYPE
          IF (ITYPE .EQ. 1) THEN            !    BOAST-VHS DATA
            CALL AboutB4(1,TRIM(BUFFER),'BOAST-VHS Input Data')
          ELSE IF(ITYPE .EQ. 3) THEN        !    BOAST3 DATA
!            CALL AboutB4(1,BUFFER,'Boast98 Input Data')
          ELSE
            CALL AboutB4(1,TRIM(BUFFER),'UNKNOWN BOAST')
          ENDIF
        ENDIF
      END IF !   end of NEWSIM if

C  To reenter memory allocation only, REMEM must be true
C  Then the 1313 target is used and ITYPE=3 and NEWMEM is true
!1313  IF (REMEM) THEN
!        IROWS=NP1
!        JCOLS=NP2
!        KLAYERS=NP3
!        ITYPE=3
!      END IF
C     Read the BOAST2 input format

      IF(ITYPE .EQ. 1) THEN

C        CALL BOAST2RD
C        CLOSE(1)
         NERR=9
         WRITE(BUFFER,*,ERR=9999) 'BOAST2 READ NOT READY'
         CALL AboutB4(1,TRIM(BUFFER),'Error alert')
         ABORT=.TRUE.
         RETURN
      ELSE IF(ITYPE .EQ. 3) THEN
        CALL IScreenBackground('blue','blue')
        CALL IWinClose(1)
        REWIND(1)
        NEWMEM=.TRUE.
        DO WHILE (NEWMEM.OR.NEWSIM)
!   This is where the BOAST3/4 editor begins its work.
!   memory allocation begins here first.
!   Allocate or reallocate 1 dimensional arrays
C  To reenter memory allocation only USE GOTO 1313
1313      II=IROWS
          JJ=JCOLS
          KK=KLAYERS
!          WRITE(BUFFER,'(A12,I3,A4,I3,A4,I3)') 'Allocate II=',II,
!     &            ' JJ=',JJ,' KK=',KK
!          CALL AboutB4(1,BUFFER,'Grid size Information (BAED)')
! II
           LP1=II
           IF (ALLOCATED(RDXL) ) THEN
             DEALLOCATE (RDXL)
           END IF
           ALLOCATE (RDXL(LP1))
! JJ
           LP2=JJ
           IF (ALLOCATED(RDYL) ) THEN
             DEALLOCATE (RDYL)
           END IF
           ALLOCATE (RDYL(LP2))
! KK
           LP3=KK
           IF (ALLOCATED(RDZL) ) THEN
             DEALLOCATE (RDZL)
           END IF
           ALLOCATE (RDZL(LP3))
           IF (ALLOCATED(RDZNET) ) THEN
             DEALLOCATE (RDZNET)
           END IF
           ALLOCATE (RDZNET(LP3))
           IF (ALLOCATED(ZT)) THEN
             DEALLOCATE (ZT)
           END IF
           ALLOCATE (ZT(LP3))
           IF (ALLOCATED(RKEL) ) THEN
             DEALLOCATE (RKEL)
           END IF
           ALLOCATE (RKEL(LP3))
           IF (ALLOCATED(RPHL) ) THEN
             DEALLOCATE (RPHL)
           END IF
           ALLOCATE (RPHL(LP3))
           IF (ALLOCATED(RKXL) ) THEN
             DEALLOCATE (RKXL)
           END IF
           ALLOCATE (RKXL(LP3))
           IF (ALLOCATED(RKYL) ) THEN
             DEALLOCATE (RKYL)
           END IF
           ALLOCATE (RKYL(LP3))
           IF (ALLOCATED(RKZL) ) THEN
             DEALLOCATE (RKZL)
           END IF
           ALLOCATE (RKZL(LP3))
           IF (ALLOCATED(LRCK) ) THEN
             DEALLOCATE (LRCK)
           END IF
           ALLOCATE (LRCK(LP3))
           IF (ALLOCATED(PIL) ) THEN
             DEALLOCATE (PIL)
           END IF
           ALLOCATE (PIL(LP3))
           IF (ALLOCATED(SOIL) ) THEN
             DEALLOCATE (SOIL)
           END IF
           ALLOCATE (SOIL(LP3))
           IF (ALLOCATED(SWIL) ) THEN
             DEALLOCATE (SWIL)
           END IF
           ALLOCATE (SWIL(LP3))
           IF (ALLOCATED(SGIL) ) THEN
             DEALLOCATE (SGIL)
           END IF
           ALLOCATE (SGIL(LP3))

!  Reallocate 3 dimensional arrays

           IF (ALLOCATED(DX) ) THEN
             DEALLOCATE (DX)
           END IF
           ALLOCATE (DX(LP1,LP2,LP3))
           IF (ALLOCATED(DY) ) THEN
             DEALLOCATE (DY)
           END IF
           ALLOCATE (DY(LP1,LP2,LP3))
           IF (ALLOCATED(DZ) ) THEN
             DEALLOCATE (DZ)
           END IF
           ALLOCATE (DZ(LP1,LP2,LP3))
           IF (ALLOCATED(DZNET) ) THEN
             DEALLOCATE (DZNET)
           END IF
           ALLOCATE (DZNET(LP1,LP2,LP3))
           IF (ALLOCATED(EL) ) THEN
             DEALLOCATE (EL)
           END IF
           ALLOCATE (EL(LP1,LP2,LP3))
           IF (ALLOCATED(VP) ) THEN
             DEALLOCATE (VP)
           END IF
           ALLOCATE (VP(LP1,LP2,LP3))
           IF (ALLOCATED(KX) ) THEN
             DEALLOCATE (KX)
           END IF
           ALLOCATE (KX(LP1,LP2,LP3))
           IF (ALLOCATED(KY) ) THEN
             DEALLOCATE (KY)
           END IF
           ALLOCATE (KY(LP1,LP2,LP3))
           IF (ALLOCATED(KZ) ) THEN
             DEALLOCATE (KZ)
           END IF
           ALLOCATE (KZ(LP1,LP2,LP3))
           IF (ALLOCATED(IROCK) ) THEN
             DEALLOCATE (IROCK)
           END IF
           ALLOCATE (IROCK(LP1,LP2,LP3))
           IF (ALLOCATED(IPVT) ) THEN
             DEALLOCATE (IPVT)
           END IF
           ALLOCATE (IPVT(LP1,LP2,LP3))
           IF (ALLOCATED(PBOT) ) THEN
             DEALLOCATE (PBOT)
           END IF
           ALLOCATE (PBOT(LP1,LP2,LP3))
           IF (ALLOCATED(SO) ) THEN
             DEALLOCATE (SO)
           END IF
           ALLOCATE (SO(LP1,LP2,LP3))
           IF (ALLOCATED(SW) ) THEN
             DEALLOCATE (SW)
           END IF
           ALLOCATE (SW(LP1,LP2,LP3))
           IF (ALLOCATED(PN) ) THEN
             DEALLOCATE (PN)
           END IF
           ALLOCATE (PN(LP1,LP2,LP3))
           IF (ALLOCATED(PID) ) THEN
             DEALLOCATE (PID)
           END IF
           ALLOCATE (PID(LP11,LP3,LP112))
           IF (ALLOCATED(PWF) ) THEN
             DEALLOCATE (PWF)
           END IF
           ALLOCATE (PWF(LP11,LP3,LP112))
!  Reallocate 2 dimensional arrays
           IF (ALLOCATED(VAREL) ) THEN
             DEALLOCATE (VAREL)
           END IF
           ALLOCATE (VAREL(LP1,LP2))
!   Place grid size allocation in BUFFER
!           WRITE(BUFFER,'(A27,I3,A5,I3,A5,I3)')
!     &       'Finished allocation of LP1=',LP1,' LP2=',LP2,' LP3=',LP3
!           CALL AboutB4(1,TRIM(BUFFER),'Grid information (BAED)')

!           WRITE(BUFFER,'(A5,I3,2(A6,I3))') 'IOLD=',IOLD,
!     &        ' JOLD=',JOLD,' KOLD=',KOLD
!           CALL AboutB4(1,BUFFER,'Old grid values (BAED)')
           IF(REMEM.AND.(.NOT.NEWSIM)) THEN
!             CALL AboutB4(1,'REMEM is true','Debug (BAED)')
!             CALL AboutB4(1,'Calling BN98IN','Debug (BAED)')
             CALL BN98IN(IOLD,JOLD,KOLD,
     &          DX,DY,DZ,DZNET,RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,
     &          EL,RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,IROCK,IPVT,
     &          PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF,
     &          NDATASET)
!           ELSE
!             CALL AboutB4(1,'REMEM is false','Debug (BAED)')
           END IF
           NEWMEM=.FALSE.
C           REMEM=.FALSE.
!           IF (NEWSIM) THEN
!             CALL AboutB4(1,'NEWSIM is true (New File)',
!     &        'BAED Debug (BAED)')
!           ELSE
!             CALL AboutB4(1,'NEWSIM is false (Old file)',
!     &        'BAED Debug (BAED)')
!           END IF
!           IF (NEWMEM) THEN
!             CALL AboutB4(1,'New Memory','Debug (BAED)')
!           ELSE
!             CALL AboutB4(1,
!     &        'NEWMEM is false (Memory already Allocated)',
!     &        'BAED Debug (BAED)')
!           END IF
           IF ((.NOT.REMEM).AND.(.NOT.NEWSIM)) THEN
C  Blank out well names first
             DO I=1,NWX
               WELNAM(I)=' '
             END DO
             DO I=1,LP11
               DO J=1,LP112
                 WELNM(LP11,LP112)=' '
                 WELONM(LP11,LP112)=' '
               END DO
             END DO
           END IF
           CALL BAIN(ABORT,NDATASET,NEWSIM,FILENAME,NEWMEM,REMEM,
     &    IOLD,JOLD,KOLD,
     &    DX,DY,DZ,DZNET,RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,EL,
     &    RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,
     &    IROCK,IPVT,PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF)
!          CALL AboutB4(1,'Exiting BAIN','Notice (BAED)')
           IF (REMEM) THEN
             IROWS=NP1
             JCOLS=NP2
             KLAYERS=NP3
             NEWMEM=.FALSE.
             NEWSIM=.FALSE.
             ITYPE=3
             GO TO 1313
           END IF
           IF (ABORT) THEN
             CLOSE(1)
             ABORT=.FALSE.
             RETURN
           END IF
         END DO        !     End of DO WHILE(NEWMEM)
         CLOSE(1)
      ELSE         ! not a Boast3 input file
         CLOSE(1)
         RETURN    ! This was an ABORT from the Editor (from HOME)
      END IF
C
C    Finder dialog box to allow an output file name be entered.
C
      IF (AnswerB4(1,'Open Output File?','-- QUESTION --')) THEN
        CALL IScreenBell('on')
        CALL InPopUp('on')
        CALL InMouseOptions(MouseExit,IntYes)
        CALL InHighlight('CYA','BLA')
        CALL InStringXYDef(0,0,'Output file name ',2,OUTNAME,LENFILE)
        CALL InMouseOptions(MouseExit,IntNo)
        CALL InPopUp('off')
        IF(FileName(1:LENFILE).EQ.'untitled.sim'.OR.
     &      OUTNAME(1:LENFILE).EQ.'untitled.sim'.OR.
     &      OUTNAME(1:LENFILE).EQ.'untitled.new') THEN
          IF (B4FILE('Do you wish to rename the output file ?',
     &     'New file',OUTNAME,'New file request')) THEN
           CALL InStringXYDef(0,0,'New file name ',2,OUTNAME,LENFILE)

          END IF
        END IF
        OPEN(2,FILE=OUTNAME,STATUS='UNKNOWN',IOSTAT=ISTAT)
        IF(ISTAT .NE. 0) THEN
          NERR=10
          WRITE(BUFFER,*,ERR=9999) 'OUTPUT OPEN ERROR ',ISTAT
          CALL AboutB4(1,TRIM(BUFFER),'Error alert')
          STOP
        ENDIF
      ELSE
        ABORT=.TRUE.
        RETURN
      END IF
      IF(ITYPE .EQ. 1) THEN
!
!     Write the BOAST2 output format
!        CALL BLKOILWR
        CLOSE(2)
        NERR=11
        WRITE(BUFFER,*,ERR=9999) 'BoastVHS input file not read in'
        CALL AboutB4(1,TRIM(BUFFER),'Input Report')
        ABORT=.TRUE.
        RETURN
      ELSE
!  First change (9/15/98) since releasing EdBoast (10/8/98)
      NX=LP1
      NY=LP2
      NZ=LP3
!  End of change that should correct the problem of
!   No. of X[and Y] - direction blocks cannot exceed 0

        CALL BAOUT(NDATASET,
     &    DX,DY,DZ,DZNET,RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,EL,
     &    RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,
     &    IROCK,IPVT,PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF)
        NERR=12
        WRITE(NOTICE(1),*,ERR=9999) 'EdBoast output complete to '
        WRITE(NOTICE(2),*,ERR=9999) OUTNAME(1:LENFILE)
        CALL AboutB4(2,NOTICE,'Report')
        CLOSE(2)
        RETURN
      ENDIF
993   NHEAD = 6
      ITYPE = 3
      REWIND(1)
      NEWSIM=.FALSE.
      GO TO 60
999   CONTINUE
      RETURN
9999    WRITE(BUFFER,*) 'BAEDIT',NERR
        CALL AboutB4(1,TRIM(BUFFER),'INPUT ERROR')
      END SUBROUTINE

!     BN98OUT.FOR
!
      SUBROUTINE BN98OUT(DX,DY,DZ,DZNET,
     &     RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,
     &     EL,RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,IROCK,IPVT,
     &     PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF,
     &     NDATASET)
      INCLUDE 'BAEDPARM.INC'
      INCLUDE 'BED.INC'
      INCLUDE 'GRIDA.INC'
      INCLUDE 'PORPRA.INC'
      INCLUDE 'TABLEA.INC'
      INCLUDE 'UINITA.INC'
      INCLUDE 'NODESA.INC'
      CHARACTER*80 BUFFER

      OPEN (UNIT=19,FILE='BN98.TXT',STATUS='UNKNOWN',IOSTAT=ISTAT)
        IF(ISTAT .NE. 0) THEN
          NERR=1
          WRITE(BUFFER,*,ERR=999) 'OUTPUT OPEN ERROR ',ISTAT
          CALL AboutB4(1,TRIM(BUFFER),'Error alert')
          STOP
        ENDIF
!   Number of data sets
!        NRECURR=NDATASET
!   Rows, Columns, and Layers
      NERR=2
      WRITE(19,'(3(1X,I4))',ERR=998) LP1,LP2,LP3
      II=LP1
      JJ=LP2
      KK=LP3
! ***** GRID BLOCK LENGTH (DX) DISTRIBUTION
        NERR=3
        K=1
        DO J=1,JJ
          WRITE(19,*,ERR=998)(DX(I,J,K),I=1,II)
        END DO
! *****  GRID BLOCK LENGTH (DY) DISTRIBUTION
        NERR=4
        K=1
        DO J=1,JJ
          WRITE(19,*,ERR=998)(DY(I,J,K),I=1,II)
        END DO
! ***** ESTABLISH GRID BLOCK LENGTH (DZ) DISTRIBUTION
        NERR=5
        DO K=1,KK
          DO J=1,JJ
            WRITE(19,*,ERR=998)(DZ(I,J,K),I=1,II)
          END DO
        END DO
! ***** GRID BLOCK NET THICKNESS (DZNET) DISTRIBUTION
        NERR=6
        DO K=1,KK
         DO J=1,JJ
          WRITE(19,*,ERR=998) (DZNET(I,J,K),I=1,II)
          END DO
        END DO
! ***** RDXL
        NERR=7
        WRITE(19,*,ERR=998)(RDXL(I),I=1,II)
! ***** RDYL
        NERR=8
        WRITE(19,*,ERR=998)(RDYL(J),J=1,JJ)
! ***** RDZL
        NERR=9
        WRITE(19,*,ERR=998)(RDZL(K),K=1,KK)
! ***** GRID BLOCK NET THICKNESS (DZNET) DISTRIBUTION
       NERR=10
        WRITE(19,*,ERR=998) (RDZNET(K),K=1,KK)
! .... Establish node mid-point elevations...............
!     NOTE:  IF KEL = -2  -- non-contiguous layers, ZT's are read in
! ....   KEL = -2 ....................................
! ***** ZT
        NERR=11
        WRITE(19,*,ERR=998) (ZT(K),K=1,KK)
! .... KEL =  1, 2, 3 options - not altered !
! ....   KEL = 1 ....................................
! ***** VAREL
        NERR=12
        DO J=1,JJ
          WRITE(19,*,ERR=998) (VAREL(I,J),I=1,II)
        END DO

! ....   KEL = 2 ....................................
! ***** RKEL
        NERR=13
        WRITE(19,*,ERR=998)(RKEL(K),K=1,KK)
! ....   KEL = 3 ....................................
! ***** EL
        NERR=14
        DO K=1,KK
          DO J=1,JJ
           WRITE(19,*,ERR=998)(EL(I,J,K),I=1,II)
          END DO
        END DO
! ***** ESTABLISH POROSITY (PHI) DISTRIBUTION
        NERR=15
        WRITE(19,*,ERR=998)(RPHL(K),K=1,KK)
! ***** ESTABLISH PERMEABILITY (RKXL) DISTRIBUTION
        NERR=16
        WRITE(19,*,ERR=998)(RKXL(K),K=1,KK)
! ***** ESTABLISH PERMEABILITY (RKYL) DISTRIBUTION
        NERR=17
        WRITE(19,*,ERR=998)(RKYL(K),K=1,KK)
! ***** ESTABLISH PERMEABILITY (RKZL) DISTRIBUTION
        NERR=18
        WRITE(19,*,ERR=998)(RKZL(K),K=1,KK)
! ***** ESTABLISH POROSITY (VP) DISTRIBUTION
        NERR=19
        DO K=1,KK
          DO J=1,JJ
           WRITE(19,*,ERR=998)(VP(I,J,K),I=1,II)
          END DO
        END DO
! ***** ESTABLISH PERMEABILITY (KX) DISTRIBUTION
        NERR=20
        DO K=1,KK
          DO J=1,JJ
           WRITE(19,*,ERR=998)(KX(I,J,K),I=1,II)
          END DO
        END DO
! ***** ESTABLISH PERMEABILITY (KY) DISTRIBUTION
        NERR=21
        DO K=1,KK
          DO J=1,JJ
            WRITE(19,*,ERR=998)(KY(I,J,K),I=1,II)
          END DO
        END DO
! ***** ESTABLISH PERMEABILITY (KZ) DISTRIBUTION
        NERR=22
        DO K=1,KK
          DO J=1,JJ
            WRITE(19,*,ERR=998)(KZ(I,J,K),I=1,II)
          END DO
        END DO
!      ***** ROCK REGION DISTRIBUTION *****
! ***** IROCK
        NERR=23
        DO K=1,KK
          DO J=1,JJ
            WRITE(19,*,ERR=998) (IROCK(I,J,K),I=1,II)
          END DO
        END DO
!     ***** PVT REGION DISTRIBUTION *****
! ***** IPVT
          NERR=24
          DO K=1,KK
           DO J=1,JJ
            WRITE(19,*,ERR=998) (IPVT(I,J,K),I=1,II)
            END DO
          END DO

!      IERR=22
!      WRITE(19) PBOT

!  .... KSI=1 ====> Write So by grid-block
! ***** SO
        NERR=25
        DO K=1,KK
          DO J=1,JJ
            WRITE(19,*,ERR=998) (SO(I,J,K),I=1,II)
          END DO
        END DO
!  .... KSI=1 ====> Write Sw by grid-block
! ***** SW
        NERR=26
        DO K=1,KK
          DO J=1,JJ
            WRITE(19,*,ERR=998) (SW(I,J,K),I=1,II)
          END DO
        END DO
!  ....   Write initial pressures by grid-block
! ***** PN
         NERR=27
         DO K=1,KK
           DO J=1,JJ
             WRITE(19,*,ERR=998) (PN(I,J,K),I=1,II)
           END DO
         END DO
! ***** LRCK,PIL,SOIL,SWIL,SGIL
      NERR=28
      DO K=1,KK
        WRITE(19,'(I4,2X,F8.1,2X,3(F5.3,2X),A)',ERR=998) LRCK(K),
     &            PIL(LRCK(K)), SOIL(LRCK(K)),
     &           SWIL(LRCK(K)), SGIL(LRCK(K)),'   [Pi  Soi  Swi  Sgi]'
      END DO
! ***** PID,PWF
      NERR=29
      DO NRECURR=1,NDATASET
       DO J=1,NWELLN(NRECURR)
        I1=I1NEW(J,NRECURR)
        I1=IDWELL(I1,NRECURR)
        IQ3=IQN3(I1,NRECURR)
        LAY=IQ3+(LAYER(I1,NRECURR)-1)
        NERR=30
        WRITE(19,*) (PID(I1,K,NRECURR),K=IQ3,LAY)
        NERR=31
        WRITE(19,*) (PWF(I1,K,NRECURR),K=IQ3,LAY)
       END DO
      END DO
!      CALL AboutB4(1,'Final PID & PWF written to BN98.TXT',
!     &     'Alert (BN98OUT)')
      RETURN
998   WRITE(BUFFER,*,ERR=999) 'BN98OUT Error Number ',NERR
      CALL AboutB4(1,TRIM(BUFFER),'Error alert')
      RETURN
999   WRITE(BUFFER,*) 'Internal write error ',NERR
      CALL AboutB4(1,TRIM(BUFFER),'Error alert')
      RETURN
      END

!     BN98IN.FOR
!
      SUBROUTINE BN98IN(IOLD,JOLD,KOLD,
     &     DX,DY,DZ,DZNET,RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,
     &     EL,RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,IROCK,IPVT,
     &     PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF,
     &     NDATASET)
      INCLUDE 'BAEDPARM.INC'
      INCLUDE 'BED.INC'
      INCLUDE 'GRIDA.INC'
      INCLUDE 'PORPRA.INC'
      INCLUDE 'TABLEA.INC'
      INCLUDE 'UINITA.INC'
      INCLUDE 'NODESA.INC'
      CHARACTER*80 BUFFER
      LOGICAL ALLOCATED
      ALLOCATABLE :: TEMP1(:,:,:),TEMP2(:,:),
     &  TEMP3(:),TEMP4(:),TEMP5(:),ITEMP1(:,:,:),ITEMP2(:),
     &  TEMP6(:,:,:),TEMP7(:),TEMP8(:),TEMP9(:)
C  File is still open so rewind it for reading back arrays
      REWIND (19)
C   Rows, Columns, and Layers
      NERR=2
      READ(19,'(3(1X,I4))',ERR=998) IOLD,JOLD,KOLD
!  Re-allocate the above according to old grid size.
      IF (ALLOCATED( TEMP1 )) THEN
        DEALLOCATE ( TEMP1 )
      END IF
      ALLOCATE ( TEMP1(IOLD,JOLD,KOLD) )
      IF (ALLOCATED( TEMP2 )) THEN
        DEALLOCATE ( TEMP2 )
      END IF
      ALLOCATE ( TEMP2(IOLD,JOLD) )
      IF (ALLOCATED( TEMP3 )) THEN
        DEALLOCATE ( TEMP3 )
      END IF
      ALLOCATE ( TEMP3(IOLD) )
      IF (ALLOCATED( TEMP4 )) THEN
        DEALLOCATE ( TEMP4 )
      END IF
      ALLOCATE ( TEMP4(JOLD) )
      IF (ALLOCATED( TEMP5 )) THEN
        DEALLOCATE ( TEMP5 )
      END IF
      ALLOCATE ( TEMP5(KOLD) )
      IF (ALLOCATED( ITEMP1 )) THEN
        DEALLOCATE ( ITEMP1 )
      END IF
      ALLOCATE ( ITEMP1(IOLD,JOLD,KOLD) )
      IF (ALLOCATED( ITEMP2 )) THEN
        DEALLOCATE ( ITEMP2 )
      END IF
      ALLOCATE ( ITEMP2(KOLD) )
      IF (ALLOCATED( TEMP6 )) THEN
        DEALLOCATE ( TEMP6 )
      END IF
      ALLOCATE ( TEMP6(LP11,KOLD,LP112) )
      IF (ALLOCATED( TEMP7 )) THEN
        DEALLOCATE ( TEMP7 )
      END IF
      ALLOCATE ( TEMP7(KOLD) )
      IF (ALLOCATED( TEMP8 )) THEN
        DEALLOCATE ( TEMP8 )
      END IF
      ALLOCATE ( TEMP8(KOLD) )
      IF (ALLOCATED( TEMP9 )) THEN
        DEALLOCATE ( TEMP9 )
      END IF
      ALLOCATE ( TEMP9(KOLD) )
!      WRITE(BUFFER,'(A4,I3,2(A5,I3),3(A5,I3))')
!     &       'LP1=', LP1,' LP2=', LP2,' LP3=', LP3,
!     &       ' IOLD=',IOLD,' JOLD=',JOLD,' KOLD=',KOLD
!      CALL AboutB4(1,BUFFER,'Grid size information (BN98IN)')
C  Use the smallest loop size for fitting into smaller arrays
      IF (IOLD.LT.LP1) THEN
        IT=IOLD
      ELSE
        IT=LP1
      END IF
      IF (JOLD.LT.LP2) THEN
        JT=JOLD
      ELSE
        JT=LP2
      END IF
      IF (KOLD.LT.LP3) THEN
        KT=KOLD
      ELSE
        KT=LP3
      END IF
!  zero the newly allocated temporary arrays
      DO K=1,KOLD
        DO L=1,LP11
          DO L2=1,LP112
            TEMP6(L,K,L2)=0.0
          END DO
        END DO
        ITEMP2(K)=0
        TEMP5(K)=0.0
        TEMP7(K)=0.0
        TEMP8(K)=0.0
        TEMP9(K)=0.0
        DO J=1,JOLD
          DO I=1,IOLD
            TEMP1(I,J,K)=0.0
            ITEMP1(I,J,K)=0
          END DO
        END DO
      END DO
      DO J=1,JOLD
        TEMP4(J)=0.0
        DO I=1,IOLD
          TEMP2(I,J)=0.0
        END DO
      END DO
      DO I=1,IOLD
        TEMP3(I)=0.0
      END DO
!  zero the newly allocated fixed arrays (DX,KX,PN,etc)
      DO K=1,LP3
        DO L=1,LP11
          DO L2=1,LP112
            PID(L,K,L2)=0.0
            PWF(L,K,L2)=0.0
          END DO
        END DO
        LRCK(K)=0
        PIL(K)=0.0
        SOIL(K)=0.0
        SWIL(K)=0.0
        SGIL(K)=0.0
        RDZL(K)=0.0
        RDZNET(K)=0.0
        ZT(K)=0.0
        RKEL(K)=0.0
        RPHL(K)=0.0
        RKXL(K)=0.0
        RKYL(K)=0.0
        RKZL(K)=0.0
        DO J=1,LP2
          DO I=1,LP1
            DX(I,J,K)=0.0
            DY(I,J,K)=0.0
            DZ(I,J,K)=0.0
            DZNET(I,J,K)=0.0
            EL(I,J,K)=0.0
            VP(I,J,K)=0.0
            KX(I,J,K)=0.0
            KY(I,J,K)=0.0
            KZ(I,J,K)=0.0
            IROCK(I,J,K)=0
            IPVT(I,J,K)=0
            SO(I,J,K)=0.0
            SW(I,J,K)=0.0
            PN(I,J,K)=0.0
          END DO
        END DO
      END DO
      DO J=1,LP2
        RDYL(J)=0.0
        DO I=1,LP1
!          DX(I,J)=0
!          DY(I,J)=0
          VAREL(I,J)=0
        END DO
      END DO
      DO I=1,LP1
        RDXL(I)=0.0
      END DO
! ***** GRID BLOCK LENGTH (DX) DISTRIBUTION
        NERR=3
        K=1
        DO J=1,JOLD
          READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
        END DO
!        CALL AboutB4(1,'TEMP1 to DX','Alert (BN98IN)')
        DO J=1,JT
          DO I=1,IT
            DX(I,J,K)=TEMP1(I,J,K)
          END DO
        END DO
!      CALL AboutB4(1,'DX read back','Alert (BN98IN)')
! *****  GRID BLOCK LENGTH (DY) DISTRIBUTION
        NERR=4
        K=1
        DO J=1,JOLD
          READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
        END DO
!        CALL AboutB4(1,'TEMP1 to DY','Alert (BN98IN)')
        DO J=1,JT
          DO I=1,IT
            DY(I,J,K)=TEMP1(I,J,K)
          END DO
        END DO
!      CALL AboutB4(1,'DY read back','Alert (BN98IN)')
! ***** ESTABLISH GRID BLOCK LENGTH (DZ) DISTRIBUTION
        NERR=5
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
!        CALL AboutB4(1,'TEMP1 to DZ','Alert (BN98IN)')
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              DZ(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
!      CALL AboutB4(1,'DZ read back','Alert (BN98IN)')
! *****  GRID BLOCK NET THICKNESS (DZNET) DISTRIBUTION
        NERR=6
        DO K=1,KOLD
         DO J=1,JOLD
          READ(19,*,ERR=998) (TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
      DO K=1,KT
        DO J=1,JT
          DO I=1,IT
            DZNET(I,J,K)=TEMP1(I,J,K)
          END DO
        END DO
      END DO
!      CALL AboutB4(1,'DZNET read back','Alert (BN98IN)')
! *****  RDXL
        NERR=7
        READ(19,*,ERR=998)(TEMP3(I),I=1,IOLD)
      DO I=1,IT
        RDXL(I)=TEMP3(I)
      END DO
! *****  RDYL
        NERR=8
        READ(19,*,ERR=998)(TEMP4(J),J=1,JOLD)
      DO J=1,JT
        RDYL(J)=TEMP4(J)
      END DO
! *****  RDZL
        NERR=9
        READ(19,*,ERR=998)(TEMP5(K),K=1,KOLD)
      DO K=1,KT
        RDZL(K)=TEMP5(K)
      END DO
! *****  GRID BLOCK NET THICKNESS (DZNET) DISTRIBUTION
        NERR=10
        READ(19,*,ERR=998) (TEMP5(K),K=1,KOLD)
      DO K=1,KT
        RDZNET(K)=TEMP5(K)
      END DO
! *****  Establish node mid-point elevations...............
! *****  NOTE:  IF KEL = -2  -- non-contiguous layers, ZT's are read in
! *****  KEL = -2 ....................................
! ***** ZT
        NERR=11
        READ(19,*,ERR=998) (TEMP5(K),K=1,KOLD)
      DO K=1,KT
        ZT(K)=TEMP5(K)
      END DO
! *****  KEL =  1, 2, 3 options - not altered !
! *****  KEL = 1 ....................................
! ***** VAREL
        NERR=12
        DO J=1,JOLD
          READ(19,*,ERR=998) (TEMP2(I,J),I=1,IOLD)
        END DO
      DO I=1,IT
        DO J=1,JT
          VAREL(I,J)=TEMP2(I,J)
        END DO
      END DO
! *****  KEL = 2 ....................................
! ***** RKEL
        NERR=13
        READ(19,*,ERR=998)(TEMP5(K),K=1,KOLD)
      DO K=1,KT
          RKEL(K)=TEMP5(K)
      END DO
! *****  KEL = 3 ....................................
! ***** EL
        NERR=14
        DO K=1,KOLD
          DO J=1,JOLD
           READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
      DO K=1,KT
        DO J=1,JT
          DO I=1,IT
            EL(I,J,K)=TEMP1(I,J,K)
          END DO
        END DO
      END DO
!      CALL AboutB4(1,'EL read back','Alert (BN98IN)')
! *****  ESTABLISH POROSITY (PHI) DISTRIBUTION
! ***** RPHL
        NERR=15
        READ(19,*,ERR=998)(TEMP5(K),K=1,KOLD)
      DO K=1,KT
          RPHL(K)=TEMP5(K)
      END DO
! *****  ESTABLISH PERMEABILITY (RKXL) DISTRIBUTION
        NERR=16
        READ(19,*,ERR=998)(TEMP5(K),K=1,KOLD)
      DO K=1,KT
          RKXL(K)=TEMP5(K)
      END DO
! *****  ESTABLISH PERMEABILITY (RKYL) DISTRIBUTION
        NERR=17
        READ(19,*,ERR=998)(TEMP5(K),K=1,KOLD)
      DO K=1,KT
          RKYL(K)=TEMP5(K)
      END DO
! *****  ESTABLISH PERMEABILITY (RKZL) DISTRIBUTION
        NERR=18
        READ(19,*,ERR=998)(TEMP5(K),K=1,KOLD)
      DO K=1,KT
          RKZL(K)=TEMP5(K)
      END DO
! *****  ESTABLISH POROSITY (VP) DISTRIBUTION
        NERR=19
        DO K=1,KOLD
          DO J=1,JOLD
           READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              VP(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
!      CALL AboutB4(1,'VP read back','Alert (BN98IN)')
! *****  ESTABLISH PERMEABILITY (KX) DISTRIBUTION
        NERR=20
        DO K=1,KOLD
          DO J=1,JOLD
           READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              KX(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
! *****  ESTABLISH PERMEABILITY (KY) DISTRIBUTION
        NERR=21
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              KY(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
! *****  ESTABLISH PERMEABILITY (KZ) DISTRIBUTION
        NERR=22
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998)(TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              KZ(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
!      ***** ROCK REGION DISTRIBUTION *****
! ***** IROCK
        NERR=23
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998) (ITEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              IROCK(I,J,K)=ITEMP1(I,J,K)
            END DO
          END DO
        END DO
!     ***** PVT REGION DISTRIBUTION *****
! ***** IPVT
        NERR=24
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998) (ITEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              IPVT(I,J,K)=ITEMP1(I,J,K)
            END DO
          END DO
        END DO
!      CALL AboutB4(1,'IPVT read back','Alert (BN98IN)')

!  PBOT not needed?
!      READ(19) TEMP1
!      DO K=1,KT
!        DO J=1,JT
!          DO I=1,IT
!            PBOT(I,J,K)=TEMP1(I,J,K)
!          END DO
!        END DO
!      END DO

!  .... KSI=1 ====> Write So by grid-block
! ***** SO
        NERR=25
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998) (TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              SO(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
!  .... KSI=1 ====> Write Sw by grid-block
! ***** SW
        NERR=26
        DO K=1,KOLD
          DO J=1,JOLD
            READ(19,*,ERR=998) (TEMP1(I,J,K),I=1,IOLD)
          END DO
        END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              SW(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
!      CALL AboutB4(1,'SW read back','Alert (BN98IN)')

!....   Write initial pressures by grid-block
! ***** PN
         NERR=27
         DO K=1,KOLD
           DO J=1,JOLD
             READ(19,*,ERR=998) (TEMP1(I,J,K),I=1,IOLD)
           END DO
         END DO
        DO K=1,KT
          DO J=1,JT
            DO I=1,IT
              PN(I,J,K)=TEMP1(I,J,K)
            END DO
          END DO
        END DO
!      CALL AboutB4(1,'PN read back','Alert (BN98IN)')
!  LRCK,PIL,SOIL,SWIL,SGIL
      NERR=28
      DO K=1,KOLD
        READ(19,'(I4,2X,F8.1,2X,3(F5.3,2X),A)',ERR=998) ITEMP2(K),
     &            TEMP5(ITEMP2(K)), TEMP7(ITEMP2(K)),
     &           TEMP8(ITEMP2(K)), TEMP9(ITEMP2(K))
      END DO
      DO K=1,KT
        LRCK(K)=ITEMP2(K)
        PIL(K) =TEMP5(K)
        SOIL(K)=TEMP7(K)
        SWIL(K)=TEMP8(K)
        SGIL(K)=TEMP9(K)
      END DO
! ***** RECURR **** Recurrent data for PID & PWF in new wells only!
!      WRITE(BUFFER,'(A20,I4)') 'Number data sets is ',NDATASET
!      CALL AboutB4(1,BUFFER,'Debug (BN98IN)')
      NERR=29
      DO NRECURR=1,NDATASET
       DO J=1,NWELLN(NRECURR)
        I1=I1NEW(J,NRECURR)
        I1=IDWELL(I1,NRECURR)
        IQ3=IQN3(I1,NRECURR)
!  New for PID & PWF grid adjustments for completed layers in a smaller number of KK
        IF (IQ3.GT.KT) THEN
          CALL AboutB4(1,'PID and PWF data may be lost!','Warning!')
        END IF
        LAY=IQ3+(LAYER(I1,NRECURR)-1)
        IF (LAY.GT.KT) THEN
          KLAY=KT
!  Fix for loss of PID and PWF when changing grid size.
        ELSE   !  this KLAY is set where it had been 0 before, if KT increased.
          KLAY=LAY
        END IF
        NERR=30
        READ(19,*) (TEMP6(I1,K,NRECURR),K=IQ3,LAY)
        DO K=IQ3,KLAY
          PID(I1,K,NRECURR)=TEMP6(I1,K,NRECURR)
        END DO
        NERR=31
        READ(19,*) (TEMP6(I1,K,NRECURR),K=IQ3,LAY)
        DO K=IQ3,KLAY
          PWF(I1,K,NRECURR)=TEMP6(I1,K,NRECURR)
        END DO
       END DO
      END DO
!      CALL AboutB4(1,'PID & PWF read back','Alert (BN98IN)')
      CLOSE (19)
      RETURN
998   WRITE(BUFFER,*,ERR=999) 'BN98IN Error Number ',NERR
      CALL AboutB4(1,TRIM(BUFFER),'Error alert')
      RETURN
999   WRITE(BUFFER,*) 'Internal write error ',NERR
      CALL AboutB4(1,TRIM(BUFFER),'Error alert')
      RETURN
      END
