C     Last change:  RJH  20 Jan 99   10:45 am
C     BAREC.FOR
C
C*********************************************************************
C*                    Designed and written by                        *
C*                    Raymond J. Heemstra                            *
C*                    BDM-Oklahoma, Inc.                             *
C*                    Bartlesville, OK 74005                         *
C*********************************************************************
C
      SUBROUTINE BARECURR(NWELLDEF,ISET,WELLNAME,I1NEWOLD,IDNOWELL,
     &    IQN1,IQN2,IQN3,LAYER,KIP,QVO,QVW,QVG,QVT,PID,PWF,ALIT,BLIT,
     &    NEWOLD,WELNAM,NPW,IDWELX,LWX,LWY,LWZ,NWELLS)
!     &    NEWOLD)
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      INCLUDE 'BAEDPARM.INC'
      CHARACTER*8 WELNAM(NWX)
      INTEGER NPW(NWX),IDWELX(NWX,NODX)
      DIMENSION LWX(NWX,NODX),LWY(NWX,NODX),LWZ(NWX,NODX)
      CHARACTER*5 WELLNAME(LP11,LP112)
!      CHARACTER*5 WNAME
!      CHARACTER*5 LNAME,SNAME
      INTEGER I1NEWOLD(LP11,LP112),IDNOWELL(LP11,LP112),
     &  IQN1(LP11,LP112),IQN2(LP11,LP112),IQN3(LP11,LP112),
     &  LAYER(LP11,LP112),KIP(LP11,LP112)
      REAL QVO(LP11,LP112),QVW(LP11,LP112),
     &  QVG(LP11,LP112),QVT(LP11,LP112)
      REAL PID(LP11,LP3,LP112),PWF(LP11,LP3,LP112)
      REAL ALIT(LP11,LP112),BLIT(LP11,LP112)
      CHARACTER*5 VAR1NU
      INTEGER I1NU,I2NU,I3NU,I4NU,I5NU
      INTEGER BSIZE,PAGESIZE
      PARAMETER(BSIZE=8,IV=12,IP=16,MB=3)    ! for PID/PWF button field
      PARAMETER(MAXDESC=10)
      CHARACTER*66 DESCRIBE(MAXDESC+9)
      INTEGER KIPDESC(MAXDESC)
      LOGICAL DIALOG
      CHARACTER PAGENO*16
      CHARACTER*80 HEADER
      CHARACTER*3 NEWOLD
      CHARACTER*4 ADDKIP
      CHARACTER*80 TITLE
      PARAMETER (NBUFF=3)
      CHARACTER*80 BUFFER(NBUFF)
      CHARACTER*2 PIDPWF
      INTEGER ifx(IV*IP+MB+1),ify(IV*IP+MB+1),
     &        ifw(IV*IP+MB+1),ift(IV*IP+MB+1)
      CHARACTER*(BSIZE) BUTTON1,BUTTON2,BUTTON3
      DATA BUTTON1 /' ACCEPT '/,BUTTON2 /' CANCEL '/
      DATA BUTTON3 /'  Help  '/
      DATA DESCRIBE /
     & 'Production rate controlled well,      (specify one of 4 rates)',
     & 'Water rate controlled well,         (injection rate specified)',
     & 'Gas rate controlled well,           (injection rate specified)',
     & 'BHP controlled production well      (optional rate constraint)',
     & 'Water inject. well, BHP controlled  (optional rate constraint)',
     & 'Gas inject. well, BHP controlled    (optional rate constraint)',
     & 'Gas production well- LIT representation (explicit press. calc)',
     & 'Production well, PI and FBHP control (implicit pressure calc.)',
     & 'Water well, PI and FBHP control      (implicit pressure calc.)',
     & 'Gas well, PI and FBHP control        (implicit pressure calc.)',
     & '                       [ PID/PWF ]',
     & 'PID -- layer flow index for each layer for rates in STB/D     ',
     & 'PID=.00708*k*h/(ln 0.121*((Dx*Dy)**0.5)/rw+S) where h=net pay,',
     & ' k=perm., Dx=X-grid block, rw=well radius, S=layer skin factor',
     & 'PWF -- flowing bottom-hole pressure (BHP) for each layer, psia',
     & '        [ Well  ID  I  J  K  NL QVO  QVW  QVG  QVT ]',
     & 'Well= well name, ID= unique node number, I = columns, J = rows',
     & 'K=uppermost completion layer, NL=consecutive completion layers',
     &'QVO, QVW, QVG, & QVT =oil, water, gas, & total rate constraints'/
      DATA KIPDESC /  1,  2,  3, -1, -2, -3, -4, -11, -12, -13/
      DIALOG=.TRUE.
      NDIALOG=1
      PAGESIZE=IP
      LASTWELL=0
      NPIDPWF=0
      IZERO=0
      IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
        TITLE='Recurrent new well data'
        CALL CHECKIJK(NWELLS,WELNAM,NPW,IDWEL,
     &        IDWELX,LWX,LWY,LWZ,
     &      ISET,NWELLDEF,LASTWELL,I1NEWOLD,
     &     WELLNAME,IDNOWELL,IQN1,IQN2,IQN3,LAYER)

      ELSE
        TITLE='Recurrent old well data'
      END IF
      IFINIT=2
      DO WHILE(DIALOG)
        KEXIT=20
        WRITE(PAGENO,'(A4,I3,A6,I2,A1)') ' set',ISET,' (Page',
     &     NDIALOG,')'
        TITLE(24:39)=PAGENO
        ISPACE=1
        IFD=1
        IROW=1
        IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
          HEADER='Well  ID  I  J  K NL KIP     QVO'//
     &           '       QVW       QVG       QVT  PID/PWF'
        ELSE
          HEADER='Well  ID  KIP     QVO'//
     &           '       QVW       QVG       QVT'
        END IF
        NHWDTH=LEN_TRIM(HEADER)+2
        IF(NHWDTH.LE.74) NHWDTH=76      !  6+4*6+4*11+2=6+24+44+2
C   Header field definition
        ifx(IFD)=2
        ify(IFD)=IROW
        ifw(IFD)=LEN_TRIM(HEADER)
        ift(IFD)=1001
        IROW=IROW+ISPACE     !  space + header = 2 rows extra to fields
C  Well data field definitions (1 string, 6 or 2 integers, 4 reals, & 1 button)
        DO NW=LASTWELL+1,NWELLDEF
          IF(I1NEWOLD(NW,ISET).GT.IDMAX) IDMAX=I1NEWOLD(NW,ISET)
          IROW=IROW+1        ! new row
          IFD=IFD+1
          ICOL=2             ! begin in column 2
          ifx(IFD)=ICOL
          ify(IFD)=IROW
          ifw(IFD)=5
          ift(IFD)=1         ! string=1
          ICOL=ICOL+3        ! set up past A5-I3 for the
          IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
            NVI=6            !  6 integers -- ID, I,J, K, L, KIP
          ELSE
            NVI=2            !  2 integers -- ID, KIP
          END IF
          DO ND=1,NVI        ! 6 or 2 integers
            IFD=IFD+1
            ICOL=ICOL+3      ! 0 spaces beyond I3
            ifx(IFD)=ICOL
            ify(IFD)=IROW    ! same row
            ifw(IFD)=3       ! width=3
            ift(IFD)=2       ! integer=2
          END DO             ! end of DO ND
C   Real field definitions, 4 reals   -- QVO, QVW, QVG, QVT
          ICOL=ICOL+4        ! set up for the first of 4 reals
          DO NR=1,4          ! loop for 4 reals
            IFD=IFD+1
            ifx(IFD)=ICOL
            ify(IFD)=IROW   ! same row
            ifw(IFD)=10     ! real is F10.0
            ift(IFD)=3      !  real=3
            ICOL=ICOL+10    ! set up for the next real, 10 to conserve space
          END DO       ! end of DO NR
C   Do the PID/PWF input selection button in the same row
          IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
            ICOL=ICOL+1       ! set to 1 past the end of last real number
            IFD=IFD+1         ! one last field on this line
            ifx(IFD)=ICOL
            ify(IFD)=IROW     ! same row
            ifw(IFD)=2        ! a narrow 2 character button field, PIDPWF
            ift(IFD)=5        ! button=5
          END IF
          IF (IROW.GT.PAGESIZE) EXIT
        END DO         ! end of DO NW
C  Button field definition for MB buttons (ACCEPT, CANCEL, & KIP Help)
        IROW=IROW+ISPACE
        ICOL=((NHWDTH+10)/MB)-BSIZE-2
        DO IFDB=IFD+1,IFD+MB
          ifx(IFDB)=ICOL+(IFDB-IFD-1)*(BSIZE+2)
          ify(IFDB)=IROW+1
          ifw(IFDB)=BSIZE
          ift(IFDB)=5
        END DO
        IROW=IROW+1
        ILINES=IROW+1
        IFD=IFD+MB
C  Set control types and options for events, keys, mouse, & frames
        CALL InEventSelect(ResizeExpose,IntYes) ! ResizeExpose=6;IntYes=1
        CALL InControlKey(50,ResizeEvent)
        CALL InMouseOptions(MouseExit,IntYes)   ! MouseExit=2;IntYes=1
        CALL InControlKey(26,577)   ! Alt-A=577(accept);Alt-N=590(next)
        CALL InControlKey(27,579)   ! Alt-C=579(cancel); Alt-Q=593(quit)
        CALL InControlKey(29,129)   ! KeyCursorDown = 129
        CALL InControlKey(30,128)   ! KeyCursorUp   = 128
        CALL InSelectionChars(' ')
        call IFrameType(4)          ! DropShadow = 4; Window3D2 = 10
        call IFrameOptions(4,15)    ! TitleForeCol, TextWhiteBold
        call IFrameOptions(5,5)     ! TitleBackCol, TextBlue
        call IWinAction('FPC')
        call IGrInputOptions(4,1)   ! GINTerminate, GINAnyKey
        call InMouseOptions(102,3)  ! PopupButton,RightButton=3; LeftButton=1
        CALL InMouseOptions(MouseExit,IntYes)  !  MouseExit=2; IntNo=2
        call InHighLight('Black','yellow')
C  Now for the FormPut loop
        DO WHILE (KEXIT.NE.ControlConfirm)   ! ControlConfirm=21
          call IWinWordWrap('JUST')
          call IWinOpenTitle(IZERO,IZERO,NHWDTH,ILINES,TITLE)
C   Begin the form definitions
          CALL IFormDefine('W',IFD,ifx,ify,ifw,ift)
          call IFrameOptions(5,15)  ! TitleForeCol, TextWhiteBold
          call IFrameOptions(4,5)   ! TitleBackCol, TextBlue
C  Place the one string, six or two integers, and 4 reals
          IROW=1
          IFDB=1           !  reset to header field
          IROW=IROW+ISPACE

          IOFFSET=IROW    !  So row count minus offset will be
C                            a button count in the DO NW loop
          DO NW=LASTWELL+1,NWELLDEF
            I1=I1NEWOLD(NW,ISET)
            IF(I1.GT.0.AND.I1.LE.IDMAX) THEN
              I1=IDNOWELL(I1,ISET)
            ELSE
              I1NEWOLD(NW,ISET)=IDMAX+1          !  well node added
              I1=I1NEWOLD(NW,ISET)
              IDNOWELL(I1,ISET)=I1
              IDMAX=IDMAX+1
            END IF
            IROW=IROW+1
C  Report any discrepancy in node ID
            IF (I1NEWOLD(NW,ISET).NE.I1) THEN
              WRITE(BUFFER(1),'(A21,I2,A24,I2)')
     &            'I1NEWOLD(NW,ISET)=I1=',I1NEWOLD(NW,ISET),
     &          ', IDNOWELL(I1,ISET)=I1=',IDNOWELL(I1,ISET)
              WRITE(BUFFER(2),'(A3,I2,A5,I2,A12,A5)')'I1=',I1,
     &          ', NW=',NW,', WELL NAME=',WELLNAME(I1,ISET)
              WRITE(BUFFER(3),'(4(A4,I2))')
     &         '  I=',IQN1(I1,ISET),
     &         ', J=',IQN2(I1,ISET),
     &         ', K=',IQN3(I1,ISET),
     &         ', L=',LAYER(I1,ISET)
              CALL AboutB4(3,BUFFER,'Well ID Error!')
              IDNOWELL(I1NEWOLD(NW,ISET),ISET)=I1NEWOLD(NW,ISET)
c              WELLNAME(I1NEWOLD(NW,ISET),ISET)=WELNAM(1:5)(NW)
C              RETURN
            END IF
C  Place the well name
            IFDB=IFDB+1
            VAR1NU=WELLNAME(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutString(IFDB,VAR1NU)      ! WELNM
C  Place the node ID number
            IFDB=IFDB+1
            I1NU=IDNOWELL(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutInteger(IFDB,I1NU)     !  ID
C   Begin the new / old well discrimination tests
            IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
              IFDB=IFDB+1
              I2NU=IQN1(I1,ISET)
              CALL IFormAttribute(IFDB,' ','Black','BWhite')
              CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
              CALL IFormPutInteger(IFDB,I2NU)       !  I
              IFDB=IFDB+1
              I3NU=IQN2(I1,ISET)
              CALL IFormAttribute(IFDB,' ','Black','BWhite')
              CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
              CALL IFormPutInteger(IFDB,I3NU)         !  J
              IFDB=IFDB+1
              I4NU=IQN3(I1,ISET)
              CALL IFormAttribute(IFDB,' ','Black','BWhite')
              CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
              CALL IFormPutInteger(IFDB,I4NU)         !  K
              IFDB=IFDB+1
              I5NU=LAYER(I1,ISET)
              CALL IFormAttribute(IFDB,' ','Black','BWhite')
              CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
              CALL IFormPutInteger(IFDB,I5NU)         !  NL
              LAY=I4NU+I5NU-1
            END IF
C   From here on all variables of new and old are the same
            IFDB=IFDB+1            !  KIP
            KIP1=KIP(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutInteger(IFDB,KIP1)
            IFDB=IFDB+1            !  QVO
            QVO1=QVO(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutReal(IFDB,QVO1,'(F10.0)')
            IFDB=IFDB+1            !  QVW
            QVW1=QVW(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutReal(IFDB,QVW1,'(F10.0)')
            IFDB=IFDB+1            !  QVG
            QVG1=QVG(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutReal(IFDB,QVG1,'(F10.0)')
            IFDB=IFDB+1            !  QVT
            QVT1=QVT(I1,ISET)
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutReal(IFDB,QVT1,'(F10.0)')
C   Do last button field put for PID/PWF arrays
            IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
C  Pass the I1NU value from the button field position, each must be unique!
              IFDB=IFDB+1
              WRITE(PIDPWF,'(I2)') I1
              IBUTTON=IFDB-11*(IROW-2)-1
C************DEBUG****************
C              WRITE(BUFFER(1),'(A,I4)') 'IFDB    = ',IFDB
C              WRITE(BUFFER(2),'(A,I4)') 'I1      = ',I1
C              WRITE(BUFFER(3),'(A,I4)') 'IROW    = ',IROW
C              WRITE(BUFFER(4),'(A,I4)') 'IBUTTON = ',IBUTTON
C                CALL AboutB4(4,BUFFER,'INFO')
C************DEBUG****************
              call IFormPutButton(IFDB,PIDPWF,IBUTTON)   ! PID/PWF selection=1 to 15
              call IFormAttribute(IFDB,' ','Black','White')
              call IFormFrame(IFDB,7,'BWhite','Black') ! Button3D1=7
            END IF       !  pick up the data entry in the InFormGet unit
C                           using the KEXIT code of 48 but what K, I1, ISET values?
C                           K is LAY, I1 & ISET are same as in KIP
            IF (IROW.GT.PAGESIZE) EXIT
          END DO           !   DO WELLS
          NBUTT=IROW-IOFFSET
C************DEBUG****************
C          IROWUSED=IROW
          call IFrameOptions(4,15)     ! TitleForeCol, TextWhiteBold
          call IFrameOptions(5,5)      ! TitleBackCol, TextBlue
C  ACCEPT
          call IFormPutButton(IFDB+1,BUTTON1,21)     ! ControlConfirm=21
          call IFormAttribute(IFDB+1,' ','Black','White')
          call IFormFrame(IFDB+1,7,'BWhite','Black') ! Button3D1=7
C  CANCEL
          call IFormPutButton(IFDB+2,BUTTON2,23)  ! ControlQuit=23
          call IFormAttribute(IFDB+2,' ','Black','White')
          call IFormFrame(IFDB+2,7,'BWhite','Black')
C  HELP
          call IFormPutButton(IFDB+3,BUTTON3,22)  ! ControlHelp=22
          call IFormAttribute(IFDB+3,' ','Black','White')
          call IFormFrame(IFDB+3,7,'BWhite','Black')
C   Place the heading on the first line
          CALL IFormPutString(1,TRIM(HEADER))
C   Declare a help field  This set of routines works, but only 200 fields
C   and 20,000 characters of data and strings allowed in form.
C   (see p. 2-66 under Forms Manager in INTERACTER Subroutine Reference)
C          call IFormHelp(1,1,65)
C          IROW=3
C          DO NW=LASTWELL+1,NWELLDEF
C            call IFormPutHelp( (NW-1)*IV+2,
C     &       'Each well name must be unique')
C            call IFormPutHelp( (NW-1)*IV+3,
C     &       'Each well node ID must be unique')
C            I1=I1NEWOLD(NW,ISET)
C            IF(I1.GT.0.AND.I1.LE.IDMAX) THEN
C              I1=IDNOWELL(I1,ISET)
C            ELSE
C              I1=1
C            END IF
C            call IFormPutHelp(IFDSCR(I1),DESCRIBE(IDESCR(I1)))
C            IROW=IROW+1
C            IF (IROW.GT.PAGESIZE) EXIT
C          END DO
          CALL InPopUp('on')
          CALL InMouseOptions(MouseExit,IntYes)
! ~~~~~~~~  Show everthing in forms for BARECURR ~~~~~~~~~~~~~~~
          call IFormShow
! ~~~~~~~~  Edit the forms and use buttons ~~~~~~~~
          call IFormEdit(IFINIT,IFEXIT)
!  check mouse or key
          KEXIT=InfoInput(55)          ! LastExitKey=55; LastGINExit=57
          CALL InPopUp('off')
          CALL InMouseOptions(MouseExit,IntNo)

          IF (KEXIT.GE.1.AND.KEXIT.LE.NBUTT) THEN
            NPIDPWF=KEXIT
          ELSE
            NPIDPWF=0
          END IF
C************DEBUG****************
C          IF (InfoInput(ExitMouseButton).eq.LeftButton) THEN
C            WRITE(BUFFER(1),*) 'KEXIT=',KEXIT
C            WRITE(BUFFER(2),*) 'NPIDPWF=',NPIDPWF
C            WRITE(BUFFER(3),*) 'NBUTT  =',NBUTT
C            call AboutB4(3,BUFFER,'Debug')
C          END IF
C************DEBUG****************
          IF(KEXIT.EQ.ControlQuit) THEN               !  CANCEL button
            KEXIT=ControlConfirm
            DIALOG=.false.
            EXIT
C  Was the help button pushed?
          ELSE IF(KEXIT.EQ.ControlHelp) THEN
            DO K=1,MAXDESC
              WRITE(ADDKIP,'(A1,I3)')'=',KIPDESC(K)
              DESCRIBE(K)(63:66)=ADDKIP
            END DO
            CALL AboutB4(MAXDESC+9,DESCRIBE,
     &       'Help on meaning of KIP')
            KEXIT=20
            IROW=1
            IFINIT=IFEXIT
            CALL IWinClose(1)
            CALL IScreenBackground('blue','blue')
C  The right column of buttons have a selection and must determine which I1
          ELSE IF ((NPIDPWF.GE.1.AND.NPIDPWF.LE.NBUTT).AND.        ! 1 to 15
     &            (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new')) THEN
            KEXIT=20
C   Begin the process of accepting the input data of the well selected
C   by the PID/PWF button to the right.
            IFD=(NPIDPWF-1)*12+2
            CALL IFormGetString(IFD,VAR1NU)    ! Get well name
            IFD=IFD+1
            CALL IFormGetInteger(IFD,I1NU)     ! Get node ID
c            NEWIDNUM=I1NU
            I1NEWOLD(NPIDPWF+LASTWELL,ISET)=I1NU    !  I1NEWOLD(NW,ISET)
            WELLNAME(I1NU,ISET)=VAR1NU         !  Place well name in node position
            IDNOWELL(I1NU,ISET)=I1NU           !  Place node ID
            IFD=IFD+1
            CALL IFormGetInteger(IFD,I2NU)     !  Get I position of well
            IQN1(I1NU,ISET)=I2NU
            IFD=IFD+1
            CALL IFormGetInteger(IFD,I3NU)     !  Get J position of well
            IQN2(I1NU,ISET)=I3NU
            IFD=IFD+1
            CALL IFormGetInteger(IFD,I4NU)     !  Get K position of well
            IQN3(I1NU,ISET)=I4NU
            IFD=IFD+1
            CALL IFormGetInteger(IFD,I5NU)     !  Get completion layers of well
            LAYER(I1NU,ISET)=I5NU
            IFD=IFD+1
            CALL IFormGetInteger(IFD,KIP1)     !  Get KIP value of well
            KIP(I1NU,ISET)=KIP1
            IFD=IFD+1
            CALL IFormGetReal(IFD,QVO1)
            QVO(I1NU,ISET)=QVO1
            IFD=IFD+1
            CALL IFormGetReal(IFD,QVW1)
            QVW(I1NU,ISET)=QVW1
            IFD=IFD+1
            CALL IFormGetReal(IFD,QVG1)
            QVG(I1NU,ISET)=QVG1
            IFD=IFD+1
            CALL IFormGetReal(IFD,QVT1)
            QVT(I1NU,ISET)=QVT1

C************DEBUG****************
C  Commented out 6/18/97 temporarily to check bottom button problem
C            IF (NPIDPWF.EQ.NBUTT) THEN
C              LASTWELL=NPIDPWF+LASTWELL
C              NDIALOG=NDIALOG+1
C              KEXIT=ControlConfirm
C              IFINIT=2
C              IF (LASTWELL.LT.NWELLDEF) THEN
C                DIALOG=.TRUE.
C              ELSE IF(NBUTT.EQ.1.OR.NBUTT.EQ.NWELLDEF) THEN
C                LASTWELL=0
C                NDIALOG=NDIALOG-1
C              ELSE
C                DIALOG=.FALSE.
C              END IF  !  Note:  4/17/98
C            END IF    !  commenting this out must have solved bottom button problem
C************DEBUG****************
            IFD=IFD+1
C   End of well line acceptance code
            CALL IScreenBackground('blue','blue')
            CALL IWinClose(1)
            DO I=1,NBUFF
              BUFFER(I)=' '
            END DO

            IB1=I1NEWOLD(LASTWELL+NPIDPWF,ISET)
            INODE=IDNOWELL(IB1,ISET)
C************DEBUG****************
C            WRITE(BUFFER(1),*) 'Field no. (IFD) = ',NEWIFD
C            WRITE(BUFFER(2),*) 'Well ID         = ',NEWIDNUM
C            WRITE(BUFFER(3),*) 'Well Name       = ',VAR1NU
C            WRITE(BUFFER(4),*) 'IFD=(NPIDPWF-1)*12+2'
C            WRITE(BUFFER(5),*) 'NPIDPWF         = ',NPIDPWF
C            WRITE(BUFFER(6),*) 'No. PID/PWF buttons= ', NBUTT
C            WRITE(BUFFER(7),*) 'IROW USED       = ',IROWUSED
C            WRITE(BUFFER(8),*) 'IOFFSET         = ',IOFFSET
C            WRITE(BUFFER(9),*) 'LASTWELL=',LASTWELL
C            WRITE(BUFFER(10),*) 'ISET=',ISET
C            WRITE(BUFFER(11),*) 'IB1=',IB1
C            IF(IB1.LE.0)IB1=1
C            WRITE(BUFFER(12),*) 'INODE=IDNOWELL(IB1/1,ISET)',
C     &          IDNOWELL(IB1,ISET)
C            CALL AboutB4(12,BUFFER,'Debug')
C************DEBUG****************
C            WRITE(BUFFER(1),*) 'NPIDPWF=',NPIDPWF
C            WRITE(BUFFER(2),*) 'ISET=',ISET
C            WRITE(BUFFER(3),*) 'IB1=',IB1
C            IF(IB1.LE.0)IB1=1
C            WRITE(BUFFER(4),*) 'INODE=IDNOWELL(IB1=1,ISET)',
C     &          IDNOWELL(IB1,ISET)
C            CALL AboutB4(4,BUFFER,'Debug1')
C************DEBUG****************

            IQ3=IQN3(INODE,ISET)

C************DEBUG****************
C            CALL AboutB4(1,'IQ3=IQN3(IB1)','Debug2')
C************DEBUG****************

            LAY=IQ3+LAYER(INODE,ISET)-1

C************DEBUG****************
C            WRITE(BUFFER(1),'(3(A,I4))')'LASTWELL=',LASTWELL,
C     &      ' NPIDPWF=',NPIDPWF,' ISET=',ISET
C            WRITE(BUFFER(2),'(A,I4)')'I1NEWOLD(LASTWELL+NPIDPWF,ISET)=',
C     &              I1NEWOLD(LASTWELL+NPIDPWF,ISET)
C            WRITE(BUFFER(3),'(3(A,I4))') 'IB1=',IB1,' IQ3=',IQ3,
C     &        ' LAY=',LAY
C            call AboutB4(3,BUFFER,'CALLING B4PIDPWF')
C************DEBUG****************

            CALL B4PIDPWF(INODE,IQ3,LAY,ISET,PID,PWF,KIP1,ALIT,BLIT)
            IROW=1
C   Initial cursor to field number of next well after PID/PWF exit key
            IFINIT=(NPIDPWF-1)*12+14
            KEXIT=ControlConfirm
            EXIT
          ELSE IF(KEXIT.EQ.50) THEN                   !  Resize event
            KEXIT=20
            CALL IWinClose(1)
            CALL IScreenBackground('blue','blue')
            IROW=1
            IFINIT=IFEXIT
          ELSE IF(KEXIT.EQ.ControlConfirm) THEN       !  ACCEPT button
C   Get the string and integers
            IFDB=1
            IROW=2
            DO NW=LASTWELL+1,NWELLDEF
              I1GET=I1NEWOLD(NW,ISET)
              IF ( I1GET.NE.IDNOWELL(I1GET,ISET) ) THEN
                WRITE(BUFFER(1),'(A18,I3)') 'IDNEWOLD(NW,ISET)=',
     &              I1NEWOLD(NW,ISET)
                WRITE(BUFFER(2),'(A21,I3)') 'IDNOWELL(I1GET,ISET)=',
     &              IDNOWELL(I1GET,ISET)
                WRITE(BUFFER(3),'(A3,I3,A6,I3,A10,A5)') 'NW=',NW,
     &           ' ISET=',ISET,' WELLNAME=',WELLNAME(I1GET,ISET)
                CALL AboutB4(3,BUFFER,'Well ID Error!')
                RETURN
              END IF
              IROW=IROW+1
              IFDB=IFDB+1
              call IFormGetString(IFDB,VAR1NU)      ! Get well name
              IFDB=IFDB+1
              call IFormGetInteger(IFDB,I1NU)       ! Get node ID
              I1NEWOLD(NW,ISET)=I1NU
              WELLNAME(I1NU,ISET)=VAR1NU
              IDNOWELL(I1NU,ISET)=I1NU               !  ID
C   Begin the new / old well discrimination tests
              IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') THEN
                IFDB=IFDB+1
                call IFormGetInteger(IFDB,I2NU)      !  Get I position of well
                IQN1(I1NU,ISET)=I2NU                 !  I
                IFDB=IFDB+1
                call IFormGetInteger(IFDB,I3NU)      !  Get J position of well
                IQN2(I1NU,ISET)=I3NU                 !  J
                IFDB=IFDB+1
                call IFormGetInteger(IFDB,I4NU)      !  Get K position of well
                IQN3(I1NU,ISET)=I4NU                 !  K
                IFDB=IFDB+1
                call IFormGetInteger(IFDB,I5NU)      !  Get completion layers of well
                LAYER(I1NU,ISET)=I5NU                !  NL
              END IF
C   New and old the same below for KIP, QVO, QVW, QVG, & QVT
              IFDB=IFDB+1
              call IFormGetInteger(IFDB,KIP(I1NU,ISET))  !  Get KIP value of well
              IFDB=IFDB+1
              call IFormGetReal(IFDB,QVO(I1NU,ISET))
              IFDB=IFDB+1
              call IFormGetReal(IFDB,QVW(I1NU,ISET))
              IFDB=IFDB+1
              call IFormGetReal(IFDB,QVG(I1NU,ISET))
              IFDB=IFDB+1
              call IFormGetReal(IFDB,QVT(I1NU,ISET))
C    Increment the IFDB for the extra button on the right end
              IF (NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new') IFDB=IFDB+1
!  **************************************************************************
C    Replace variables with new input
              IFINIT=2
              IF (IROW.GT.PAGESIZE) THEN
                NDIALOG=NDIALOG+1
                LASTWELL=NW                   !   Set the last well number
                KEXIT=ControlConfirm
                IF (LASTWELL.LT.NWELLDEF) THEN
                  DIALOG=.true.
                ELSE
                  DIALOG=.false.
                END IF
                EXIT
              ELSE
                DIALOG=.false.
C************DEBUG****************
C                CALL IWinClose(1)
C                CALL IScreenBackground('blue','blue')
C                WRITE(BUFFER(1),'(2(A,I3))') 'IROW=',IROW,' I1NU=',I1NU
C                WRITE(BUFFER(2),'(2(A,I3))') 'NW=',NW,' I1GET=',I1GET
C                WRITE(BUFFER(3),'(2(A,I3))') 'I1ID=',I1ID,'IFDB=',IFDB
C                CALL AboutB4(3,BUFFER,'note')
C************DEBUG****************
              END IF
            END DO              ! End of DO WELLS

C****************** BEGIN I,J,K DEBUG *******************************
!            IF (KEXIT.EQ.ControlConfirm) THEN
!  **************  Check out the I,J,K values for each new well name ************
!              DO NW=1,NWELLDEF
!                IF ((NEWOLD.EQ.'NEW'.OR.NEWOLD.EQ.'new').AND.
!     &             WELLNAME(I1GET,ISET).NE.'        ') THEN
!     &                       WELNAM(NW).NE.'        ') THEN
!                  DO KB=1,12
!                    BUFFER=' '
!                  END DO
!  From the unique well node number point of view
!                  I1GET=I1NEWOLD(NW,ISET)
!        BUFFER 1
!                  IBFER=1
!                  WRITE(BUFFER(1),'(A3,I3,A25,I3,A10,I3)') 'NW=',NW,
!     &             ' I1NEWOLD(NW,ISET)=I1GET=',I1NEWOLD(NW,ISET),
!     &             ' NWELLDEF=',NWELLDEF
!        BUFFER 2
!                  IBFER=2
!                  WRITE(BUFFER(2),'(A45,A5,3X,I4,I4,I4)',ERR=111)
!     &             'WELLNAME(I1GET,ISET), IQN1,2,3(I1GET,ISET) = ',
!     &             WELLNAME(I1GET,ISET),IQN1(I1GET,ISET),
!     &             IQN2(I1GET,ISET),IQN3(I1GET,ISET)
!        BUFFER 3
!                  IBFER=3
!                  WRITE(BUFFER(3),'(A7,I3,A22,I3)') 'NWELLS=',NWELLS,
!     &            ' IDNOWELL(I1GET,ISET)=',IDNOWELL(I1GET,ISET)
!        BUFFER 4
!                  IBFER=4
!                  BUFFER(4)=' '
!        BUFFER 5
!                  IBFER=5
!                  WRITE(BUFFER(5),'(A10,I3,A22,A5,A14,I2,A6)',ERR=111)
!     &            'Well [NW]=',NW,'. Named [WELNAM(NW)]="',WELNAM(NW),
!     &            '" has NPW(NW)=',NPW(NW),' nodes'
!        BUFFERS 6
!                  IBFER=6
!                  WRITE(BUFFER(6),*)
!     &             'Node---Name---------I---J---K--------'
!        BUFFERS 6+MNOD
!                  WNAME=WELLNAME(I1GET,ISET)
!                  NODS=NPW(NW)
!                  IF (WNAME.EQ.WELNAM(NW)(1:5)) THEN
!  From the node spread sheet point of view (allows 15 nodes at a time)
!                    DO MNOD=1,NODS
!                      IBFER=6+MNOD
!                      WRITE(BUFFER(6+MNOD),
!     &                '(I3,A2,2X,A5,5X,I4,I4,I4)',
!     &                 ERR=111) MNOD,'. ',WELNAM(NW),
!     &                 LWX(NW,MNOD),LWY(NW,MNOD),LWZ(NW,MNOD)
!                    END DO
!                    CALL AboutB4(6+NODS,BUFFER,
!     &          'Matched   No.  WELLNAME  I  J  K  Set '//CHAR(48+ISET))
!                  ELSE
!        BUFFER 6+MNOD
!  From the well and well node point of view
!                    DO MNOD=1,NODS
!                      IBFER=6+MNOD
!                      WRITE(BUFFER(6+MNOD),
!     &                 '(I3,A2,2X,A5,5X,I4,I4,I4)',
!     &                 ERR=111) MNOD,'. ',WELNAM(NW),
!     &                 LWX(NW,MNOD),LWY(NW,MNOD),LWZ(NW,MNOD)
!                    END DO
!                    CALL AboutB4(6+NODS,BUFFER,
!     &         'Mismatch  No.  WELLNAME  I  J  K  Set '//CHAR(48+ISET))
!                  END IF
!                END IF
!                GO TO 112
!111             WRITE(BUFFER(1),*) 'BARECURR Internal write error ',
!     &            IBFER
!                CALL AboutB4(1,BUFFER,'Write Error')
!112             CONTINUE
!              END DO
!            END IF
C******************  END  I,J,K DEBUG *******************************

          ELSE
            CALL IScreenBell('2')
            KEXIT=20
C************DEBUG****************
C            CALL IScreenBackground('blue','blue')
C            CALL IWinClose(1)
C            WRITE(BUFFER(1),'(A,I5)') 'NPIDPWF=',NPIDPWF
C            WRITE(BUFFER(2),'(A,I2)') 'I1=',I1
C            WRITE(BUFFER(3),'(A,I2)') 'NBUTT=',NBUTT
C            call AboutB4(3,BUFFER,'Alert')
C            KEXIT=ControlConfirm
C************DEBUG****************
            IROW=1
            IFINIT=IFEXIT
          END IF
        END DO    !   end DO WHILE KEXIT
        CALL InMouseOptions(MouseExit,IntNo)     ! MouseExit=2;IntNo=0
        CALL IWinClose(3)
      END DO     !  end DO WHILE DIALOG is TRUE
      END SUBROUTINE

C     B4PIDPWF.FOR
C                    Designed by
C                    Raymond J. Heemstra
C
      SUBROUTINE B4PIDPWF(I1,IQ3,LAY,ISET,PID,PWF,KIP1,ALIT,BLIT)
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      INCLUDE 'BAEDPARM.INC'
      INTEGER BSIZE
!      PARAMETER(IPG=21,BSIZE=8)
      PARAMETER(IPG=25,BSIZE=8)
      DIMENSION PID(LP11,LP3,LP112),PWF(LP11,LP3,LP112)
      REAL ALIT(LP11,LP112),BLIT(LP11,LP112)
      CHARACTER*(BSIZE) BUTTON1,BUTTON2
      CHARACTER*80 TITLE,HEADER,HEADER2
      LOGICAL DIALOG
      CHARACTER PAGENO*25
      INTEGER NDIALOG
      INTEGER ifx(2*IPG+3),ify(2*IPG+3),
     &        ifw(2*IPG+3),ift(2*IPG+3)
      DATA BUTTON1 /' ACCEPT '/, BUTTON2 /' CANCEL '/
      DATA TITLE /'Recurrent well node'/
      DATA HEADER /'     Layer     PID        PWF'/
      DATA HEADER2 /'             ALIT        BLIT'/
      NHWDTH=LEN_TRIM(HEADER) + 6
C   Initialize some parameters
      DIALOG=.TRUE.
      NDIALOG=1
      IROW=1
      IFD=1
      ISPACE=1
      ISHIFT=6
      LAST=0
      IZERO=0
      DO WHILE (DIALOG)
        KEXIT=20
        WRITE(PAGENO,'(I3,A10,I3,A6,I2,A1)') I1,', data set',ISET,
     &   ' (Page',NDIALOG,')'
        TITLE(20:44)=PAGENO
        NHW=LEN_TRIM(TITLE)+2
        IF(NHWDTH.LT.NHW) NHWDTH=NHW
C   Header field definition
        ifx(IFD)=2+ISHIFT
        ify(IFD)=IROW
        ifw(IFD)=LEN_TRIM(HEADER)
        ift(IFD)=1001        !   protected string of header
        IROW=IROW+ISPACE     !  Space between header and data
C  Well field definitions of LAYER, PID, & PWF data by layer
        DO NLAY=LAST+IQ3,LAY
          IROW=IROW+1
          IFD=IFD+1
          ICOL=7+ISHIFT
          ifx(IFD)=ICOL
          ify(IFD)=IROW
          ifw(IFD)=4
          ift(IFD)=1002       !  protected layer integer
C  PID/PWF real numbers in same row
          ICOL=ICOL+6
          DO I=1,2
            IFD=IFD+1
            ifx(IFD)=ICOL
            ify(IFD)=IROW
            ifw(IFD)=10
            ift(IFD)=3        !  2 reals
            ICOL=ICOL+12      !  2 spaces between reals
          END DO
          IF(IROW.GT.IPG) EXIT
        END DO
!   Definitions for ALIT & BLIT  to be entered if KIP is -4
        IF (KIP1.EQ.-4) THEN
!    HEADER2 definitions
          IROW=IROW+ISPACE+1            ! next field and skip one space
          IFD=IFD+1
          ifx(IFD)=2+ISHIFT             ! same as first header
          ify(IFD)=IROW
          ifw(IFD)=LEN_TRIM(HEADER2)    ! length of string
          ift(IFD)=1001                 ! protected field

          IROW=IROW+ISPACE              ! skip a space again as with first header
          ICOL=ICOL-26                  ! backup 24 columns for 2 variables (E12)

          IROW=IROW+1                   !  next field
          DO I=1,2
            IFD=IFD+1
            ifx(IFD)=ICOL
            ify(IFD)=IROW
            ifw(IFD)=12                 !  for E12.5 field size
            ift(IFD)=3                  !  a REAL number
            ICOL=ICOL+13                !  (E12.5)
          END DO
        END IF
!   End of ALIT & BLIT definitions
C  Button field definition
        IROW=IROW+ISPACE
        ICOL=((NHWDTH+10)/2)-BSIZE-2
        DO IFDB=IFD+1,IFD+2
          ifx(IFDB)=ICOL+(IFDB-IFD-1)*(BSIZE+2)
          ify(IFDB)=IROW+1
          ifw(IFDB)=BSIZE
          ift(IFDB)=5       !  button field
        END DO
        IROW=IROW+1
        ILINES=IROW+1
        IFD=IFD+2
        IFINIT=2
C  Set control types and options for events, keys, mouse, & frames
        CALL InEventSelect(ResizeExpose,IntYes) ! ResizeExpose=6;IntYes=1
        CALL InControlKey(50,ResizeEvent)
        CALL InMouseOptions(MouseExit,IntYes)   ! MouseExit=2;IntYes=1
        CALL InControlKey(26,577)   ! Alt-A=577(accept);Alt-N=590(next)
        CALL InControlKey(27,579)   ! Alt-C=579(cancel); Alt-Q=593(quit)
        CALL InControlKey(29,129)   ! KeyCursorDown = 129
        CALL InControlKey(30,128)   ! KeyCursorUp   = 128
        CALL InSelectionChars(' ')
        call IFrameType(4)          ! DropShadow = 4; Window3D2 = 10
        call IFrameOptions(4,15)    ! TitleForeCol, TextWhiteBold
        call IFrameOptions(5,5)     ! TitleBackCol, TextBlue
        call IWinAction('FPC')
        call IGrInputOptions(4,1)   ! GINTerminate, GINAnyKey
        call InMouseOptions(102,3)  ! PopupButton,RightButton=3; LeftButton=1
        CALL InMouseOptions(MouseExit,IntYes)  !  MouseExit=2; IntYes=2
        call InHighLight('Black','yellow')
C  Now for the FormPut loop
        IFDB=1
        IROW=1
        DO WHILE (KEXIT.NE.ControlConfirm)   ! ControlConfirm=21
          call IWinWordWrap('JUST')
          call IWinOpenTitle(IZERO,IZERO,NHWDTH,ILINES,TITLE)
C   Begin the form definitions
          CALL IFormDefine('W',IFD,ifx,ify,ifw,ift)
          call IFrameOptions(5,15)  ! TitleForeCol, TextWhiteBold
          call IFrameOptions(4,5)   ! TitleBackCol, TextBlue
C  Place the one string, five integers, and 3 reals
          IFDB=1           !  reset to header field
          IROW=IROW+ISPACE
          DO NL=LAST+IQ3,LAY
            IROW=IROW+1
            IFDB=IFDB+1
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite') ! Field3D1=5
            CALL IFormPutInteger(IFDB,NL)
            IFDB=IFDB+1
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite') ! Field3D1=5
            CALL IFormPutReal(IFDB,PID(I1,NL,ISET),'(F10.4)')
            IFDB=IFDB+1
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite') ! Field3D1=5
            CALL IFormPutReal(IFDB,PWF(I1,NL,ISET),'(F10.4)')
            IF(IROW.GT.IPG) EXIT
          END DO            ! end DO NL loop
!   Put forms for ALIT & BLIT  to be entered if KIP is -4
          IF (KIP1.EQ.-4) THEN
            IROW=IROW+1+ISPACE
C   Place the heading on the first line
            IFDB=IFDB+1
            CALL IFormPutString(IFDB,TRIM(HEADER2))
            IROW=IROW+1+ISPACE
            IFDB=IFDB+1
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')
            CALL IFormPutReal(IFDB,ALIT(I1,ISET),'(E12.5)')
            IFDB=IFDB+1
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')
            CALL IFormPutReal(IFDB,BLIT(I1,ISET),'(E12.5)')
          END IF
!   End of ALIT & BLIT put forms
          CALL IFrameOptions(4,15)    ! TitleForeCol, TextWhiteBold
          CALL IFrameOptions(5,5)     ! TitleBackCol, TextBlue
C  ACCEPT
          call IFormPutButton(IFDB+1,BUTTON1,21)       ! ControlConfirm=21
          call IFormAttribute(IFDB+1,' ','Black','White')
          call IFormFrame(IFDB+1,7,'BWhite','Black')   ! Button3D1=7
C  CANCEL
          call IFormPutButton(IFDB+2,BUTTON2,23)  ! ControlQuit=23
          call IFormAttribute(IFDB+2,' ','Black','White')
          call IFormFrame(IFDB+2,7,'BWhite','Black')
C   Place the heading on the first line
          CALL IFormPutString(1,TRIM(HEADER))
C ++++ Show everthing in B4PIDPWF forms
          CALL IFormShow
C ++++ Edit the forms and use buttons to accept or cancel data
          CALL IFormEdit(IFINIT,IFEXIT)
!  Check 1st key exit, KEXIT, of B4PIDPWF
          KEXIT=InfoInput(55)   !   LastGINExit = 55
          IF (KEXIT.EQ.ControlQuit) THEN
C   Cancel button
            KEXIT=ControlConfirm
            DIALOG=.FALSE.
            EXIT
          ELSE IF (KEXIT.EQ.50) THEN
            KEXIT=20
            CALL IWinClose(1)
            CALL IScreenBackground('blue','blue')
            IROW=1
            IFINIT=IFEXIT
          ELSE IF (KEXIT.EQ.ControlConfirm) THEN
C   Get the real values
            IFDB=1
            IROW=IROW+ISPACE
            DO NL=LAST+IQ3,LAY
              IROW=IROW+1
              IFDB=IFDB+2           !  Skip the Protected layer field
              CALL IFormGetReal(IFDB,PID(I1,NL,ISET))
              IFDB=IFDB+1
              CALL IFormGetReal(IFDB,PWF(I1,NL,ISET))
              IF (IROW.GT.IPG) THEN
                NDIALOG=NDIALOG+1
                LAST=NL
                KEXIT=ControlConfirm
                IF (LAST+IQ3.LT.LAY) THEN
                  DIALOG=.TRUE.
                ELSE
                  DIALOG=.FALSE.
                END IF
                EXIT
              ELSE
                DIALOG=.FALSE.
                CALL IWinClose(1)
                CALL IScreenBackground('blue','blue')
              END IF
            END DO                ! End of DO NL layers
!   Get forms for ALIT & BLIT  to be entered if KIP is -4
            IF (KIP1.EQ.-4) THEN
              IROW=IROW+1+ISPACE
              IFDB=IFDB+2              !  Skip the Protected layer field
              CALL IFormGetReal(IFDB,ALIT(I1,ISET))
              IFDB=IFDB+1
              CALL IFormGetReal(IFDB,BLIT(I1,ISET))
            END IF
!   End of ALIT & BLIT put forms
          ELSE
            CALL IScreenBell('2')
            IROW=1
            IFINIT=IFEXIT
          END IF
        END DO                    ! end DO WHILE KEXIT loop
        CALL InMouseOptions(MouseExit,IntNo)   ! MouseExit=2; IntNo=0
        CALL IWinClose(3)
      END DO                      !  end DO WHILE DIALOG is true
      END SUBROUTINE
C*************************  new 4/30/97  *****************************

C     Last change:  RJH  30 Apr 97   10:50 am
C     B4GRID3D.FOR
C                    Designed by
C                    Raymond J. Heemstra
C
      SUBROUTINE B4GRID3D(NP1,NP2,LAYER,GRID,TITLE,FileName,
     &                          GROUP,NEXT,ABORT)
      CHARACTER*(*) FileName
      INCLUDE 'BAEDPARM.INC'
!      CHARACTER*80 WTIT
!      COMMON /B4EDGRP/ IWW,IWH,WTIT
      COMMON/DATA05/ GTYPE,CUMUL,LAYOUT,ITYP
      CHARACTER*1    GTYPE,CUMUL,LAYOUT
      DIMENSION GRID(LP1,LP2,LP3)
      DIMENSION ARRAY(NP1,NP2)
      CHARACTER BUFFER*90
      CHARACTER*(*) TITLE
      LOGICAL ACCEPT,GROUP,NEXT,ABORT
C    ***** INITIALIZATION DATA *****
      BUFFER=' '
      ACCEPT= .FALSE.
      GROUP = .FALSE.
      NEXT  = .FALSE.
      ABORT = .FALSE.
C  Place the GRID top layer into the ARRAY
      DO J=1,NP2
        DO I=1,NP1
          ARRAY(I,J)=GRID(I,J,LAYER)
        END DO
      END DO
C************DEBUG****************
!      IF (NP2.GT.1) THEN
!        WRITE(BUFFER,'(A5,I3,A5,A,A4,A)',ERR=911) 'Layer',LAYER,' for ',
!     &          TRIM(TITLE),' in ',TRIM(FileName)
!      ELSE
!        WRITE(BUFFER,'(A,A4,A)',ERR=911) TRIM(TITLE),
!     &    ' in ',TRIM(FileName)
!      END IF
C************DEBUG****************
      IF (NP2.GT.1) THEN
        WRITE(BUFFER,'(A5,I3,A5,A)',ERR=911) 'Layer',LAYER,' for ',
     &          TRIM(TITLE)
      ELSE
        WRITE(BUFFER,'(A)',ERR=911) TRIM(TITLE)
      END IF
C  Edit the ARRAY using a built-in spread sheet
912   CALL B4SPREAD(NP1,NP2,ARRAY,TRIM(BUFFER),ACCEPT,TRIM(FileName),
     &     GROUP,NEXT,ABORT )
      IF(ACCEPT.OR.GROUP.OR.NEXT) THEN
C  Place the array values into the given layer of GRID
        DO J=1,NP2
          DO I=1,NP1
            GRID(I,J,LAYER)=ARRAY(I,J)
          END DO
        END DO
        ACCEPT=.TRUE.
        ABORT=.FALSE.
      END IF
      IF (ABORT) THEN
        LAYER=LP3
      END IF
      RETURN
911   CALL AboutB4(1,BUFFER,
     &    'CALL Software support (918) 699-2087')
      GO TO 912
      END SUBROUTINE

C   B4SPREAD.FOR
C                    Designed by
C                    Raymond J. Heemstra
C
C   This is the main event loop for displaying the 2-dimensional
C  array of data values, while accepting input of commands and new
C  numbers for entering into the array.  The position in the array
C  is IX and IY.
C
      SUBROUTINE B4SPREAD(NP1,NP2,ARRAY,TITLE,
     &                     ACCEPT,FileName,GROUP,NEXT,ABORT)
      CHARACTER*(*) FileName
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
!      CHARACTER*80 WTIT
!      COMMON /B4EDGRP/ IWW,IWH,WTIT
      CHARACTER*80 WTIT,WINMAIN
      COMMON /B4EDGRP/ IWW,IWH,WTIT,WINMAIN
      COMMON /GRESN/ NXPX,NYPX,NCOLR

      LOGICAL ACCEPT,QUIT,HOME,RUNNING,GROUP,NEXT,ABORT
      DIMENSION ARRAY(NP1,NP2)
      CHARACTER*(*) TITLE
      CHARACTER*1 PRESS
      INTEGER ESCAPE
      LOGICAL AnswerB4
      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE
      COMMON/DATA05/ GTYPE,CUMUL,LAYOUT,ITYP
      CHARACTER*1    GTYPE,CUMUL,LAYOUT

C    ***** INITIALIZATION DATA *****
      ESCAPE=27     !  ESCAPE=27
      QUIT=.FALSE.
      PRESS=' '
      RUNNING=.FALSE.
      call IScreenTitle('G',TITLE)
      call IScreenMode('G',NXPX,NYPX,NCOLR)
      call INTRO                   !  Explain how to get menu, etc.
      call INIT(NP1,NP2,ARRAY)
      CALL IScreenBell('on')
      call SHOSCR                  !   Show first screen of data
      DO WHILE (.NOT.QUIT)              !  statement 100
        call CURCEL
        IF(LGE(PRESS,' ').AND.LLE(PRESS,'~')) RUNNING=.TRUE.
        IF(PRESS.EQ.'/'.OR.KEY.GE.KeyCursorUp.OR.
     &       KEY.LE.KeyLeftExtreme ) RUNNING=.TRUE.
        DO WHILE (RUNNING )             !  statement 150
          call InKeyEvent(KEY)
          PRESS=CHAR(KEY)
          IF (KEY.EQ.LeftButtonDown) THEN
            MOWSCOL=InfoInput(MouseTextCol)
            MOWSROW=InfoInput(MouseTextRow)
C   Columns
            DO I=1,NP1
!              ILO=6+(I-1)*9    !   to allow F9.2 in cells
!              IHI=ILO+8
              ILO=6+(I-1)*10   !   to allow F10.4 in cells
              IHI=ILO+9
              IF(MOWSCOL.GE.ILO.AND.MOWSCOL.LE.IHI) ICOLX=I
            END DO
            IF (ICOLX.LT.1) THEN
              ICOLX=1
              CALL IScreenBell('2')
              EXIT
            ELSE IF(ICOLX.GT.NP1) THEN
              ICOLX=NP1
              CALL IScreenBell('2')
              EXIT
            END IF
            IF (IXTOPL.GT.0) THEN
              IXREL=ICOLX+IXTOPL-1
            ELSE
              IXREL=ICOLX
            END IF
            IXCUR=IXREL
            IF(IXCUR.GT.NP1)IXCUR=NP1
C    Rows
            DO J=1,NP2
              JLO=5+(J-1)
              JHI=JLO+25
              IF(MOWSROW.GE.JLO.AND.MOWSROW.LE.JHI) IROWY=J
            END DO
            IF (IROWY.LT.1) THEN
              IROWY=1
              CALL IScreenBell('2')
              EXIT
            ELSE IF(IROWY.GT.NP2) THEN
              IROWY=NP2
              CALL IScreenBell('2')
              EXIT
            END IF
            IF (IYTOPL.GT.0) THEN
              IYREL=IROWY+IYTOPL-1
            ELSE
              IYREL=IROWY
            END IF
            IYCUR=IYREL
            IF(IYCUR.GT.NP2)IYCUR=NP2
            call SHOSCR
            EXIT
          END IF
          IF (KEY.EQ.ESCAPE) THEN
            CALL IScreenMode('G',NXPX,NYPX,NCOLR)
            IF (AnswerB4(1,'Wish to escape program?','Notice')) THEN
              CALL IWinClose(1)
              call IScreenQuit('C')
              STOP
            END IF
          ELSE IF (PRESS.EQ.'A'.OR.PRESS.EQ.'a') THEN
            IF (Answerb4(1,'Accept this data?','-- Question --')) THEN
              ACCEPT=.TRUE.
              DO J=1,NP2
                DO I=1,NP1
                  ARRAY(I,J)=VALS(I,J)
                END DO
              END DO
            ELSE
              ACCEPT=.FALSE.
            END IF
          ELSE IF (PRESS.EQ.'C'.OR.PRESS.EQ.'c') THEN
            ACCEPT=.FALSE.
          ELSE IF (PRESS.EQ.'N'.OR.PRESS.EQ.'n') THEN
            CALL IScreenMode('G',NXPX,NYPX,NCOLR)
            DO J=1,NP2
              DO I=1,NP1
                ARRAY(I,J)=VALS(I,J)
              END DO
            END DO
            QUIT=.TRUE.
            ACCEPT=.TRUE.
            RUNNING=.FALSE.
            RETURN
          ELSE IF (PRESS.EQ.'M'.OR.PRESS.EQ.'m'.OR.
     &                 KEY.EQ.RightButtonDown ) THEN
            CALL MENU(NP1,NP2,ARRAY,TITLE,
     &                ACCEPT,QUIT,NEXT,GROUP,HOME,FileName)

            IF (ACCEPT.OR.NEXT.OR.GROUP) THEN
              ACCEPT=.TRUE.
              DO J=1,NP2
                DO I=1,NP1
                  ARRAY(I,J)=VALS(I,J)
                END DO
              END DO
            END IF

            IF (QUIT) THEN
              ACCEPT=.FALSE.
              RUNNING  = .FALSE.
            END IF
            IF (HOME) THEN
              CALL IScreenMode('G',NXPX,NYPX,NCOLR)
              ABORT   = .TRUE.
              RETURN
            END IF
            IF (GROUP) THEN
              ABORT  = .FALSE.
              RETURN
            END IF
          ELSE IF(KEY.GE.KeyCursorUp.AND.KEY.LE.KeyLeftExtreme) THEN
            CALL MOVCEL(KEY)
            CALL SHOSCR
            EXIT
          ELSE IF (LGE(PRESS,' ').AND.LLE(PRESS,'~')) THEN
            CALL INPCEL(PRESS)
            EXIT
          ELSE IF (KEY.EQ.ResizeEvent) THEN
!  Attempt to insure that last J number in spread sheet is consecutive
            call INIT(NP1,NP2,ARRAY)
            call SHOSCR
            EXIT
          END IF
        END DO        ! end of RUNNING
      END DO       ! end of QUIT
      CALL IScreenMode('G',NXPX,NYPX,NCOLR)
      END SUBROUTINE

!    INTRO.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE INTRO
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      COMMON /GRESN/ NXPX,NYPX,NCOLR
C  introductory screen
15    CALL IScreenMode('G',NXPX,NYPX,NCOLR)
      CALL IClearScreen
      CALL IScreenBackground('blue','blue')

      CALL IWinOpen(0,1,55,22)
      CALL ITextColour('black','cyan')
      CALL IWinClear
      CALL IWinOutStringXY(2,1,'Invisible commands are:')
      CALL IWinOutStringXY(2,3,
     &    'N ---- selects next layer or variable array')
      CALL IWinOutStringXY(2,4,'M ---- menu selections, graphs')
      CALL IWinOutStringXY(2,5,'A ---- accept the input data')
      CALL IWinOutStringXY(2,6,'C ---- cancel the input data')
      CALL IWinOutStringXY(2,7,
     &  'F5 --- capture the graphic screen to a .BMP file')
      CALL IWinOutStringXY(2,8,'Esc -- abort the entire program')
      CALL IWinOutStringXY(2,9,
     &  'Use cursor arrow keys to move Left, Right, Up, & Down')
      CALL IWinOutStringXY(2,10,
     &  'Use Left mouse button to select cell position')
      CALL IWinOutStringXY(2,11,
     &  'Use Right Mouse to bring up the Menu (Please note)!')
      CALL IWinOutStringXY(2,13,
     &  'Home button  -- cancels current layer data import')
      CALL IWinOutStringXY(2,14,
     &  'Next button  -- selects next reservoir parameter layer')
      CALL IWinOutStringXY(2,15,
     &  'Group button -- selects next reservoir parameter group')
      CALL IWinOutStringXY(2,16,
     &    'Cancel button -- rejects current data entered by key')
      CALL IOutCentre(18,'Press mouse or any key to start')
      CALL IOutCentre(20,'Copyright (C) 1998')
      CALL IOutCentre(21,'BDM-Oklahoma')
      CALL IOutCentre(22,'All rights reserved')
      CALL IWinClose(0)   !  leave contents of window the same
c      CALL IWinClose(1)  !  restores contests if pop-up on, or else clears
      CALL InKeyEvent(KEY)
      IF (KEY.EQ.ResizeEvent) THEN
        GO TO 15
      END IF
      RETURN
      END

!    INIT.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE INIT(NP1,NP2,ARRAY)
C  Do general initialisation
      INCLUDE 'interif.inc'
      PARAMETER (LP1=200,LP2=200)
      DIMENSION ARRAY(NP1,NP2)
      COMMON /GRESN/ NXPX,NYPX,NCOLR

      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE
      COMMON/DATA05/ GTYPE,CUMUL,LAYOUT,ITYP
      CHARACTER*1    GTYPE,CUMUL,LAYOUT

      CALL InHighlight('BLACK','CYAN')
      NLINE  = InfoScreen(TextRows) ! Put last line into NLINE
!      NLINE  = InfoWindow(WinHeight)
C      NLINE  = NP2+5  !  this corrects too many J numbers, but bombs the J col
      NROW   = NLINE - 5
      NCOL   = (InfoScreen(TextColumns)-8)/9
      NCOLOR = InfoAttribute(ForeTextCol)
      ICHRA  = ICHAR('I')
      ICHRB  = ICHAR('J')
      CALL SETCEL(1,1)
      IXCUR  = 1
      IYCUR  = 1
      MAXX   = LP1
      MAXY   = LP2
!      MAXX   = NP1      !  This places excess zeros outside array
!      MAXY   = NP2      !  plus old numbers from other files.
      IFILE  = 0
      NSER   = 0
      DO 150 IY = 1,MAXY
      DO 100 IX = 1,MAXX
      VALS(IX,IY) = -1E37
  100 CONTINUE
  150 CONTINUE
      GTYPE  = 'C'
      CUMUL  = ' '
!      LAYOUT = '3'     ! take out will
!      ITYP = 3         !  allow ITYP to remain as selected (ie.3D,contour)
C  Set the array values into VALS and MAXX & MAXY
      DO J=1,NP2
         DO I=1,NP1
            VALS(I,J)=ARRAY(I,J)
         END DO
      END DO
      MAXX=NP1
      MAXY=NP2

      RETURN
      END

!    MENU.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE MENU(NP1,NP2,ARRAY,TITLE,
     &                 ACCEPT,QUIT,NEXT,GROUP,HOME,FileName)
      CHARACTER*(*) FileName
      INCLUDE 'interif.inc'
      INCLUDE 'interip.inc'

      DIMENSION ARRAY(NP1,NP2),VISUAL(NP1,NP2)
      CHARACTER*(*) TITLE
!      CHARACTER*80 WTIT
!      COMMON /B4EDGRP/ IWW,IWH,WTIT
      CHARACTER*80 WTIT,WINMAIN
      COMMON /B4EDGRP/ IWW,IWH,WTIT,WINMAIN
      COMMON /GRESN/ NXPX,NYPX,NCOLR

      PARAMETER  ( LP1=200, LP2=200 )
      PARAMETER  ( MAXTOP = 8 )
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      CHARACTER*1    GTYPE,CUMUL,LAYOUT
      COMMON/DATA05/ GTYPE,CUMUL,LAYOUT,ITYP
      LOGICAL   ACCEPT, QUIT , NEXT , HOME , GROUP


      CHARACTER*6    OPTTOP(MAXTOP)
      CHARACTER*60   HLPTOP(MAXTOP)
      CHARACTER*40 LOANAM,SAVNAM

      DATA   OPTTOP/'Import',
     &              'Export',
     2              'Type  ',
     3              'Graph ',
     4              'Cancel',
     5              ' Next ',
     6              'Group ',
     7              ' Home '/

      DATA   HLPTOP/
     & 'Import spread sheet text file, canceled by Home selection',
     & 'Export current data to a spread sheet .csv file',
     2 'Choose type of graph to plot (capture plot with F5 key)',
     3 'Create a 3D or 2D graph of current data entry, F5 to capture',
     4 'Return to EDIT mode, cancels keyboard data entry only      ',
     5 'Go to next spread sheet layer, saves import & keyboard data',
     6 'Go to next spread sheet group, saves import & keyboard data',
     7 'Go to the Home button mode, cancels import & keyboard entry'/

      QUIT   = .FALSE.
      NEXT   = .FALSE.
      GROUP  = .FALSE.
      HOME   = .FALSE.
      LOANAM =' '
      CALL STATUS('MENU ')
C
C  set menu highlight combination and get menu response
C
      CALL InHighlight('BLACK','YELLOW')
      IOPT = 4
!  option below allows mouse detection outside of menu
      CALL InPopUp('on')
      CALL InMouseOptions(MouseExit,IntYes)     ! outside input area
  100 IOPT = IMenuHorizHelp(OPTTOP,MAXTOP,2,HLPTOP,0,IOPT)
!  check on mouse detection
      IF (IOPT.EQ.-2) THEN
        call AboutB4(1,'Mouse outside the menus',
     &      'Hey you! Will not happen')
      END IF
!  New 3/9/98 for mouse release of menu selection
      CALL InMouseOptions(MouseExit,IntNo)
      CALL InPopUp('off')
C  did user press 'quit' key ?
      IF (InfoInput(LastExitKey).NE.ControlQuit) THEN

!  Did user select 'Home' option ?
        IF (IOPT.EQ.MAXTOP) THEN     !   Go Home
          QUIT=.TRUE.
          HOME=.TRUE.
!  Did user select 'Group'
        ELSE IF(IOPT.EQ.MAXTOP-1) THEN   !  Advance Group spread sheet
          QUIT  = .TRUE.                 !  QUIT is attention
          GROUP = .TRUE.                 !  GROUP is to go to next group
          NEXT  = .FALSE.
!  Did user select 'Next'
        ELSE IF(IOPT.EQ.MAXTOP-2) THEN   !  Advance Next spread sheet layer
          QUIT  = .TRUE.                 !  QUIT is next layer
          GROUP = .FALSE.                !  Not next group
          NEXT  = .TRUE.
C  Did user select 'Import' list of .CSV files ?
        ELSE IF (IOPT.EQ.1) THEN   !  Import spread sheet file
          CALL FSEEK(LOANAM,IFILE,'CSV')
          IOMODE=1
          SAVNAM=LOANAM
          CALL DATAIO(IOMODE,LOANAM,IERROR,NP1,NP2)
          IF (IERROR.LE.0) THEN
            DO J=1,NP2
              DO I=1,NP1
                VISUAL(I,J)=VALS(I,J)
              END DO
            END DO
            MAXX=NP1
            MAXY=NP2
            ACCEPT=.TRUE.
          ELSE
            ACCEPT=.FALSE.
          ENDIF
!  Did user select to save the current spread sheet under a file name
        ELSE IF (IOPT.EQ.2) THEN  ! Export spread sheet file
          IF (SAVNAM.NE.LOANAM) THEN
            SAVNAM='untitled.csv'
          END IF
          IOMODE=2
          DO J=1,NP2
            DO I=1,NP1
              VALS(I,J)=ARRAY(I,J)     !  or VISUAL instead of ARRAY
            END DO
          END DO
          CALL DATAIO(IOMODE,SAVNAM,IERROR,NP1,NP2)
          IF (IERROR.LE.0) THEN
            CALL SHOSCR
          ELSE
            CALL AboutB4(1,'Spread sheet not saved','Notice')
          END IF
!  Select type of graph ( 3D surface, 2D filled, or 2D contour
        ELSE IF (IOPT.EQ.3) THEN     !  set graph type
          CALL GRATYP
!  Graph menu of type ITYP
        ELSE IF (IOPT.EQ.4) THEN     !  Graph the array
          IF (LAYOUT.EQ.'3'.AND.GTYPE.EQ.'C') THEN
            ITYP = 3
          END IF
          WTIT(1:)=TRIM(TITLE)
          do i=1,NP1
            do j=1,NP2
              VISUAL(I,J)=VALS(I,J)   !   set VALS instead of ARRAY into VISUAL
            end do
          end do
          CALL GRASHO(NP1,NP2,VISUAL,FileName)
          CALL SHOSCR

!   Did user select Cancel (or Undo)
        ELSE IF (IOPT.EQ.5) THEN
          DO I=1,NP1
            DO J=1,NP2
              VALS(I,J)=ARRAY(I,J)
            END DO
          END DO
!          GO TO 1000
        ENDIF
      END IF !   ControlQuit
C  clear menu lines
 1000 CALL CLRMNU
      CALL STATUS('READY')
      RETURN
      END

!     SHOSCR.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE SHOSCR

!  show main screen including cell values
      COMMON /IGXYZ/ NP1,NP2,NP3

      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR

      CHARACTER*7    ROWID

      CALL IClearScreen
!
!  display date/time
      CALL SHODAT
!
!  select black on cyan on a colour screen or reverse video
!  otherwise and clear column headings line
!
      CALL SELATT(3)        !  bwhite text with bblue highlight
      CALL IClearLine(4)
!  *****new 8/29/97 *******
!  display non-blank cell values, row by row
!
!      CALL SHOROW(IYTOPL,IYBOTR)
!
!  write out row id's (left justify values)
      DO 200 IROW = 5,NLINE-1
       IF (IYTOPL+IROW-5.GT.NP2) EXIT
       ROWID = ' '
       CALL IntegerToString(IYTOPL+IROW-5,ROWID(:4),'(I4)')
       IPOS = ILocateChar(ROWID)
       CALL IOutStringXY(1,IROW,'J'//ROWID(IPOS:IPOS+3))
  200 CONTINUE
! ******** end of new 8/29/97 ********
!
!  display non-blank cell values, column by column
      CALL SHOCOL(IXTOPL,IXBOTR)
!
!  reset character attributes
      CALL SELATT(0)      !  black text color with cyan background
!
!  update status field
      CALL STATUS('READY')
      RETURN
      END

!     SHODAT.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE SHODAT
!
!  display date and time
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB

      CHARACTER*21   DATTIM
      CHARACTER*3    MONSTR(12)
      INTEGER IHRS,MINS,ISECS
      DATA   MONSTR/'Jan','Feb','Mar','Apr','May','Jun',
     1              'Jul','Aug','Sep','Oct','Nov','Dec'/

!  get date and time
      CALL IOsDate(IYEAR,MONTH,IDAY)    ! Should be good after year 2000
      CALL IOsTime(IHRS,MINS,ISECS)     ! Remember, its British!
                          ! So its probably Greenwitch time - 6
!  convert to a string
      IHRS=IHRS+6        ! IHRS = (GMT-6) ?? Anyway it works
      DATTIM = '  -'//MONSTR(MONTH)//'-        :   AM'
      IF (IHRS.GT.11) DATTIM(20:20) = 'P'
      CALL IntegerToString(IDAY,DATTIM(1:2),'(I2)')
      CALL IntegerToString(IYEAR,DATTIM(8:11),'(I4)')
      IHRS = MOD(IHRS,12)
      IF (IHRS.EQ.0) IHRS = 12
      CALL IntegerToString(IHRS,DATTIM(14:15),'(I2)')
      CALL IntegerToString(MINS,DATTIM(17:18),'(I2)')
      IF (DATTIM(17:17).EQ.' ') DATTIM(17:17) = '0'
!
!  display on bottom screen line
      CALL IOutStringXY(1,NLINE,DATTIM)
      RETURN
      END

!     SHOCOL.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE SHOCOL(IX1,IX2)
!
!  display data columns IX1 to IX2 with headings
      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      CHARACTER*10    COLID,CHRIX*4
      DATA           COLID/'         '/

!  enable highlight for heading
      CALL SELATT(3)  ! bwhite text with bblue Highlights in col heading
!      CALL SELATT(1) ! Highlights col heading in yellow, black text

!  display column headings
      DO 100 IX = IX1,IX2
      ICOL = 5 + (IX-IXTOPL)*10
      CHRIX = ' '
      CALL IntegerToString(IX,CHRIX,'(I4)')
      IPOS = ILocateChar(CHRIX)
      COLID(5:5) = CHAR(ICHRA)
      COLID(6:)=CHRIX(IPOS:)
      CALL IOutStringXY(ICOL,4,COLID)
  100 CONTINUE
      CALL SELATT(0)       !  black text color in cyan background

!  display non-blank cell values
      DO 250 IY = IYTOPL,IYBOTR
      DO 200 IX = IX1,IX2
      CALL SHOCEL(IX,IY,.FALSE.)
  200 CONTINUE
  250 CONTINUE
      RETURN
      END

!     SHOROW.FOR
!                    Designed by
!                    Raymond J. Heemstra
      SUBROUTINE SHOROW(IY1,IY2)
!
!  display data rows IY1 to IY2 with headings

      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      CHARACTER*7    ROWID
!
!  enable highlight for heading
!     CALL SELATT(1)     !  black text with Yellow highlight
      CALL SELATT(3)     !  bwhite text with bBlue highlight
!
!  write out row id's (left justify values)
      DO 100 IY = IY1,IY2
      IROW  = (IY-IYTOPL) + 5
      ROWID = ' '
      CALL IntegerToString(IY,ROWID(:5),'(I5)')
      IPOS  = ILocateChar(ROWID)
      ROWID(IPOS-1:IPOS-1)='J'
      CALL IOutStringXY(1,IROW,ROWID(IPOS-1:IPOS+3))
  100 CONTINUE
      CALL SELATT(0)    !   black text with cyan highlight
!
!  display non-blank cell values
      DO 250 IY = IY1,IY2
      DO 200 IX = IXTOPL,IXBOTR
      CALL SHOCEL(IX,IY,.FALSE.)
  200 CONTINUE
  250 CONTINUE
      RETURN
      END

!     CLRMNU.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE CLRMNU
!
!  clear the prompt/menu lines
      CALL IClearLine(2)
      CALL IClearLine(3)
      RETURN
      END

!     SCRSCR.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE SCRSCR
!
!  scroll the displayed data values if
!  the current cell has moved off screen
!
      INCLUDE 'interif.inc'

      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE
!
!  check whether current cell has moved off screen
      IF (IXCUR.LT.IXTOPL) THEN
          NX = IXCUR - IXTOPL
      ELSE IF (IXCUR.GT.IXBOTR) THEN
          NX = IXCUR - IXBOTR
      ELSE
          NX = 0
      ENDIF
      IF (IYCUR.LT.IYTOPL) THEN
          NY = IYCUR - IYTOPL
      ELSE IF (IYCUR.GT.IYBOTR) THEN
          NY = IYCUR - IYBOTR
      ELSE
          NY = 0
      ENDIF
!
!  update current global pos accordingly
      CALL SETCEL(IXTOPL+NX,IYTOPL+NY)
!
!  if both x and y positions have changed,
!  or if we're going to scroll by more rows/columns
!  than are on the screen, just redisplay the whole screen
      CALL IWinAction(' ')
      IF ((NX.NE.0.AND.NY.NE.0).OR.
     1    IABS(NX).GE.NCOL.OR.IABS(NY).GE.NROW) THEN
          CALL SHOSCR
      ELSE IF (NX.NE.0) THEN
!
!  scroll left/right - must fill missing columns at left or right
          CALL IWinOpen(5,5,NCOL*10,NROW+6)
          IF (NX.GT.0) THEN
              CALL IWinScroll('L',NX*9)
              CALL SHOCOL(IXTOPL-NX+1,IXBOTR)  !  this corrects right tab scroll
          ELSE
              CALL IWinScroll('R',IABS(NX)*9)
              CALL SHOCOL(IXTOPL,IXBOTR-NX-1)  !  this corrects return scroll
          ENDIF
      ELSE IF (NY.NE.0) THEN

!  scroll up/down - must fill missing rows at top/bottom
          CALL IWinOpen(5,5,NCOL*9,NROW+6)
          IF (NY.GT.0) THEN
              CALL IWinScroll('U',NY)
              CALL SHOROW(IYTOPL-NY+1,IYBOTR)
          ELSE
              CALL IWinScroll('D',IABS(NY))
              CALL SHOROW(IYTOPL,IYBOTR-NY-1)
          ENDIF
      ENDIF
      CALL IWinClose(0)
      RETURN
      END

!    CURCEL.FOR
!                    Designed by
!                    Raymond J. Heemstra
      SUBROUTINE CURCEL
!
!  display current cell and write current cell i.d./value at top left
!
      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      CHARACTER*5    ROWID
      CHARACTER*5    COLID
      CHARACTER*15    CELLID
      CHARACTER*10    FIELD
!    ROWID are the J rows (IYCUR); and COLID are the I columns(IXCUR)
      DATA           ROWID /'    ='/
      DATA           COLID /'    :'/

!  set up cell i.d. as a string
      CALL IntegerToString(IXCUR,COLID(:4),'(I4)')
      ISTART = ILocateChar(COLID)
      CELLID(1:) = CHAR(ICHRA)//COLID(ISTART:)
      LENCEL = IActualLength(CELLID)
      CALL IntegerToString(IYCUR,ROWID(:4),'(I4)')
      ISTART = ILocateChar(ROWID)
      CELLID(LENCEL+1:) = CHAR(ICHRB)//ROWID(ISTART:)
      LENCEL = IActualLength(CELLID)

!  set up cell value as a string
      FIELD = ' '
      IF (VALS(IXCUR,IYCUR).GT.-1E36)
     1    CALL IRealToString(VALS(IXCUR,IYCUR),FIELD,'(F10.4)')
!     1    CALL IRealToString(VALS(IXCUR,IYCUR),FIELD,'(G9.2)')

!  output cell i.d. and value at top left corner
      CALL IClearLine(1)
      CALL IOutStringXY(1,1,CELLID(:LENCEL)//FIELD)

!  output cell value, highlighted, within main data area
      CALL SELATT(1)     !   black text with yellow highlight
      IXX = 6 + (IXCUR-IXTOPL)*10
      IYY = 5 + (IYCUR-IYTOPL)
      CALL IOutStringXY(IXX,IYY,FIELD)
      CALL SELATT(0)     !   black text with cyan highlight
!
!  place cursor in middle of cell
      CALL ICursorLeft(5)
      RETURN
      END

!    SHOCEL.FOR
!                    Designed by
!                    Raymond J. Heemstra
      SUBROUTINE SHOCEL(IX,IY,BLANK)
!
!  display a cell in main data area without highlights
!  BLANK = Only output a blank fo empty cells if true.
!
      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      LOGICAL        BLANK
      CHARACTER*10    FIELD

      IXX = 6 + (IX-IXTOPL)*10
      IYY = 5 + (IY-IYTOPL)
      FIELD = ' '
      IF (VALS(IX,IY).GT.-1E36) THEN
          CALL IRealToString(VALS(IX,IY),FIELD,'(F10.4)')
!          CALL IRealToString(VALS(IX,IY),FIELD,'(G9.2)')
          CALL IOutStringXY(IXX,IYY,FIELD)
      ELSE IF (BLANK) THEN
          CALL IOutStringXY(IXX,IYY,FIELD)
      ENDIF
      RETURN
      END

!    MOVCEL.FOR
      SUBROUTINE MOVCEL(KEY)
!
!  move currently highlighted cell and scroll sheet if necessary
!  given a cursor key value (128=up 129=down 130=right 131=left)
!
      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      INTEGER        NCELLX(0:2),NCELLY(0:2)
      DATA           NCELLX/1,8 ,50/
      DATA           NCELLY/1,10,20/

      IXOLD = IXCUR
      IYOLD = IYCUR
      IDIRN = MOD(KEY,4)
      IDIST = (KEY-128)/4
!
!  up ?
      IF (IDIRN.EQ.0) THEN
          IYCUR = MAX0(IYCUR-NCELLY(IDIST),1)
!
!  down ?
      ELSE IF (IDIRN.EQ.1) THEN
          IYCUR = MIN0(IYCUR+NCELLY(IDIST),MAXY)
!
!  right ?
      ELSE IF (IDIRN.EQ.2) THEN
          IXCUR = MIN0(IXCUR+NCELLX(IDIST),MAXX)
!
!  left ?
      ELSE IF (IDIRN.EQ.3) THEN
          IXCUR = MAX0(IXCUR-NCELLX(IDIST),1)
      ENDIF
!
!  if current cell has changed de-highlight old one & scroll if needed
      IF (IXCUR.NE.IXOLD.OR.IYCUR.NE.IYOLD) THEN
          CALL SHOCEL(IXOLD,IYOLD,.TRUE.)
          CALL SCRSCR
      ENDIF
      RETURN
      END

!    SETCEL.FOR
      SUBROUTINE SETCEL(IX,IY)
!
!  set current gloabl cell pos to IX,IY
!
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR

      IXTOPL = IX
      IYTOPL = IY
      IXBOTR = IX + NCOL - 1
      IYBOTR = IY + NROW - 1
      RETURN
      END

!    INPCEL.FOR
      SUBROUTINE INPCEL(PRESS)

!  enter a cell value
!
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'

      PARAMETER (LP1=200,LP2=200)
      COMMON/DATA02/ IXTOPL,IYTOPL,IXBOTR,IYBOTR,IXCUR,IYCUR
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE

      CHARACTER*1    PRESS
      CHARACTER*10   STRING

!  put entered key in a default response string
      STRING = PRESS

!  make sure cursor is placed after first character and get string
      CALL InCursorPos(2)
      CALL STATUS('EDIT ')
  100 CALL ICursorXY(1,2)
      CALL InStringDef(STRING,LENGTH)
      CALL InCursorPos(1)
!
!  did user press the 'quit' key or enter a null string ?
      IF(InfoInput(LastExitKey).EQ.ControlQuit.OR.LENGTH.EQ.0)GOTO 1000
!
!  clear error flag just in case
      IERR = InfoError(LastError)
!
!  convert string to an integer
      CALL IStringToReal(STRING(:LENGTH),RVAL)
!
!  if there was an error try again
      IF (IERR.NE.0) THEN
          CALL IScreenBell(' ')
          GOTO 100
      ENDIF
!
!  update value in data array and clear prompt line
      VALS(IXCUR,IYCUR) = RVAL
 1000 CALL CLRMNU
      CALL STATUS('READY')
      RETURN
      END

!    STATUS.FOR
      SUBROUTINE STATUS(STRING)
!
!  display status at top right corner
!
      INCLUDE 'interif.inc'

      CHARACTER*(*) STRING

      IF (STRING.EQ.'ERROR') THEN
          CALL SELATT(2)  !  black text with fashing red highlight
      ELSE
          CALL SELATT(1)  !   black text with yellow highlight
      ENDIF
      CALL IOutStringXY(InfoScreen(TextColumns)-5,1,STRING)
      CALL SELATT(0)     !   black text with cyan highlight
      RETURN
      END

!    SELATT.FOR
      SUBROUTINE SELATT(IONOFF)
!
!  select text attributes
!  IONOFF = 0 : Revert to normal white on black text
!           1 : Select black-on-cyan (colour screen)
!               or reverse video (mono screen)
!           3 : Change color of top & left border of spreadsheet
!
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB

      IF (NCOLOR.GT.2) THEN
          IF (IONOFF.EQ.0) THEN
              CALL ITextFlash(' ')
              CALL ITextColour('BLACK','CYAN')
          ELSE IF (IONOFF.EQ.1) THEN
              CALL ITextColour('BLACK','YELLOW')
          ELSE IF (IONOFF.EQ.3) THEN
              CALL ITextColour('BWHITE','BBLUE')
          ELSE
              CALL ITextFlash('ON')
              CALL ITextColour('BLACK','RED')
          ENDIF
      ELSE
          IF (IONOFF.EQ.0) THEN
              CALL ITextAttribute(' ')
          ELSE IF (IONOFF.EQ.1) THEN
              CALL ITextAttribute('R')
          ELSE
              CALL ITextAttribute('RF')
          ENDIF
      ENDIF
      RETURN
      END

!    GRATYP.FOR
!                    Designed by
!                    Raymond J. Heemstra
      SUBROUTINE GRATYP
!
!  select graph type
!
      INCLUDE 'interif.inc'
      INCLUDE 'interip.inc'

      COMMON/DATA05/ GTYPE,CUMUL,LAYOUT,ITYP
      CHARACTER*1    GTYPE,CUMUL,LAYOUT

      PARAMETER     (MAXTYP = 3)
      CHARACTER*10   OPTTYP(MAXTYP)
      CHARACTER*30   HLPTYP(MAXTYP)

      DATA   OPTTYP/'2D contour',
     2              '2D filled ',
     3              '3D surface'/
      DATA   HLPTYP/'2D line-based contour plot    ',
     2              '2D fill-based contour plot    ',
     3              'Plot as 3D contoured surface  '/

      CALL InPopUp('on')
      CALL InMouseOptions(MouseExit,IntYes)

      ITYP = IMenuVerticHelp(OPTTYP,MAXTYP,9,3,HLPTYP,' ',0,1,ITYP)

      CALL InMouseOptions(MouseExit,IntNo)
      CALL InPopUp('off')
!
!  did user press 'quit' key ?
      CALL InSelectionChars(' ')
      KeyExit = InfoInput(LastExitKey)
      IF (KeyExit .EQ. 50) THEN
        CALL IScreenBackground('green','bgreen')    !  experimental
!        CYCLE
      ELSE IF (InfoInput(LastExitKey).EQ.ControlQuit) THEN
        IF (ITYP.EQ.1) THEN
          LAYOUT='2'
          GTYPE='C'
        ELSE IF(ITYP.EQ.2) THEN
          LAYOUT='F'
          GTYPE='C'
        ELSE
          ITYP=3
          LAYOUT='3'
          GTYPE='C'
        END IF
        RETURN
      ELSE
!
!  update graph type
!
!        GTYPE  = 'C'
!        CUMUL  = ' '        !  Non-cumulative
!        LAYOUT = '2'
        IF (ITYP.EQ.1) THEN
          LAYOUT='2'
          GTYPE  = 'C'             !  Contour plot
        ELSE IF (ITYP.EQ.2) THEN
          LAYOUT = 'F'             !  Fill-based contour plots
          GTYPE  = 'C'
        ELSE IF (ITYP.EQ.3) THEN
          LAYOUT = '3'           ! Height dependent contour colours
          GTYPE  = 'C'
        ELSE
          ITYP=3
          LAYOUT='3'
          GTYPE='C'
        ENDIF
      END IF
      RETURN
      END

!      SUBROUTINE GRAOPT
!
!  select graph options    ! this does nothing
!
!      RETURN
!      END

!    GRASHO.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE GRASHO(NP1,NP2,ARRAY,FileName)
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
!
!  show currently selected graph
      PARAMETER (LP1=200,LP2=200)
      CHARACTER*80 WTIT,WINMAIN
      COMMON /B4EDGRP/ IWW,IWH,WTIT,WINMAIN
      COMMON /GRESN/ NXPX,NYPX,NCOLR

      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE
      COMMON/DATA04/ TITLE,STITLE(LP2)
      CHARACTER*80   TITLE,STITLE
      COMMON/DATA05/ GTYPE,CUMUL,LAYOUT,ITYP
      CHARACTER*1    GTYPE,CUMUL,LAYOUT
      CHARACTER*(*) FileName
      CHARACTER*64 FILESAVE

      PARAMETER(NC=9,NC1=NC+1)
      REAL CONTKEY(NC)
      CHARACTER*6 KEYSTR(NC)
      INTEGER NVALUE(2)
      REAL ZCONTR(NC)
      DIMENSION ARRAY(NP1,NP2)
      INTEGER F5,F6

      DATA F5 /175/, F6 /176/
!
!  enter graphics mode
15    CALL IScreenMode('G',NXPX,NYPX,NCOLR)
      CALL IScreenTitle('G',TRIM(WTIT))
!
!  select software character set
      CALL IGrCharSet(' ')
      CALL IGrCharSize(1.3,1.3)
      CALL IGrArea(0.0,0.0,1.0,1.0)
      CALL IGrAreaClear
!
!  select software character set
!      CALL IGrCharSet(' ')
!      CALL IGrCharSize(1.3,1.3)
      CALL IGrColour('W')
      CALL IGrBorder
!
!  set presentation graphics area and units
      CALL IPgArea(0.1,0.1,0.75,0.9)
!
!  plot the data
      NXDIM=NP1
      NYDIM=NP2
      NX=NXDIM
      NY=NYDIM
      XMIN = 0.0
      YMIN = 0.0
      ZMIN = 99999.
      ZMAX =-99999.
      XMAX=FLOAT(NX)
      YMAX=FLOAT(NY)
      NVALUE(1) = NX-1
      NVALUE(2) = NY-1
!
!  set presentation graphics area and units
C      CALL IPgArea(0.1,0.1,0.75,0.9)
      IF(LAYOUT.EQ.'2') THEN
        CALL IPgNewGraph(NC,NVALUE,CUMUL,LAYOUT,GTYPE)
      ELSE
C        CALL IPgNewGraph(NC+1,NVALUE,' ','3VH','Con')
C        CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
C        CALL  IPgElevation(25.0)
C        CALL IRealMaxMin2(ZVALUE,NXDIM,NYDIM,NX,NY,ZMIN,ZMAX)
C        IF ((ZMAX-ZMIN).LT.1.0E-20) THEN
C          ZMIN=0.0
C        END IF
C        CALL IPgUnitsZ(ZMIN,ZMAX)
        CALL IPgNewGraph(NC,NVALUE,CUMUL,LAYOUT,GTYPE)
      END IF
!
!  set presentation graphics area and units
      CALL IPgArea(0.1,0.1,0.75,0.9)
!
!  calculate max/min values
      CALL IRealMaxMin2(ARRAY,NXDIM,NYDIM,NX,NY,ZMIN,ZMAX)
      IF ((ZMAX-ZMIN).LT.1.0E-20) THEN
        ZMIN=0.0
      END IF
      CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
      IF (LAYOUT.EQ.'3') THEN
        CALL  IPgElevation(25.0)
      END IF
      CALL IPgUnitsZ(ZMIN,ZMAX)
!
!  axes and scale
      CALL IPgAxes
      CALL IPgZScale('TN')
      CALL IPgYScaleLeft('TN')
      CALL IPgXScale('TN')
!
!   Generate some arbitrary contour heights
      DO IC = 1,NC
!        ZCONTR(IC) = ZMIN + FLOAT(IC)*(ZMAX-ZMIN)/FLOAT(NC+1)
        ZCONTR(IC) = ZMIN + FLOAT(IC)*(ZMAX-ZMIN)/FLOAT(NC1)
        CONTKEY(IC) = ZMIN+ FLOAT(IC)*(ZMAX-ZMIN)/FLOAT(NC1)
      END DO
      CALL IGrCharSize(1.1,1.1)
!
!  select graph type
      IF (LAYOUT.EQ.'2') THEN
!
!   Generate a 2 dimensional contour plot of data in ARRAY
        CALL IPgContour2Reg(ARRAY,NXDIM,NYDIM,ZCONTR)
        CALL IPgYLabelLeft('ROWS','C')
        CALL IPgXLabel('COLUMNS','C')
      ELSE IF (LAYOUT.EQ.'F') THEN
!
!   Generate a 2 dimensional fill-based contour plot of data in ARRAY
        CALL IPgConFill2Granul(1) ! IGRAN=1, sub-divide grid cell 1
        CALL IPgConFill2Reg(ARRAY,NXDIM,NYDIM,ZCONTR)
        CALL IPgYLabelLeft('ROWS','C')
        CALL IPgXLabel('COLUMNS','C')
      ELSE                 !   3-D surface display
        CALL IPgNewGraph(NC,NVALUE,' ','3VH','Con')
        CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
        CALL  IPgElevation(25.0)
        CALL IRealMaxMin2(ARRAY,NXDIM,NYDIM,NX,NY,ZMIN,ZMAX)
        CALL IPgUnitsZ(ZMIN,ZMAX)
        CALL IPgSurf3DataCont(ARRAY,NXDIM,NYDIM,ZCONTR)
        CALL IPgYLabelLeft('VALUE','9')
        CALL IPgXLabel('COLUMNS','R')
        CALL IPgXLabel('ROWS','L')

!**************************************************
      ENDIF
  100 CONTINUE
!
!  add legends
      LENTIT = IActualLength(TITLE)
      CALL IPgTitle(TITLE(:LENTIT),'C')
!  Place a contour color scale (CONTkey) on right side of contour plot.
!  Set up simple strings for the key and assign varying fill styles for
!  each contour.
            DO IC = 1,NC
              IF (CONTKEY(IC) .LT. 10.0) THEN
                WRITE(KEYSTR(IC),'(F6.4)') CONTKEY(IC)
              ELSE IF (CONTKEY(IC) .GE. 10.0 .AND.
     &                       CONTKEY(IC) .LT. 100.0) THEN
                WRITE(KEYSTR(IC),'(F6.3)') CONTKEY(IC)
              ELSE
                WRITE(KEYSTR(IC),'(F6.0)') CONTKEY(IC)
              END IF
              CALL IPgStyle(IC,4,3,3,240-IC*20,0)
            END DO
            CALL IGrCharSize(1.2,0.8)
            CALL IGrCharSet(' ')
            CALL IPgKeyAll(KEYSTR,'R')
!   End of contour legend
!  wait for user to press a key and exit graphics mode

      CALL InKeyEvent(KEY)
      FILESAVE=FileName
!  Capture screen in a .BMP file (not compatible with PAINT)
      IF (KEY.EQ.F5) THEN
!        CALL B4CAPT(FileName,FILESAVE)
        CALL B4CAPTUR(FileName)
      ELSE IF (KEY.EQ.F6) THEN
        CALL B4RETRIV(FILESAVE)
      ELSE IF (KEY.EQ.ResizeEvent) THEN
        GO TO 15
      END IF
      CALL IGrPause('A')
      RETURN
      END

!    DATAIO.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE DATAIO(IOPT,DEFAUL,IERROR,NP1,NP2)
!
!  import or save a data file
!  IOPT = 1 : Import mode
!       = 2 : Export mode
!
      INCLUDE 'interif.inc'
      INCLUDE 'interip.inc'
      PARAMETER (LP1=200,LP2=200)
      PARAMETER (NRECSIZ=4192)
      COMMON/DATA03/ MAXX,MAXY,NSER,NPTS(LP2),VALS(LP1,LP2),IFILE
      CHARACTER*80   TITLE,STITLE
      COMMON/DATA04/ TITLE,STITLE(LP2)
      CHARACTER*(*)  DEFAUL
      CHARACTER*40   LOANAM,SAVNAM
      CHARACTER*80 BUFFER
      CHARACTER*(NRECSIZ) RECORD
      LOGICAL  EXISTS,FSTORE
      CALL STATUS('EDIT ')
      CALL InCursorPos(999)
      CALL CLRMNU
      IF (IOPT.EQ.1) THEN
        LOANAM=' '
        LOANAM = TRIM(DEFAUL)
        LENGTH=LEN_TRIM(LOANAM)
        IERROR = 0
        IF(InfoInput(LastExitKey).EQ.ControlQuit.OR.LENGTH.EQ.0)RETURN
      ELSE
          SAVNAM = DEFAUL
        IF(SAVNAM(1:4).EQ.'    ') SAVNAM='UNTITLED.CSV'
        IF (FSTORE(DEFAUL)) THEN
          SAVNAM=DEFAUL
          LENGTH=LEN_TRIM(SAVNAM)
          CALL AboutB4(1,
     &     'Exporting spread sheet as '//TRIM(SAVNAM),'Notice')
        ELSE
          CALL AboutB4(1,'Exporting of spread sheet canceled','Notice')
          RETURN
        END IF
      ENDIF
!      IF (InfoInput(LastExitKey).EQ.ControlQuit.OR.LENGTH.EQ.0) RETURN
      IERROR = 0
      LFN=20
!
!  does file exist ?
      IF (IOPT.EQ.1) THEN
        INQUIRE (FILE=LOANAM,EXIST=EXISTS)
        IF (.NOT.EXISTS) THEN
          WRITE(BUFFER,*) TRIM(LOANAM)//' does not exist!'
          call AboutB4(1,TRIM(BUFFER),'File error!')
          IERROR = 1
          RETURN
        ENDIF
!
!  load
        OPEN(LFN,FILE=LOANAM,STATUS='OLD')
        DO J=1,NP2
          READ(LFN,*,ERR=900) (VALS(I,J),I=1,NP1)
        END DO
!        WRITE(BUFFER,*) 'File name imported is: '//LOANAM
!        call AboutB4(1,TRIM(BUFFER),'Notice')
      ELSE
!
!  save
        MAXLEN=0
        DO J=1,NP2
          RECORD=' '
          WRITE(RECORD,*,ERR=900) (VALS(I,J),CHAR(44),I=1,NP1)
          LENVALS=LEN_TRIM(RECORD)
          RECORD(LENVALS:LENVALS)=' '
!          LENVALS=LENVALS-1
          IF (MAXLEN.LT.LENVALS) THEN
            MAXLEN=LENVALS
          END IF
        END DO
        IF (MAXLEN.LT.17*NP1) THEN
          MAXLEN=16*NP1
        END IF
!        WRITE(BUFFER(1),*) 'Export file record length = ',MAXLEN  !  = 447  for test3.csv
!        WRITE(BUFFER(2),*) 'Cols = ',NP1,', Rows = ',NP2
!        call AboutB4(2,BUFFER,'Notice')
        OPEN(LFN,FILE=SAVNAM,STATUS='UNKNOWN',RECL=MAXLEN)
        DO J=1,NP2
          RECORD=' '
!  Convert to comma delimited spreadsheet format
          WRITE(RECORD(1:MAXLEN),*,ERR=900) (VALS(I,J),CHAR(44),I=1,NP1)
          WRITE(LFN,*,ERR=901) RECORD(1:MAXLEN-1)    ! remove last comma
        END DO
!        WRITE(BUFFER,*) 'Exported file name saved is: '//SAVNAM
!        call AboutB4(1,TRIM(BUFFER),'Notice')
      ENDIF
      CLOSE (LFN)
      IERROR=0
      RETURN
!
!  i/o error
  900 IERROR = 2
        WRITE(BUFFER,*) 'Record size exceeds ',NRECSIZ
        CALL AboutB4(1,TRIM(BUFFER),'write to record error')
!
!  close file
      CLOSE(LFN)
      RETURN
  901  IERROR=3
       WRITE(BUFFER,*) RECORD(1:65)
       CALL AboutB4(1,TRIM(BUFFER),'write to LFN error')
      END

!     BADEFALT.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE BADEFALT(FILENAME,
     &   DX,DY,DZ,DZNET,RDXL,RDYL,RDZL,RDZNET,ZT,VAREL,RKEL,EL,
     &   RPHL,RKXL,RKYL,RKZL,VP,KX,KY,KZ,
     &   IROCK,IPVT,PBOT,SO,SW,PN,LRCK,PIL,SOIL,SWIL,SGIL,PID,PWF)
      CHARACTER*(*) FILENAME
      INCLUDE 'BAEDPARM.INC'
      INCLUDE 'BED.INC'
      INCLUDE 'GRIDA.INC'
      INCLUDE 'PORPRA.INC'
      INCLUDE 'TABLEA.INC'
      INCLUDE 'UINITA.INC'
      INCLUDE 'NODESA.INC'
      B3HDR(1)='Place up to 5 lines of description and identification  '
      B3HDR(2)='of the reservoir being investigated.  You can discuss  '
      B3HDR(3)='the constraints such as producers, injectors, implicit '
      B3HDR(4)='and explicit calculations (KIP), BHP control, run days,'
      B3HDR(5)='added switches, dates of simulations, etc.'

      CALL EXTEN(FILENAME,RESIN,'RIN')
      CALL EXTEN(FILENAME,RESOUT,'ROT')
      H1= 'RESTART AND POST-RUN CODES'
      H2= 'Grid Data'
      H3= 'Grid Block Lengths'
      H4= 'Grid Block Length Modifications'
      H5= 'Depths to Top of Grid-Blocks ( KEL  ALPHA )'
      H6= 'Porosity and Permeability Distributions'
      H7= 'Porosity & Permeability Modifications'
      H8= 'Transmissibility Modifications'
      H9= 'ROCK PVT'
      H10='Number of Rock Regions'
      H11='Number of PVT Regions'
      H12= ' SAT   KRO     KRW     KRG     KROG      PCOW      PCGO'
      H13= 'ITHREE SWR'
      H14= '   PBO      PBODAT   PBGRAD'
      H15= '  VSLOPE     BSLOPE      RSLOPE       PMAX    REPRS'
      H16= '   P     MUO    BO      RSO'
      H17= '   P     MUW    BW'
      H18='Gas and Rock Propties Data Table'
!           KGCOR
      H19='  P     MUG     BG     PSI     CR'
!      PGT(NP,I),MUGT(NP,I),BGT(NP,I),PSIT(NP,I),CRT(NP,I)
!          CALLS PSEUDOIN
      H20='Pressure and Rock Compressibility (PRT  CRT)'
!          PRT(NP,IG),CRT(NP,IG)
      H21= '  RHOSCO   RHOSCW    RHOSCG'
!     EQUILIBRIUM PRESSURE/CONSTANT SATURATION INITIALIZATION
      H22= 'Initialization Option Codes'
      H23= ' NR    Pwoc     WOC      Pgoc     GOC    Soi   Swi   Sgi'//
     & '   [by Region]'
      H24= 'Initialization by Layer (NZ Records) (NZ Pi Soi Swi Sgi)'
      H25='oil saturation layer1'
      H26='water saturation layer1'
      H27='initial pressures for layer 1'
      H28= 'KSN1 KSM1 KCO1 KCOF KSCRN KOUT'
      H29= 'NMAX FACT1 FACT2 TMAX WORMAX GORMAX PAMIN PAMAX'
      H30= 'KSOL MITR OMEGA TOL TOL1 DSMAX DPMAX'
      H31= 'NUMDIS IRK THRUIN'
      H32= 'Aquifer Data'
      H33= 'Well and Node Data'
      H34= ' No. of Wells'
      H35= ' Well Nodes WellName'
      H36= '  Well    Node(I,J,K)      DIR'
      H37= 'Recurrent Data'
      H38(1)=
     &'======================= DATA SET   1 =========================='
      H39(1)= 'No. of new wells;  No. of old wells'
      H40(1)= '---NEW WELLS---'
      H41(1)= '---OLD WELLS---'
!      H42= ' '   !  not used
!      H43= ' '   !  not used

!     Basic information needed.
      KDX=-1
      KDY=-1
      KDZ=-1
      KDZNET=-1
      DXC=60.
      DYC=60.
      DZC=20.
      DZNETC=20.
!
!   LP9=25 max table entries; rock reg.=1
      PMAXT=4014.7    ! POT(1,LP9)=9014.7
      IREPRS=1        ! off is IREPRS=1; on is 0
!
!   Depths to Top of Grid-Blocks and Dip Angle
      KEL=0
      IF (KEL.EQ.0) THEN
        ALPHA=0.0     !   Dip angle, positive is down in X-direction
      END IF
      ELEV=4000.     !   Depth to top of grid-block, ft.
C      DO K=1,NZ
C        DO J=1,NY
C          DO I=1,NX
C            EL(I,J,K)=ELEV+0.5*DZ(I,J,K)+SIN(ALPHA)*DX(I,J,K)
C          END DO
C        END DO
C      END DO
!
!   Grid dimensions
      II=NX
      JJ=NY
      KK=NZ
      KPH=-1
      KKX=-1
      KKY=-1
      KKZ=-1
      PHIC=.25
      KXC=120.
      KYC=120.
      KZC=60.

      I1DX(1)=1
      I2DX(1)=NX
      J1DX(1)=1
      J2DX(1)=NY
      K1DX(1)=1
      K2DX(1)=NZ

      I1DY(1)=1
      I2DY(1)=NX
      J1DY(1)=1
      J2DY(1)=NY
      K1DY(1)=1
      K2DY(1)=NZ

      I1DZ(1)=1
      I2DZ(1)=NX
      J1DZ(1)=1
      J2DZ(1)=NY
      K1DZ(1)=1
      K2DZ(1)=NZ

      I1DZN(1)=1
      I2DZN(1)=NX
      J1DZN(1)=1
      J2DZN(1)=NY
      K1DZN(1)=1
      K2DZN(1)=NZ
!
!  Porosity - Permeability
      I1NUM(1)=1
      I2NUM(1)=NX
      J1NUM(1)=1
      J2NUM(1)=NY
      K1NUM(1)=1
      K2NUM(1)=NZ

      I1KX(1)=1
      I2KX(1)=NX
      J1KX(1)=1
      J2KX(1)=NY
      K1KX(1)=1
      K2KX(1)=NZ

      I1KY(1)=1
      I2KY(1)=NX
      J1KY(1)=1
      J2KY(1)=NY
      K1KY(1)=1
      K2KY(1)=NZ

      I1KZ(1)=1
      I2KZ(1)=NX
      J1KZ(1)=1
      J2KZ(1)=NY
      K1KZ(1)=1
      K2KZ(1)=NZ
!
!   Transmissibility
      I1TX(1)=1
      I2TX(1)=NX
      J1TX(1)=1
      J2TX(1)=NY
      K1TX(1)=1
      K2TX(1)=NZ

      I1TY(1)=1
      I2TY(1)=NX
      J1TY(1)=1
      J2TY(1)=NY
      K1TY(1)=1
      K2TY(1)=NZ

      I1TZ(1)=1
      I2TZ(1)=NX
      J1TZ(1)=1
      J2TZ(1)=NY
      K1TZ(1)=1
      K2TZ(1)=NZ
!
!   Rock and PVT
      NROCK=1
      NPVT=1
      NUMROK=1
      NUMPVT=1
      NRRCK(1)=1             !  PWOC(NRRCK(1))
      SOIRK(NRRCK(1))=0.85   !   0.85
      SWIRK(NRRCK(1))=0.10   !   0.10
      SGIRK(NRRCK(1))=0.05   !   0.05

C      PWOC(NRRCK(1))=PMAXT
C      PGOC(NRRCK(1))=PMAXT

      I1ROK(1)=1
      I2ROK(1)=NX
      J1ROK(1)=1
      J2ROK(1)=NY
      K1ROK(1)=1
      K2ROK(1)=NZ
      IVALROK(1)=1

      I1PVT(1)=1
      I2PVT(1)=NX
      J1PVT(1)=1
      J2PVT(1)=NY
      K1PVT(1)=1
      K2PVT(1)=NZ
      IVALPVT(1)=1
!
!   PVT values
!    LRCK values are default sequentially to each layer
      DO K=1,KK
        LRCK(K)=K
        PIL(LRCK(K))=PMAXT
        SOIL(LRCK(K))=0.88
        SWIL(LRCK(K))=0.12
        SGIL(LRCK(K))=0.0
      END DO
!
!   Sat/perm curve   sat vs. kro, krw, krg, krog,pcow,pcgo
      MSAT(1)=6

      SAT(1,1)=0.08    !  0.08
      SAT(1,2)=0.31    !  0.31
      SAT(1,3)=0.40    !  0.40
      SAT(1,4)=0.51    !  0.51
      SAT(1,5)=0.69    !  0.69
      SAT(1,6)=1.0     !  1.00

      KROT(1,1)=0.0    !  0.00
      KROT(1,2)=0.0    !  0.00
      KROT(1,3)=0.008  !  0.008
      KROT(1,4)=0.057  !  0.057
      KROT(1,5)=0.157  !  0.257
      KROT(1,6)=1.0    !  0.60

      KRWT(1,1)=0.00   !  0.00
      KRWT(1,2)=0.06   !  0.06
      KRWT(1,3)=0.108  !  0.108
      KRWT(1,4)=0.180  !  0.180
      KRWT(1,5)=0.280  !  0.280
      KRWT(1,6)=0.50   !  0.50

      KRGT(1,1)=0.005  !  0.005
      KRGT(1,2)=0.02   !  0.02
      KRGT(1,3)=0.12   !  0.12
      KRGT(1,4)=0.32   !  0.32
      KRGT(1,5)=0.72   !  0.72
      KRGT(1,6)=1.0    !  1.00

      KROGT(1,1)=0.0   !  0.00
      KROGT(1,2)=0.0   !  0.00
      KROGT(1,3)=0.0   !  0.00
      KROGT(1,4)=0.0   !  0.00
      KROGT(1,5)=0.0   !  0.00
      KROGT(1,6)=0.0   !  0.00

      PCOWT(1,1)=0.0   !  0.00
      PCOWT(1,2)=0.0   !  0.00
      PCOWT(1,3)=0.0   !  0.00
      PCOWT(1,4)=0.0   !  0.00
      PCOWT(1,5)=0.0   !  0.00
      PCOWT(1,6)=0.0   !  0.00

      PCGOT(1,1)=0.0   !  0.00
      PCGOT(1,2)=0.0   !  0.00
      PCGOT(1,3)=0.0   !  0.00
      PCGOT(1,4)=0.0   !  0.00
      PCGOT(1,5)=0.0   !  0.00
      PCGOT(1,6)=0.0   !  0.00

      ITHREE(1)=0
      SWR(1)=.12     !  0.12
!
!    pbo   pbodat   pbgrad
      VSLOPE(1)=0.000046                 !      0.000046
      BSLOPE(1)=-0.0000232               !     -0.0000232
      RSLOPE(1)=0.0

      PWOC(NRRCK(1))=PMAXT     !  Pressure at water oil contact
      PGOC(NRRCK(1))=PMAXT     !  Pressure at gas oil contact
!
!  PVT curves   POT vs. muo, muw, mug, krog,pcow,pcgo
      MPOT(1)=3
      POT(1,1)=14.7                      !     14.7
      MUOT(1,1)=1.04                     !      1.04
      BOT(1,1)=1.06                      !      1.06
      RSOT(1,1)=1.0                      !      1.0

      POT(1,2)=(PMAXT-POT(1,1))/2        !   4014.7
      MUOT(1,2)=0.85                     !      0.87
      BOT(1,2)=1.095                     !      1.095
      RSOT(1,3)=170.      !    170.   this is needed for RSOT(1,2) calc.
      RSOT(1,2)=(RSOT(1,3)-RSOT(1,1))/2  !     80.

      POT(1,3)=PMAXT      !   4014.7
      MUOT(1,3)=0.7       !      0.7
      BOT(1,3)=1.15       !      1.15
!      RSOT(1,3)=170.      !    170.

      MPWT(1)=3
      PWT(1,1)=POT(1,1)
      MUWT(1,1)=0.3       !      0.3
      BWT(1,1)=1.002      !      1.002

      PWT(1,2)=(PMAXT-POT(1,1))/2
      MUWT(1,2)=0.3       !      0.3
      BWT(1,2)=1.001      !      1.001

      PWT(1,3)=PMAXT
      MUWT(1,3)=0.3       !      0.3
      BWT(1,3)=1.001      !      1.001

      MPGT(1)=3
      PGT(1,1)=POT(1,1)
      MUGT(1,1)=0.3       !      0.3
      BGT(1,1)=1.002      !      1.002
      PSIT(1,1)=0
      PRT(1,1)=0
      CRT(1,1)=0.000003   !      0.000003

      PGT(1,2)=(PMAXT-POT(1,1))/2
      MUGT(1,2)=0.7       !      0.7
      BGT(1,2)=1.001      !      1.001
      PSIT(1,2)=(PMAXT-POT(1,1))/2
      PRT(1,2)=(PMAXT-POT(1,1))/2
      CRT(1,2)=0.000003   !      0.000003

      PGT(1,3)=PMAXT
      MUGT(1,3)=0.7       !      0.7
      BGT(1,3)=1.001      !      1.001
      PSIT(1,3)=PMAXT
      PRT(1,3)=PMAXT
      CRT(1,3)=0.000003   !      0.000003

      KGCOR=0

      KODEA   =3          !  Gas composition option
      TEM     =226.0      !  Reservoir temperature, o F
      SPG     =0.871      !  Gas specific gravity (air=1.0) = 0.
      FRCI(1) =0.0        !  H2S mole fraction
      FRCI(2) =0.0065     !  CO2 mole fraction
      FRCI(3) =0.0554     !  N2 mole fraction
      FRCI(4) =0.567      !  C1 mole fraction
      FRCI(5) =0.2118     !  C2 mole fraction
      FRCI(6) =0.1106     !  C3 mole fraction
      FRCI(7) =0.0085     !  iC4 mole fraction
      FRCI(8) =0.0287     !  nC4 mole fraction
      FRCI(9) =0.0024     !  iC5 mole fraction
      FRCI(10)=0.0066     !  nC5 mole fraction
      FRCI(11)=0.0018     !  C6 mole fraction
      FRCI(12)=0.0007     !  C7+ mole fraction

!   PRSCI, TEMCI, RMWTI all have 12
!
!    Stock tank fluid densites
      RHOSCO=46.244       !   46.244
      RHOSCW=62.238       !   62.238
      RHOSCG=0.0647       !    0.0647

      KSN1=0
      KSM1=0
      KCO1=0
      KCOFF=0
      KSCRN=1
      KOUT=0

      NN=9999
      FACT1=1.25         !       1.25
      FACT2=0.50         !       0.50
      TMAX=3650.0        !    3650.0
      WORMAX=20.0        !      20.0
      WOROCK(1)=20.0     !      20.0
      GORMAX=500000.0    !  500000.0
      GOROCK(1)=500000.0 !  500000.0
      PAMIN=100.0        !     100.0
      PAMAX=10000.0      !   10000.0

      KSOL=4
      MITER=100
      OMEGA=1.5          !       1.5
      TOL=0.1            !       0.1
      TOL1=0.001         !       0.001
      DSMAX=0.05         !       0.05
      DPMAX=100.0        !     100.0
      NUMDIS=0
      IRK=0
      THRUIN=0.5         !   0.5
!
!  AquiferS
!    Pot
      I1PAQ(1)=1
      I2PAQ(1)=NX
      J1PAQ(1)=1
      J2PAQ(1)=NY
      K1PAQ(1)=1
      K2PAQ(1)=NZ
!    Steady-state
      I1SAQ(1)=1
      I2SAQ(1)=NX
      J1SAQ(1)=1
      J2SAQ(1)=NY
      K1SAQ(1)=1
      K2SAQ(1)=NZ
!    Carter-Tracy
      I1BAQ(1,1)=1
      I2BAQ(1,1)=NX
      J1BAQ(1,1)=1
      J2BAQ(1,1)=NY
      K1BAQ(1,1)=1
      K2BAQ(1,1)=NZ
!  Blank out well names first
      DO I=1,NWX
        WELNAM(I)=' '
      END DO
      DO I=1,LP11
        DO J=1,LP112
          WELNM(LP11,LP112)=' '
          WELONM(LP11,LP112)=' '
        END DO
      END DO
!   Well data
      NWELLS=1
      WELNAM(1)='PROD1'
      IDWEL(1)=1
      NPW(1)=1
      LWX(1,1)=1
      LWY(1,1)=1
      LWZ(1,1)=1
      IDIR(1,1)=1
      IDWELX(1,1)=IDWEL(1)
      IOMETH(1)=5
      IWLCNG(1)=1
      FTIO(1,1)=1.0     !    1.0
      FTIO(2,1)=100.0   !   100.0
      FTIO(3,1)=200.0   !   200.0
      FTIO(4,1)=300.0   !   300.0
      FTIO(5,1)=400.0   !   400.0
      DAY(1)=0.1        !    0.1
      DTMIN(1)=0.1      !    0.1
      DTMAX(1)=15.0     !   15.0
!   Recurrent data set
      NWELLN(1)=1
      WELNM(1,1)=WELNAM(1)
      IDWELL(1,1)=IDWEL(1)
      WELONM(1,1)=WELNM(1,1)
      IDOWELL(1,1)=IDWELL(1,1)
      LAYER(1,1)=1
      I1NEW(1,1)=1
!      D1NEW(1,1)=IDWEL(1)
!      I1OLD(1,1)=IDWEL(1)
      IQN1(1,1)=LWX(1,1)
      IQN2(1,1)=LWY(1,1)
      IQN3(1,1)=LWZ(1,1)

      PID(1,IQN3(1,1),1)=10.0           !   10.0
      PWF(1,IQN3(1,1),1)=0.0            !    0.0

      KIP(1,1)=1
      QVO(1,1)=50.0                     !   50.0

      END SUBROUTINE

!     Last change:  RJH   5 Jun 97    8:05 am
!     B4SATCAP.FOR
!
!*********************************************************************
!*                    Designed and written by                        *
!*                    Raymond J. Heemstra                            *
!*                    BDM-Oklahoma, Inc.                             *
!*                    Bartlesville, OK 74005                         *
!*********************************************************************
!
      SUBROUTINE B4SATCAP(NR,MSAT,NP,MPOT,MPWT,MPGT,
     &    SAT,KROT,KRWT,KRGT,KROGT,PCOWT,PCGOT,ITHREE,SWR,
     &    POT,MUOT,BOT,RSOT,
     &    PWT,MUWT,BWT,
     &    PGT,MUGT,BGT,PSIT,PRT,CRT,KGCOR,PMAXT,
     &    SATCAP,FileName)
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      INCLUDE 'BAEDPARM.INC'
      CHARACTER*(*) FileName
      INTEGER ITHREE(LP7)
      REAL SWR(LP7)
      REAL SAT(LP7,LP9),KROT(LP7,LP9),KRWT(LP7,LP9),
     &   KRGT(LP7,LP9),KROGT(LP7,LP9),PCOWT(LP7,LP9),PCGOT(LP7,LP9)
      REAL POT(LP8,LP9),MUOT(LP8,LP9),BOT(LP8,LP9),RSOT(LP8,LP9)
      REAL PWT(LP8,LP9),MUWT(LP8,LP9),BWT(LP8,LP9),
     &     PGT(LP8,LP9),MUGT(LP8,LP9),BGT(LP8,LP9),
     &     PSIT(LP8,LP9),PRT(LP8,LP9),CRT(LP8,LP9)
      INTEGER MSAT(LP7),MPOT(LP8)
      INTEGER MPWT(LP8),MPGT(LP8)

      INTEGER BSIZE,PAGESIZE

      CHARACTER*80 WTIT,WINMAIN
      COMMON /B4EDGRP/ IWW,IWH,WTIT,WINMAIN
      COMMON /GRESN/ NXPX,NYPX,NCOLR


      PARAMETER(BSIZE=8,IV=8,IP=16,MB=4)    ! for accept line button field

      PARAMETER(MAXDESC=16)
      CHARACTER*66 DESCRIBE(MAXDESC)
      LOGICAL DIALOG
      CHARACTER PAGENO*19
      CHARACTER*80 HEADER
      CHARACTER*3 SATCAP
      CHARACTER*80 BUFFER
      CHARACTER*80 TITLE
      CHARACTER*2 PIDPWF
      INTEGER ifx(IV*IP+MB+1),ify(IV*IP+MB+1),
     &        ifw(IV*IP+MB+1),ift(IV*IP+MB+1)
      CHARACTER*(BSIZE) BUTTON1,BUTTON2,BUTTON3,BUTTON4
      LOGICAL :: B4ENTER,EQUALS
      DATA BUTTON1 /' ACCEPT '/,BUTTON2 /' CANCEL '/
      DATA BUTTON3 /'  Help  '/,BUTTON4 /' GRAPHS '/
      DATA DESCRIBE /
     &'KROW= oil phase relative permeability, fraction',
     &'KRW = water phase relative permeability, fraction',
     &'KRG = gas phase relative permeability, fraction',
     &'KROG= oil phase relative permeability, gas-oil system, fraction',
     &'PCOW= oil/water capillary pressure, psi',
     &'PCGO= gas/oil capilary pressure, psi',
     &' ',
     &'P    = pressure, psia (in ascending order)   i.e. 14.7 to PMAX ',
     &'MUO, MUW, MUG = saturated oil, water, gas viscosities, cp      ',
     &'BO, BW, BG = saturated oil, water, gas form. vol. fact., RB/STB',
     &'RSO = saturated oil solution gas/oil ratio, SCF/STB            ',
     &'Assume saturated water solution gas/water ratio (RSW = 0.0)    ',
     &'PSI      = gas pseudo-pressure, psi**2/cp  ( only if KGCOR=0 ) ',
     &'CR       = pressure dependent rock compressibility, 1/psi      ',
     &' ',
     &'Accept   = accepts input data for the line of the button  '/

      DIALOG=.TRUE.
      NDIALOG=1
      PAGESIZE=IP
      LASTLINE=0
      NPIDPWF=0
      ISPACE=1
      IZERO=0
      TITLE=' '
      IF (SATCAP.EQ.'PGT') THEN
        IWREAL=12
      ELSE
        IWREAL=10
      END IF
      IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'sat') THEN
        TITLE='Rel. Perm. & Capillary Press. Table'
        WTIT=TITLE
        HEADER='    SAT       KROW      KRW       KRG       KROG'//
     &           '      PCOW      PCGO   Accept'
        NLINES=MSAT(NR)
        NVR=7
        ISET=NR
      ELSE IF(SATCAP.EQ.'POT'.OR.SATCAP.EQ.'pot') THEN
        TITLE='Oil PVT Properties Table'
        WTIT=TITLE
        HEADER='     P        MUO        BO       RSO     Accept'
        IVALUE=MPOT(NP)
        IF (B4ENTER(1,'Number of Entries',IVALUE,
     &     'Oil PVT Properties Table')) THEN
          IF (IVALUE.GT.LP9) THEN
            WRITE(BUFFER,'(A,I2,A)') 'Only ',LP9,
     &       ' table entries allowed!'
            CALL AboutB4(1,TRIM(BUFFER),'Alert')
            IVALUE=LP9
          END IF
          MPOT(NP)=IVALUE
        ELSE
          RETURN
        END IF
        NLINES=MPOT(NP)
        NVR=4
        ISET=NP
      ELSE IF(SATCAP.EQ.'PWT'.OR.SATCAP.EQ.'pwt') THEN
        TITLE='Water PVT Properties Table'
        WTIT=TITLE
        HEADER='    P         MUW       BW        Accept'
        IVALUE=MPWT(NP)
        IF (B4ENTER(1,'Number of Entries',IVALUE,
     &     'Water PVT Properties Table')) THEN
          IF (IVALUE.GT.LP9) THEN
            WRITE(BUFFER,'(A,I2,A)') 'Only ',LP9,
     &       ' table entries allowed!'
            CALL AboutB4(1,TRIM(BUFFER),'Alert')
            IVALUE=LP9
          END IF
          MPWT(NP)=IVALUE
        ELSE
          RETURN
        END IF
        NLINES=MPWT(NP)
        NVR=3
        ISET=NP
      ELSE IF (SATCAP.EQ.'PGT'.OR.SATCAP.EQ.'pgt') THEN
        TITLE='Gas PVT & Rock Compress. Table'
        WTIT=TITLE
        HEADER=
     &'   P           MUG         BG          PSI         CR'//
     &'        Accept'
        IVALUE=MPGT(NP)
        IF (B4ENTER(1,'Number of Entries',IVALUE,
     &     'Gas PVT & Rock Compress. Table')) THEN
          IF (IVALUE.GT.LP9) THEN
            WRITE(BUFFER,'(A,I2,A)') 'Only ',LP9,
     &       ' table entries allowed!'
            CALL AboutB4(1,TRIM(BUFFER),'Alert')
            IVALUE=LP9
          END IF
          MPGT(NP)=IVALUE
        ELSE
          RETURN
        END IF
        NLINES=MPGT(NP)
        NVR=5
        ISET=NP
      ELSE IF (SATCAP.EQ.'KGC'.OR.SATCAP.EQ.'kgc') THEN

!  KGCOR=1 and this is line 17. (Rock compressibility)
        TITLE='Rock Compressiability Table'
        WTIT=TITLE
        HEADER='          PRT     CRT    Accept'
        IVALUE=MPGT(NP)
        IF (B4ENTER(1,'Number of Entries',IVALUE,
     &     'Rock Compressiability Table')) THEN
          IF (IVALUE.GT.LP9) THEN
            WRITE(BUFFER,'(A,I2,A)') 'Only ',LP9,
     &       ' table entries allowed!'
            CALL AboutB4(1,TRIM(BUFFER),'Alert')
            IVALUE=LP9
          END IF
          MPGT(NP)=IVALUE
        ELSE
          RETURN
        END IF
        NLINES=MPGT(NP)
        NVR=2
        ISET=NP

!  default the PRT to PMAX if only one line
        IF (NLINES.EQ.1) THEN
          IF (.NOT. EQUALS(PRT(ISET,NW),PMAXT) ) THEN
            CALL AboutB4(1,'PRT must equal PMAX','Alert')
            PRT(ISET,1)=PMAXT
          END IF
        ELSE
          IF (.NOT. EQUALS(PRT(ISET,NLINES),PMAXT) ) THEN
            CALL AboutB4(1,'Last PRT must equal PMAX','Alert')
            PRT(ISET,NLINES)=PMAXT
          END IF
        END IF
!  end of default

      END IF
      LENTITL=LEN_TRIM(TITLE)
      IFINIT=2
      DO WHILE(DIALOG)
        PAGENO=' '

!  fix of get wrong rows
        NPIDPWF=0
        KEXIT=20
        WRITE(PAGENO,'(A7,I3,A6,I2,A1)') ' region',ISET,' (Page',
     &     NDIALOG,')'
        TITLE(LENTITL+1:LENTITL+20)=PAGENO
        IFD=1
        IROW=1
        NHWDTH=LEN_TRIM(HEADER)+2
        IF(NHWDTH.LT.IWREAL*(NVR+1)) NHWDTH=IWREAL*(NVR+1)
        IF (NHWDTH .LT. LEN_TRIM(TITLE)) NHWDTH=LEN_TRIM(TITLE)

!   Starting column is calculated as ISTRTCOL
        ISTRTCOL=(NHWDTH-3-NVR*IWREAL)/2

!   Header field definition
        ifx(IFD)=2
        ify(IFD)=IROW
        ifw(IFD)=LEN_TRIM(HEADER)
        ift(IFD)=1001
        IROW=IROW+ISPACE     !  space + header = 2 rows extra to fields

!   Data field definitions (Line is 7, 4, 3, 5 or 2 reals, & 1 button)
        DO NW=LASTLINE+1,NLINES
          IROW=IROW+1        ! new row
          ICOL=ISTRTCOL      ! begin in calculated column

!   Real field definitions, NVR reals  -- SAT, KRO, KRW, KRG, etc.
          DO NRR=1,NVR     ! loop for NVR reals
            IFD=IFD+1
            ifx(IFD)=ICOL
            ify(IFD)=IROW      ! same row
            ifw(IFD)=IWREAL    ! real is F10.0 or F12.0
            ift(IFD)=3         !  real=3 , unprotected
            ICOL=ICOL+IWREAL   ! set up for the next real, 10 or 12 to conserve space
          END DO          ! end of DO NRR

!   Do the accept line input selection button in the same row
          ICOL=ICOL+1       ! set to 1 past the end of last real number
          IFD=IFD+1         ! one last field on this line
          ifx(IFD)=ICOL
          ify(IFD)=IROW     ! same row
          ifw(IFD)=2        ! a narrow 2 character accept line button field
          ift(IFD)=5        ! button=5
          IF (IROW.GT.PAGESIZE) EXIT
        END DO         ! end of DO NW

!  Button field definition for MB buttons (ACCEPT, CANCEL, HELP & GRAPHS)
        IROW=IROW+ISPACE
        ICOL=((NHWDTH+IWREAL)/MB)-BSIZE-2
        DO IFDB=IFD+1,IFD+MB
          ifx(IFDB)=ICOL+(IFDB-IFD-1)*(BSIZE+2)
          ify(IFDB)=IROW+1
          ifw(IFDB)=BSIZE
          ift(IFDB)=5
        END DO
        IROW=IROW+1
        ILINES=IROW+1
        IFD=IFD+MB

!  Set control types and options for events, keys, mouse, & frames
        CALL InEventSelect(ResizeExpose,IntYes) ! ResizeExpose=6;IntYes=1
        CALL InControlKey(50,ResizeEvent)
        CALL InMouseOptions(MouseExit,IntYes)   ! MouseExit=2;IntYes=1
        CALL InControlKey(26,577)   ! Alt-A=577(accept);Alt-N=590(next)
        CALL InControlKey(27,579)   ! Alt-C=579(cancel); Alt-Q=593(quit)
        CALL InControlKey(29,129)   ! KeyCursorDown = 129
        CALL InControlKey(30,128)   ! KeyCursorUp   = 128
        CALL InSelectionChars(' ')
        call IFrameType(4)          ! DropShadow = 4; Window3D2 = 10
        call IFrameOptions(4,15)    ! TitleForeCol, TextWhiteBold
        call IFrameOptions(5,5)     ! TitleBackCol, TextBlue
        call IWinAction('FPC')
        call IGrInputOptions(4,1)   ! GINTerminate, GINAnyKey
        call InMouseOptions(102,3)  ! PopupButton,RightButton=3; LeftButton=1
        CALL InMouseOptions(MouseExit,IntYes)  !  MouseExit=2; IntNo=2
        call InHighLight('Black','yellow')

!  Now for the FormPut loop
        DO WHILE (KEXIT.NE.ControlConfirm)   ! ControlConfirm=21
          call IWinWordWrap('JUST')
          call IWinOpenTitle(IZERO,IZERO,NHWDTH,ILINES,TITLE)

!   Begin the form definitions
          CALL IFormDefine('W',IFD,ifx,ify,ifw,ift)
          call IFrameOptions(5,15)  ! TitleForeCol, TextWhiteBold
          call IFrameOptions(4,5)   ! TitleBackCol, TextBlue

!  Place the one string, six or two integers, and 4 reals
          IROW=1
          IFDB=1           !  reset to header field
          IROW=IROW+ISPACE
          IOFFSET=IROW    !  So row count minus offset will be
!                            a button count in the DO NW loop
          DO NW=LASTLINE+1,NLINES
            IROW=IROW+1
            IF (SATCAP.EQ.'SAT') THEN

!      SAT,KROT,KRWT,KRGT
              R1NU=SAT(ISET,NW)
              R2NU=KROT(ISET,NW)
              R3NU=KRWT(ISET,NW)
              R4NU=KRGT(ISET,NW)
            ELSE IF (SATCAP.EQ.'POT') THEN

!      POT,MUOT,BOT,RSOT
              R1NU=POT(ISET,NW)
              R2NU=MUOT(ISET,NW)
              R3NU=BOT(ISET,NW)
              R4NU=RSOT(ISET,NW)
            ELSE IF (SATCAP.EQ.'PWT') THEN

!      PWT,MUWT,BWT
              R1NU=PWT(ISET,NW)
              R2NU=MUWT(ISET,NW)
              R3NU=BWT(ISET,NW)
!              R4NU=RSWT(ISET,NW)       !  adding RSW
            ELSE IF (SATCAP.EQ.'PGT') THEN

!      PGT,MUGT,BGT,PSIT,CRT
              R1NU=PGT(ISET,NW)
              R2NU=MUGT(ISET,NW)
              R3NU=BGT(ISET,NW)
              R4NU=PSIT(ISET,NW)
              R5NU=CRT(ISET,NW)
            ELSE IF (SATCAP.EQ.'KGC') THEN

!      PRT,CRT
              R1NU=PRT(ISET,NW)
              R2NU=CRT(ISET,NW)
            END IF
            IFDB=IFDB+1          !   increment field 2
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'sat') THEN
              CALL IFormPutReal(IFDB,R1NU,'(F10.8)')    !  SAT or POT
            ELSE IF(SATCAP.EQ.'POT'.OR.SATCAP.EQ.'pot'.OR.
     &              SATCAP.EQ.'PWT'.OR.SATCAP.EQ.'pwt'.OR.
     &              SATCAP.EQ.'PGT'.OR.SATCAP.EQ.'pgt'.OR.
     &              SATCAP.EQ.'KGC'.OR.SATCAP.EQ.'kgc' ) THEN
              CALL IFormPutReal(IFDB,R1NU,'(F10.1)')   ! SAT or POT,PWT,PGT,PRT & KGC
            END IF
            IFDB=IFDB+1          !   increment field 3
            CALL IFormAttribute(IFDB,' ','Black','BWhite')
            CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
            CALL IFormPutReal(IFDB,R2NU,'(F10.8)')    !  KROT or MUOT,MUWT,MUGT, CRT

!   Eliminate KGCOR=1 for PGT
            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.SATCAP.EQ.'PWT'
     &                    .OR.SATCAP.EQ.'PGT') THEN
              IFDB=IFDB+1          !   increment field 4
              CALL IFormAttribute(IFDB,' ','Black','BWhite')
              CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
              CALL IFormPutReal(IFDB,R3NU,'(F10.8)')    !  KRWT or BOT,BWT,BGT
            END IF

!  R4 for SAT,POT,PGT
            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.
     &                        SATCAP.EQ.'PGT') THEN
              IFDB=IFDB+1          !   increment field 5
              CALL IFormAttribute(IFDB,' ','Black','BWhite')
              CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
              IF (SATCAP.EQ.'SAT') THEN
                CALL IFormPutReal(IFDB,R4NU,'(F10.8)')   !  KRGT
              ELSE IF(SATCAP.EQ.'POT') THEN
                CALL IFormPutReal(IFDB,R4NU,'(F10.2)')   !  RSOT, PSIT
              ELSE IF(SATCAP.EQ.'PGT') THEN
                CALL IFormPutReal(IFDB,R4NU,'(G12.5)')   !  RSOT, PSIT
              END IF
              IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'sat') THEN

!      KROGT,PCOWT,PCGOT
                IFDB=IFDB+1        !   increment field 6
                R5NU=KROGT(ISET,NW)
                CALL IFormAttribute(IFDB,' ','Black','BWhite')
                CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
                CALL IFormPutReal(IFDB,R5NU,'(F10.2)')      !  KROGT
                IFDB=IFDB+1        !   increment field 7
                R6NU=PCOWT(ISET,NW)
                CALL IFormAttribute(IFDB,' ','Black','BWhite')
                CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
                CALL IFormPutReal(IFDB,R6NU,'(F10.2)')      !  PCOWT
                IFDB=IFDB+1        !   increment field 8
                R7NU=PCGOT(ISET,NW)
                CALL IFormAttribute(IFDB,' ','Black','BWhite')
                CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
                CALL IFormPutReal(IFDB,R7NU,'(F10.5)')      ! PCGOT
              ELSE IF(SATCAP.EQ.'PGT') THEN

!   R5 for CRT(kgcor=0)
                IFDB=IFDB+1        !   increment field 6
                R5NU=CRT(ISET,NW)
                CALL IFormAttribute(IFDB,' ','Black','BWhite')
                CALL IFormFrame(IFDB,Field3D1,'Black','BWhite')  ! Field3D1=5
                CALL IFormPutReal(IFDB,R5NU,'(F10.7)')      !  CRT

              END IF
            END IF

!   Do last button field put for PID/PWF arrays
!            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'sat') THEN
!  Pass the I1NU value from the button field position, each must be unique!
              IFDB=IFDB+1        !   increment field 9 to the button field
              WRITE(PIDPWF,'(I2)') NW
              IBUTTON=IFDB-NVR*(IROW-2)-1
              call IFormPutButton(IFDB,PIDPWF,IBUTTON)   ! PID/PWF selection=1 to 15
              call IFormAttribute(IFDB,' ','Black','White')
              call IFormFrame(IFDB,7,'BWhite','Black') ! Button3D1=7
!       Pick up the data entry in the InFormGet unit
!       using the KEXIT code of 48 but what K, NW, ISET values?
!       K is LAY, NW & ISET are same as in KIP
            IF (IROW.GT.PAGESIZE) EXIT
          END DO           !   DO NW
          NBUTT=IROW-IOFFSET
          call IFrameOptions(4,15)     ! TitleForeCol, TextWhiteBold
          call IFrameOptions(5,5)      ! TitleBackCol, TextBlue

!  ACCEPT
          call IFormPutButton(IFDB+1,BUTTON1,21)     ! ControlConfirm=21
          call IFormAttribute(IFDB+1,' ','Black','White')
          call IFormFrame(IFDB+1,7,'BWhite','Black') ! Button3D1=7

!  CANCEL
          call IFormPutButton(IFDB+2,BUTTON2,23)     ! ControlQuit=23
          call IFormAttribute(IFDB+2,' ','Black','White')
          call IFormFrame(IFDB+2,7,'BWhite','Black')

!  HELP
          call IFormPutButton(IFDB+3,BUTTON3,22)     ! ControlHelp=22
          call IFormAttribute(IFDB+3,' ','Black','White')
          call IFormFrame(IFDB+3,7,'BWhite','Black')

!  GRAPHS
          call IFormPutButton(IFDB+4,BUTTON4,104)    ! GRAPHS=104
          call IFormAttribute(IFDB+4,' ','Black','White')
          call IFormFrame(IFDB+4,7,'BWhite','Black')

!   Place the heading on the first line
          CALL IFormPutString(1,TRIM(HEADER))
          CALL InPopUp('on')
          CALL InMouseOptions(MouseExit,IntYes)

!   Show everthing in forms
          call IFormShow

!   Edit the forms and use buttons
          call IFormEdit(IFINIT,IFEXIT)
          KEXIT=InfoInput(55)          ! LastExitKey=55; LastGINExit=57
          CALL InPopUp('off')
          CALL InMouseOptions(MouseExit,IntNo)
          IF (KEXIT.GE.1.AND.KEXIT.LE.NBUTT) THEN
            NPIDPWF=KEXIT
          ELSE
            NPIDPWF=0
          END IF
          IF(KEXIT.EQ.ControlQuit) THEN               !  CANCEL button
            KEXIT=ControlConfirm
            DIALOG=.false.
            EXIT

!  Was the help button pushed?
          ELSE IF(KEXIT.EQ.ControlHelp) THEN
            CALL AboutB4(MAXDESC,DESCRIBE,
     &       'Help on meaning of various terms')
            KEXIT=20
            IROW=1
            IFINIT=IFEXIT
            CALL IWinClose(1)
            CALL IScreenBackground('blue','blue')

!  Was the graph button pushed?
          ELSE IF(KEXIT.EQ.104) THEN
            KEXIT=20
            IROW=1
            IFINIT=IFEXIT
            CALL IWinClose(1)
            CALL IScreenBackground('blue','blue')
            CALL B4GRAF2D(SATCAP,NR,NP,FileName)

!  The right column of buttons have a selection and must determine line.
          ELSE IF ((NPIDPWF.GE.1.AND.NPIDPWF.LE.NBUTT)) THEN    ! 1 to 15

!   Multiple pages will increment the array position to fit the button number
            IPICK=NPIDPWF+LASTLINE
            KEXIT=20
!   Begin the process of accepting the input data of the well selected
!   by the PID/PWF butto, NPIDPWF, to the right.
!
            IFD=(NPIDPWF-1)*(NVR+1)+2

!  All curves have at least two input columns plus buttons
            CALL IFormGetReal(IFD,R1NU)
            IFD=IFD+1
            CALL IFormGetReal(IFD,R2NU)

!   Discriminate on basis of SATCAP
            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.SATCAP.EQ.'PWT'
     &          .OR.SATCAP.EQ.'PGT') THEN
              IFD=IFD+1
              CALL IFormGetReal(IFD,R3NU)
            END IF
            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.
     &                              SATCAP.EQ.'PGT') THEN
              IFD=IFD+1
              CALL IFormGetReal(IFD,R4NU)
            END IF
            IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'PGT') THEN
              IFD=IFD+1
              CALL IFormGetReal(IFD,R5NU)
            END IF
            IF (SATCAP.EQ.'SAT') THEN
              IFD=IFD+1
              CALL IFormGetReal(IFD,R6NU)
              IFD=IFD+1
              CALL IFormGetReal(IFD,R7NU)
            END IF
            IF (SATCAP.EQ.'SAT') THEN

!      SAT,KROT,KRWT,KRGT
              SAT(ISET,IPICK)=R1NU
              KROT(ISET,IPICK)=R2NU
              KRWT(ISET,IPICK)=R3NU
              KRGT(ISET,IPICK)=R4NU
              KROGT(ISET,IPICK)=R5NU
              PCOWT(ISET,IPICK)=R6NU
              PCGOT(ISET,IPICK)=R7NU
            ELSE IF (SATCAP.EQ.'POT') THEN

!      POT,MUOT,BOT,RSOT
              POT(ISET,IPICK)=R1NU
              MUOT(ISET,IPICK)=R2NU
              BOT(ISET,IPICK)=R3NU
              RSOT(ISET,IPICK)=R4NU
            ELSE IF (SATCAP.EQ.'PWT') THEN

!      PWT,MUWT,BWT
              PWT(ISET,IPICK)=R1NU
              MUWT(ISET,IPICK)=R2NU
              BWT(ISET,IPICK)=R3NU
!              RSWT(ISET,IPICK)=R4NU
            ELSE IF (SATCAP.EQ.'PGT') THEN

!      PGT,MUGT,BGT,PSIT,CRT
                PGT(ISET,IPICK)=R1NU
                MUGT(ISET,IPICK)=R2NU
                BGT(ISET,IPICK)=R3NU
                PSIT(ISET,IPICK)=R4NU
                CRT(ISET,IPICK)=R5NU
            ELSE IF (SATCAP.EQ.'KGC') THEN

!      PRT,CRT
                PRT(ISET,IPICK)=R1NU
                CRT(ISET,IPICK)=R2NU
            END IF

!   Fixes the last button problem, as in R4RECURR subroutine
C            IF (NPIDPWF.EQ.NBUTT) THEN
C              LASTLINE=NPIDPWF+LASTLINE
C              NDIALOG=NDIALOG+1
C              KEXIT=ControlConfirm
C              IFINIT=2
C              IF (LASTLINE.LT.NLINES) THEN
C                DIALOG=.TRUE.
C              ELSE IF(NBUTT.EQ.1.OR.NBUTT.EQ.NLINES) THEN
C                LASTLINE=0
C                NDIALOG=NDIALOG-1
C              ELSE
C                DIALOG=.FALSE.
C              END IF
C            END IF

            IFD=IFD+1

!   End of well line acceptance code
            CALL IScreenBackground('blue','blue')
            CALL IWinClose(1)
           IROW=1

!   Initial cursor to field number of next well after PID/PWF exit key
            IFINIT=(NPIDPWF-1)*(NVR+1)+(NVR+3)
            KEXIT=ControlConfirm
            EXIT
          ELSE IF(KEXIT.EQ.50) THEN                   !  Resize event
            KEXIT=20
            CALL IWinClose(1)
            CALL IScreenBackground('blue','blue')
            IROW=1
            IFINIT=IFEXIT
          ELSE IF(KEXIT.EQ.ControlConfirm) THEN       !  ACCEPT button

!   Get the string and integers
            IFDB=1
            IROW=2
            DO NW=LASTLINE+1,NLINES
              IROW=IROW+1
              IFDB=IFDB+1
              CALL IFormGetReal(IFDB,R1NU)
              IFDB=IFDB+1
              CALL IFormGetReal(IFDB,R2NU)
              IF(SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.SATCAP.EQ.'PWT'
     &                            .OR.SATCAP.EQ.'PGT') THEN
                IFDB=IFDB+1
                CALL IFormGetReal(IFDB,R3NU)
              END IF
              IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.
     &                                SATCAP.EQ.'PGT') THEN
                IFDB=IFDB+1
                CALL IFormGetReal(IFDB,R4NU)
              END IF
              IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'PGT') THEN
                IFDB=IFDB+1
                CALL IFormGetReal(IFDB,R5NU)
              END IF
              IF (SATCAP.EQ.'SAT') THEN
                IFDB=IFDB+1
                CALL IFormGetReal(IFDB,R6NU)
                IFDB=IFDB+1
                CALL IFormGetReal(IFDB,R7NU)
              END IF

!   Now discriminate between the rel. perm. & cap. press. curves
              IF (SATCAP.EQ.'SAT') THEN

!      SAT,KROT,KRWT,KRGT
                SAT(ISET,NW)  =R1NU
                KROT(ISET,NW) =R2NU
                KRWT(ISET,NW) =R3NU
                KRGT(ISET,NW) =R4NU

!      KROGT,PCOWT,PCGOT
                KROGT(ISET,NW)=R5NU
                PCOWT(ISET,NW)=R6NU
                PCGOT(ISET,NW)=R7NU
              ELSE IF (SATCAP.EQ.'POT') THEN

!      POT,MUOT,BOT,RSOT
                POT(ISET,NW)  =R1NU
                MUOT(ISET,NW) =R2NU
                BOT(ISET,NW)  =R3NU
                RSOT(ISET,NW) =R4NU
              ELSE IF (SATCAP.EQ.'PWT') THEN

!      PWT,MUWT,BWT
                PWT(ISET,NW)  =R1NU
                MUWT(ISET,NW) =R2NU
                BWT(ISET,NW)  =R3NU
              ELSE IF (SATCAP.EQ.'PGT') THEN
C      PGT,MUGT,BGT,PSIT
                PGT(ISET,NW) =R1NU
                MUGT(ISET,NW)=R2NU
                BGT(ISET,NW) =R3NU
                PSIT(ISET,NW)=R4NU
                CRT(ISET,NW) =R5NU
              ELSE IF (SATCAP.EQ.'KGC') THEN
                PRT(ISET,NW) =R1NU
                CRT(ISET,NW) =R2NU
              END IF         !  end if SATCAP

!    Increment the field IFDB for the extra button on the right end
              IFDB=IFDB+1

!    Replace variables with new input
              IFINIT=2
              IF (IROW.GT.PAGESIZE) THEN
                NDIALOG=NDIALOG+1
                LASTLINE=NW                   !   Set the last well number
                KEXIT=ControlConfirm
                IF (LASTLINE.LT.NLINES) THEN
                  DIALOG=.true.
                ELSE
                  DIALOG=.false.
                END IF
                EXIT
              ELSE
                DIALOG=.false.
              END IF
            END DO              ! End of DO NW
          ELSE
            CALL IScreenBell('2')
            KEXIT=20
            IROW=1
            IFINIT=IFEXIT
          END IF                !   end of IF KEXIT
        END DO    !   end DO WHILE KEXIT
        CALL InMouseOptions(MouseExit,IntNo)     ! MouseExit=2;IntNo=0
        CALL IWinClose(3)
        CALL IScreenBackground('blue','blue')
      END DO     !  end DO WHILE DIALOG is TRUE
      END SUBROUTINE

!     B4CAPP.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE B4CAPP(NR,OKAY)
      INCLUDE 'BAEDPARM.INC'
      INCLUDE 'BED.INC'
      LOGICAL OKAY
      PARAMETER (IBASE=11)
      CHARACTER*80 TITLE,PROMPTS(3),STRINGS(IBASE+4)
      CHARACTER BUFFER
      CHARACTER*80 WTIT,WINMAIN
      COMMON /B4EDGRP/ IWW,IWH,WTIT,WINMAIN
      COMMON /GRESN/ NXPX,NYPX,NCOLR

C      CHARACTER BUFFER(28)
      LOGICAL B4MIX
      INTEGER NUMBERS(2)
C      IBASE=11
C      WRITE(BUFFER,*) 'Saturation table entries = ',MSAT(NR)
C      CALL AboutB4(1,BUFFER,'Debug notice')
      IF (MSAT(NR).GE.IBASE) THEN
        MBEGIN=MSAT(NR)-IBASE
      ELSE
        MBEGIN=1
      END IF
      NERR=1
       WRITE(TITLE,*,ERR=999) 'Capillary Pressure for region ',NR
       WTIT=TITLE
C       WRITE(BUFFER(1),*)'KROG is used only with 3-phase calculations'
C       WRITE(BUFFER(2),*)
C       WRITE(STRINGS(1),*)'KROG is used only with 3-phase calculations'
       WRITE(STRINGS(1),*)
     &   ' N    SAT    KROW    KRW    KRG    KROG   PCOW    PCGO'
       DO I=MBEGIN,MSAT(NR)
C         WRITE(BUFFER(I+2),
         J=I-MBEGIN+1
         NERR=I+1
         WRITE(STRINGS(J+1),
     &     '(I2,A,1X,F5.3,1X,F7.5,1X,F6.4,1X,F7.5,1X,3(F7.3,1X))',
     &     ERR=999)
     &     I,'. ',SAT(NR,I),KROT(NR,I),KRWT(NR,I),KRGT(NR,I),
     &     KROGT(NR,I),PCOWT(NR,I),PCGOT(NR,I)
       END DO
C       WRITE(BUFFER(MSAT(NR)+3),*)'ITHREE=',ITHREE(NR),' SWR=',SWR(NR)
C       CALL AboutB4(MSAT(NR)+3,BUFFER,TITLE)
C   Three phase switch here
C        ITHREE(NR), SWR(NR)
c        NUMBERS=ITHREE(NR)
      ISTRG=MSAT(NR)-MBEGIN+2 ! MBEGIN=MSAT(NR)-IBASE or ISTRG=IBASE+2
      NUMBERS(2)=ITHREE(NR)
      RVALUES=SWR(NR)
      TITLE='Three-phase Oil Relative Permeability Option'
      STRINGS(ISTRG+1)='KROG used only for 3-phase oil calculations'//
     &', KROW & KRW represent'
      STRINGS(ISTRG+2)='a water-oil system while KROG & KRG represe'//
     &'nt a gas oil system.'
c       STRINGS(ISTRG+3)='The next entry permits increasing the table.'
c       PROMPTS(1)='Three-phase calculation, (Yes=1, No=0)'
c       PROMPTS(2)='Irreducible water saturation, fraction'
c       IF (B4MIX(4,STRINGS,PROMPTS,1,NUMBERS,1,RVALUES,TITLE)) THEN
c         ITHREE(NR)=NUMBERS
c         SWR(NR)=RVALUES
c       END IF
c
      NUMBERS(1)=MSAT(NR)
      PROMPTS(1)='Number of entries to relative perm. table'
      PROMPTS(2)='Three-phase calculation,    (Yes=1, No=0)'
      PROMPTS(3)='Irreducible water saturation, fraction'
      IF (B4MIX(ISTRG+2,STRINGS,PROMPTS,2,NUMBERS,1,RVALUES,TITLE)) THEN
        OKAY=.TRUE.
        IF (NUMBERS(1).GT.LP9) THEN
          NERR=30
          WRITE(BUFFER,'(A,I2,A)',ERR=999) 'Only ',LP9,
     &     ' table entries allowed!'
          CALL AboutB4(1,TRIM(BUFFER),'Alert')
          NUMBERS(1)=LP9
          OKAY=.FALSE.
          RETURN
        END IF
        MSAT(NR)=NUMBERS(1)
        ITHREE(NR)=NUMBERS(2)
        SWR(NR)=RVALUES
      ELSE
        OKAY=.FALSE.
      END IF
      RETURN
999   WRITE(BUFFER,*) 'B4CAPP error number ',NERR
      CALL AboutB4(1,TRIM(BUFFER),'B4CAPP error')
      END SUBROUTINE

!     B4GRAF2D.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE B4GRAF2D(SATCAP,NR,NP,FileName)
      INCLUDE 'BAEDPARM.INC'
      INCLUDE 'BED.INC'
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      CHARACTER*80 WTIT,WINMAIN
      COMMON /B4EDGRP/ IWW,IWH,WTIT,WINMAIN
      COMMON /GRESN/ NXPX,NYPX,NCOLR

      CHARACTER*(*) FileName
      CHARACTER*64 FILESAVE
      CHARACTER*3 SATCAP
      CHARACTER*50 XLABEL,OILLABEL,Y1LABEL,Y2LABEL,Y3LABEL
      CHARACTER*50 GASLABEL,Y4LABEL,KROGLABE
      CHARACTER*50 SATLABEL,KROLABEL,KRWLABEL,KRGLABEL
      CHARACTER*50 POTLABEL,MUOLABEL,BOTLABEL,RSOLABEL
      CHARACTER*50          MUWLABEL,BWTLABEL
      CHARACTER*50          MUGLABEL,BGTLABEL
      CHARACTER*50 PRTLABEL,CRTLABEL
      REAL Y1VAL(LP9),Y2VAL(LP9),Y3VAL(LP9),Y4VAL(LP9),Y5VAL(LP9),
     &     Y6VAL(LP9)
      REAL XVAL(LP9),X1VAL(LP9)
      INTEGER F5
      DATA F5 /175/
      DATA SATLABEL /'Water Saturation, fraction'/
      DATA OILLABEL  /'Oil Saturation, fraction'/
      DATA KROLABEL /'Rel. Oil Perm.'/
      DATA KRWLABEL /'Rel. Water Perm.'/
      DATA KRGLABEL /'Rel. Gas Perm.'/

      DATA GASLABEL /'Total liquid Sat., fraction'/   ! Irreducible water + oil sat.
      DATA KROGLABE /'Rel. Oil Perm.(gas-oil)'/      ! KROGT

      DATA POTLABEL /'Pressure, psi'/
      DATA MUOLABEL /'Oil Viscosity, cp'/
      DATA BOTLABEL /'Oil FVF, RB/STB'/
      DATA RSOLABEL /'Oil SGOR, SCF/STB'/

      DATA MUWLABEL /'Water Viscosity, cp'/
      DATA BWTLABEL /'Water FVF, RB/STB'/

      DATA MUGLABEL /'Gas Viscosity, cp'/
      DATA BGTLABEL /'Gas FVF, RB/STB'/

      DATA PRTLABEL /'Rock pressure, psia'/
      DATA CRTLABEL /'Rock compressibility'/

!  Put title in graphic window
      CALL IScreenTitle('G',TRIM(WTIT))
      call IScreenMode('G',NXPX,NYPX,NCOLR)
      NSETS=1
      IF (SATCAP.EQ.'SAT') THEN
        XLABEL=SATLABEL
        Y1LABEL=KROLABEL
        Y2LABEL=KRWLABEL
        Y3LABEL=KRGLABEL
        Y4LABEL=KROGLABE           ! KROGT
        NDATA=MSAT(NR)
        DO I=1,NDATA
          XVAL(I)=SAT(NR,I)
          X1VAL(I)=1.-SAT(NR,I)
          Y1VAL(I)=KROT(NR,I)
          Y2VAL(I)=KRWT(NR,I)
          Y3VAL(I)=KRGT(NR,I)
          Y4VAL(I)=PCOWT(NR,I)
          Y5VAL(I)=PCGOT(NR,I)
          Y6VAL(I)=KROGT(NR,I)      ! KROGT
        END DO
      ELSE IF(SATCAP.EQ.'POT') THEN
        XLABEL=POTLABEL
        Y1LABEL=MUOLABEL
        Y2LABEL=BOTLABEL
        Y3LABEL=RSOLABEL
        NDATA=MPOT(NP)
        DO I=1,NDATA
          XVAL(I)=POT(NP,I)
          X1VAL(I)=POT(NP,I)
          Y1VAL(I)=MUOT(NP,I)
          Y2VAL(I)=BOT(NP,I)
          Y3VAL(I)=RSOT(NP,I)
        END DO
      ELSE IF(SATCAP.EQ.'PWT') THEN
        XLABEL=POTLABEL
        Y1LABEL=MUWLABEL
        Y2LABEL=BWTLABEL
        NDATA=MPWT(NP)
        DO I=1,NDATA
          XVAL(I)=PWT(NP,I)
          X1VAL(I)=PWT(NP,I)
          Y1VAL(I)=MUWT(NP,I)
          Y2VAL(I)=BWT(NP,I)
        END DO
      ELSE IF(SATCAP.EQ.'PGT') THEN
        XLABEL=POTLABEL
        Y1LABEL=MUGLABEL
        Y2LABEL=BGTLABEL
        NDATA=MPGT(NP)
        DO I=1,NDATA
          XVAL(I)=PGT(NP,I)
          X1VAL(I)=PGT(NP,I)
          Y1VAL(I)=MUGT(NP,I)
          Y2VAL(I)=BGT(NP,I)
        END DO
      ELSE IF(SATCAP.EQ.'KGC') THEN
        XLABEL=PRTLABEL
        Y1LABEL=CRTLABEL
        Y2LABEL=CRTLABEL
        NDATA=MPWT(NP)
        DO I=1,NDATA
          XVAL(I)=PRT(NP,I)
          X1VAL(I)=PRT(NP,I)
          Y1VAL(I)=CRT(NP,I)
          Y2VAL(I)=CRT(NP,I)
        END DO
      END IF
      IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT'.OR.
     &    SATCAP.EQ.'PWT'.OR.SATCAP.EQ.'PGT'.OR.
     &    SATCAP.EQ.'KGC') THEN
        CALL IGrArea(0.0,0.0,1.0,1.0)  !   0.0,0.0,1.0,1.0

!                  xleft,ylower,xright,yupper
        CALL IPgArea(0.20,0.20,0.80,0.95)  !   0.20,0.20,0.80,0.95
        CALL IGrAreaClear

!      left curve
        CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
        CALL IPgStyle(1,4,0,0,127,0)      !  cyan=127

!   Find max & min x - coordinate
        CALL IRealMaxMin1(XVAL,NDATA,XL1,XL2)
        IF(XL1.GT.0.0) XL1=FLOAT(0)

!   Find max & min Y value
        CALL IRealMaxMin1(Y1VAL,NDATA,Y1L1,Y1L2)
        CALL IRealMaxMin1(Y2VAL,NDATA,Y2L1,Y2L2)
        CALL IRealMaxMin1(Y3VAL,NDATA,Y3L1,Y3L2)
        CALL IRealMaxMin1(Y6VAL,NDATA,Y6L1,Y6L2)
        IF (SATCAP.EQ.'SAT') THEN
          IF(Y1L1.GT.0.0) Y1L1=0.0
          IF(Y2L1.GT.0.0) Y2L1=0.0
          IF(Y3L1.GT.0.0) Y3L1=0.0       !  New for (krg) gas perm. min
          IF(Y6L1.GT.0.0) Y6L1=0.0       !  New for (krog) gas-oilperm. min
          IF(Y1L2.GT.Y2L2) THEN
            YMIN=Y1L1
            YMAX=Y1L2
          ELSE
            YMIN=Y2L1
            YMAX=Y2L2
          END IF
!          IF (Y3L2.GT.Y1L2) THEN     !   New for (krg,krw vs 1-sat)
!            Y1MIN=Y3L1      !  New krg min
!            Y1MAX=Y3L2      !  New krg max
!          ELSE
!            Y1MIN=Y1L1      !  New krw min
!            Y2MAX=Y1L2      !  New krw max
!          END IF
        ELSE
          YMIN=Y1L1
          YMAX=Y1L2
        END IF

!   ******************* 1st PLOT  **************************
        XMIN=XL1
        XMAX=XL2
        CALL IGrColour('cyan')
        CALL IPgStyle(1,4,0,0,127,0)       ! cyan=127
        CALL IPgAxes
        CALL IGrCharSize(1.0,1.0)     !   1.0,1.0
        CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
        CALL IPgXScale('TN')

!  X LABEL:   Water Saturation, fraction
        CALL IPgXLabel(TRIM(XLABEL),'C')

!      left curve is oil
        CALL IGrColour('green')           ! green=95 for oil
        CALL IPgStyle(1,4,0,0,95,0)       ! green=95    solid=0,dot=1
        CALL IPgYScaleLeft('TN')

!  GRAPH:     X1VAL is Water Sat.; Y1VAL is Oil
        CALL IPgXYPairs(X1VAL,Y1VAL)                      ! kro plot on left

!  Y LABEL:   Y1LABEL is Relative Oil Permeability
        CALL IPgYLabelLeft(TRIM(Y1LABEL),'C')

!      right curve is water
        CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
        CALL IGrColour('yellow')       ! yellow=63
        CALL IPgStyle(1,4,0,0,63,0)    ! yellow=63, dotdatdash=4
        CALL IGrCharSize(1.0,1.0)       !   1.0,1.0
        IF(SATCAP.EQ.'SAT') THEN
          CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
        ELSE
          CALL IRealMaxMin1(Y2VAL,NDATA,Y2MIN,Y2MAX)
          CALL IPgUnits(XMIN,Y2MIN,XMAX,Y2MAX)
        END IF
        CALL IPgYScaleRight('TN')

!      Y2LABEL is 'Rel. Water Perm.'
        CALL IPgYLabelRight(TRIM(Y2LABEL),'C')

        CALL IPgStyle(1,4,0,0,63,0)    ! yellow=63

!      XVAL is Water Sat.; Y2VAL is Water
        CALL IPgXYPairs(XVAL,Y2VAL)                       ! krw plot on right

        CALL IGrColour('cyan')
        CALL IPgStyle(1,4,0,0,127,0)    ! cyan=127
        CALL InKeyEvent(KEY)

!     Capture an image using the F5 function key
        IF (KEY.EQ.F5) THEN
          FILESAVE=FileName
          CALL B4CAPTUR(FILESAVE)
        END IF
        IF (SATCAP.EQ.'SAT'.OR.SATCAP.EQ.'POT') THEN

!   ******************* 2nd PLOT  **************************
          CALL IGrAreaClear
          IF (SATCAP.EQ.'SAT') THEN
            IF (Y3L2.GT.Y1L2) THEN     !   New for (krg,krw vs 1-sat)
              YMIN=Y3L1      !  New krg min
              YMAX=Y3L2      !  New krg max
            ELSE
              YMIN=Y6L1      !  New krog min
              YMAX=Y6L2      !  New krog max
            END IF
          END IF
          IF (SATCAP.EQ.'POT') THEN
            CALL IRealMaxMin1(Y1VAL,NDATA,Y1MIN,Y1MAX)
              YMIN=Y1MIN
              YMAX=Y1MAX
          END IF

!      left curve is oil perm.        *** should be gas perm.????
          CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
          CALL IPgStyle(1,4,0,0,127,0)      !  Cyan=127
          CALL IGrCharSize(1.0,1.0)     !   1.0,1.0

          CALL IGrColour('cyan')
          CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
          CALL IPgAxes
          CALL IPgXScale('TN')
          IF(SATCAP.EQ.'SAT') THEN     ! New
!      X1LABEL is 'Oil Saturation, fraction'--had been Water Sat.
            CALL IPgXLabel(TRIM(OILLABEL),'C')  !  New (had been XLABEL)
          ELSE
            CALL IPgXLabel(TRIM(XLABEL),'C')
          END IF
          CALL IGrColour('green')
          CALL IPgStyle(1,4,0,0,95,0)       ! green=95 for oil
          CALL IPgYScaleLeft('TN')

          IF(SATCAP.EQ.'SAT') THEN
            CALL IPgXYPairs(X1VAL,Y3VAL)                ! New krg plot on left
            CALL IPgYLabelLeft(TRIM(Y3LABEL),'C')       ! New
          ELSE
            CALL IPgXYPairs(X1VAL,Y1VAL)               !  Left curve
            CALL IPgYLabelLeft(TRIM(Y1LABEL),'C')      !  rso on left
          END IF
!      right curve is gas perm.    **  x-axis should be oil saturation **
!                             y1val is gas    y2 is oil
          IF(SATCAP.EQ.'POT') THEN
            CALL IRealMaxMin1(Y3VAL,NDATA,Y3MIN,Y3MAX)
            YMAX=Y3MAX
            YMIN=Y3MIN
          ELSE
            Y3MIN=YMIN
            Y3MAX=YMAX
          END IF
          CALL IGrUnits(XMIN,YMIN,XMAX,YMAX)
          CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
          CALL IGrColour('red')
          CALL IPgStyle(1,4,0,0,31,0)       ! red=31 for gas

          CALL IPgUnits(XMIN,Y3MIN,XMAX,Y3MAX)
          CALL IPgYScaleRight('TN')
          IF(SATCAP.EQ.'SAT') THEN
            CALL IPgXYPairs(XVAL,Y6VAL)                ! krog on right
            CALL IPgYLabelRight(TRIM(Y4LABEL),'C')
          ELSE
            CALL IPgXYPairs(XVAL,Y3VAL)                ! RSO on right
            CALL IPgYLabelRight(TRIM(Y3LABEL),'C')
          END IF

          CALL IGrColour('Green')
          CALL InKeyEvent(KEY)
!     Capture an image using the F5 function key
          IF(KEY.EQ.F5) THEN
            FILESAVE=FileName
            CALL B4CAPTUR(FILESAVE)
          END IF
        END IF
!   Third curve for KROG
        IF (SATCAP.EQ.'SAT'.AND.Y6L2.GT.0) THEN
!   ******************* 3rd PLOT  **************************
!   Plot of KROG vs total liquid (Irreducible water + oil saturation)
          CALL IGrArea(0.0,0.0,1.0,1.0)  !   0.0,0.0,1.0,1.0
!                  xleft,ylower,xright,yupper
          CALL IPgArea(0.20,0.20,0.80,0.95)  !   0.20,0.20,0.80,0.95
          CALL IGrAreaClear
!      left curve
          CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
          CALL IPgStyle(1,4,0,0,127,0)      !  cyan=127
!   Find max & min x - coordinate
          CALL IRealMaxMin1(XVAL,NDATA,XL1,XL2)
          IF(XL1.GT.0.0) XL1=FLOAT(0)
          XLABEL=GASLABEL
          XMIN=XL1
          XMAX=XL2
          YMIN=Y6L1
          YMAX=Y6L2
          CALL IGrColour('cyan')
          CALL IPgStyle(1,4,0,0,127,0)       ! cyan=127
          CALL IPgAxes
          CALL IGrCharSize(1.0,1.0)     !   1.0,1.0
          CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
          CALL IPgXScale('TN')
!  X LABEL:   Water Saturation, fraction
          CALL IPgXLabel(TRIM(XLABEL),'C')
!      left curve is oil in gas-oil system
          CALL IGrColour('green')           ! green=95 for oil
          CALL IPgStyle(1,4,0,0,95,0)       ! green=95    solid=0,dot=1
          CALL IPgYScaleLeft('TN')
!  GRAPH:     X1VAL is Water Sat.; Y6VAL is Oil in gas-oil
          CALL IPgXYPairs(XVAL,Y6VAL)                    ! kroG plot on left
!  Y LABEL:   Y1LABEL is Relative Oil Permeability
          CALL IPgYLabelLeft(TRIM(Y4LABEL),'C')
          CALL InKeyEvent(KEY)
!          IF(KEY.EQ.F5) CALL B4CAPT(FileName,FILESAVE)
          IF(KEY.EQ.F5) THEN
            FILESAVE=FileName
            CALL B4CAPTUR(FILESAVE)
          END IF
!  End of KROG plot vs total liquid
        END IF
! *************** Capillary Pressure tables include 2 curves **************
        IF (SATCAP.EQ.'SAT') THEN
          IF (PCOWT(NR,1).GT.0.0.OR.PCGOT(NR,1).GT.0.0) THEN
        CALL IGrArea(0.0,0.0,1.0,1.0)  !   0.0,0.0,1.0,1.0
!                  xleft,ylower,xright,yupper
        CALL IPgArea(0.20,0.20,0.80,0.95)  !   0.20,0.20,0.80,0.95
        CALL IGrAreaClear
!  Left curve of PCOWT is the first curve
            CALL IRealMaxMin1(Y4VAL,NDATA,YMIN,YMAX)
            CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
            CALL IPgStyle(1,4,0,0,127,0)      !  Cyan=127
            CALL IGrCharSize(1.0,1.0)         !   1.0,1.0
            CALL IGrColour('cyan')
            CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
            CALL IPgAxes
            CALL IPgXScale('TN')
!        X LABEL:   Water Saturation, fraction
            CALL IPgXLabel(TRIM(XLABEL),'C')
!        left curve is oil/water capillary pressure
            CALL IGrColour('green')           ! green=95 for pcow
            CALL IPgStyle(1,4,0,0,95,0)       ! green=95    solid=0,dot=1
            CALL IPgYScaleLeft('TN')
!    GRAPH:     X1VAL is Water Sat.; Y4VAL is PCOWT
            CALL IPgXYPairs(X1VAL,Y4VAL)      ! pcow plot on left
!  Y LABEL:   Y1LABEL is Relative Oil Permeability
            CALL IPgYLabelLeft('Oil/Water Cap. Press.','C')
            CALL InKeyEvent(KEY)
!            IF(KEY.EQ.F5) CALL B4CAPT(FileName,FILESAVE)
            IF(KEY.EQ.F5) THEN
              FILESAVE=FileName
              CALL B4CAPTUR(FILESAVE)
            END IF

!  Another left curve of PCGOT is the second curve
            CALL IGrAreaClear
            CALL IRealMaxMin1(Y5VAL,NDATA,YMIN,YMAX)
            CALL IPgNewGraph(NSETS,NDATA,' ',' ','XY')
            CALL IPgStyle(1,4,0,0,127,0)      !  Cyan=127
            CALL IGrCharSize(1.0,1.0)         !   1.0,1.0
            CALL IGrColour('cyan')
            CALL IPgUnits(XMIN,YMIN,XMAX,YMAX)
            CALL IPgAxes
            CALL IPgXScale('TN')
!        X LABEL:   Gas Saturation, fraction
            CALL IPgXLabel('Gas Saturation, fraction','C')
!        left curve is gas/oil capillary pressure
            CALL IGrColour('red')             ! green=95 for pcow
            CALL IPgStyle(1,4,0,0,31,0)       ! red=31    solid=0,dot=1
            CALL IPgYScaleLeft('TN')
!    GRAPH:     X1VAL is also Gas Sat.; Y5VAL is PCGOT
            CALL IPgXYPairs(X1VAL,Y5VAL)      ! pcow plot on left
!  Y LABEL:   Y1LABEL is Relative Oil Permeability
            CALL IPgYLabelLeft('Gas/Oil Cap. Press.','C')
            CALL InKeyEvent(KEY)
!            IF(KEY.EQ.F5) CALL B4CAPT(FileName,FILESAVE)
            IF(KEY.EQ.F5) THEN
              FILESAVE=FileName
              CALL B4CAPTUR(FILESAVE)
            END IF

          END IF
        END IF
      END IF
      END SUBROUTINE

!     B4BUTTONS.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE B4BUTTONS(NBUTTONS,BUTTONS,BSIZE,NTARGET,ACCEPT,BTITLE)
      INCLUDE 'interip.inc'
      INCLUDE 'interif.inc'
      INCLUDE 'interkm.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'interat.inc'
      INCLUDE 'intercg.inc'
      INTEGER BSIZE,NTARGET
      LOGICAL ACCEPT
      CHARACTER*(BSIZE) BUTTONS(NBUTTONS)
      CHARACTER*(*) BTITLE
      INTEGER ifx(NBUTTONS),ifY(NBUTTONS),ift(NBUTTONS),ifw(NBUTTONS)
       MAXLEN=BSIZE
       NACROSS=5
!   BTITLE is a title imported as an argument
!   i.e.'Buttons for Saturation and Pressure Dependent Data' or HOME
       NWDTH=LEN_TRIM(BTITLE)
       IF ((NBUTTONS-2)*10+5.GT.NWDTH) THEN
         NWDTH=(NBUTTONS-2)*10 + NACROSS
       END IF
       do ib=1,NBUTTONS
         LENBUTTON=LEN_TRIM(BUTTONS(ib))
         IF (LENBUTTON.GT.MAXLEN) THEN
           MAXLEN=LENBUTTON
         END IF
       end do
       IBASE=-5
       ISTEP=BSIZE+2
       IBASEY=2

       do ib=1,NBUTTONS-2,NACROSS
         if (ib+NACROSS.gt.NBUTTONS-2)then
           ic=NBUTTONS-2
         else
           ic=ib+NACROSS
         end if
         IBASE=-5
         do i=ib,ic
           IBASE=IBASE+ISTEP
           ifx(i)=IBASE
         end do
       end do
       ifx(NBUTTONS-1) = (NWDTH/2)-ISTEP     !  (NWDTH/2)-10
       ifx(NBUTTONS)   = (NWDTH/2)+ISTEP     !  (NWDTH/2)+10

       jpos=0
       do ib=1,NBUTTONS-2,NACROSS
         jpos=jpos+IBASEY
         do j=ib,ib+NACROSS
           ify(j)=jpos
           ift(j)=5
           ifw(j)=MAXLEN
         end do
       end do
       ify(NBUTTONS-1)=jpos+2
       ift(NBUTTONS-1)=5
       ifw(NBUTTONS-1)=MAXLEN
       ify(NBUTTONS)=jpos+2
       ift(NBUTTONS)=5
       ifw(NBUTTONS)=MAXLEN
       NHIGH=jpos+4
       CALL IScreenBackground('blue','blue')
       CALL IWinClose(1)
       CALL InEventSelect(6,1)           ! ResizeExpose=6;IntYes=1
       CALL InControlKey(50,ResizeEvent)
       CALL InControlKey(26,577)   ! Alt-A=577(accept);Alt-N=590(next)
       CALL InControlKey(27,579)   ! Alt-C=579(cancel); Alt-Q=593(quit)
       CALL InControlKey(29,129)     ! KeyCursorDown = 129
       CALL InControlKey(30,128)     ! KeyCursorUp   = 128
       CALL InSelectionChars(' ')

       call IFrameType(4)           ! DropShadow = 4; Window3D2 = 10
       call IFrameOptions(4,15)     ! TitleForeCol, TextWhiteBold
       call IFrameOptions(5,5)      ! TitleBackCol, TextBlue
       call IWinAction('FPC')
       call IGrInputOptions(4,1)    ! GINTerminate, GINAnyKey
       call InMouseOptions(2,2)     ! MouseExit,IntYes
       call InMouseOptions(102,3)   ! PopupButton,RightButton=3; LeftButton=1
       call InHighLight('Black','yellow')
       IFINIT=NTARGET
       KEXIT=22

!       NOLDTARG=NTARGET
       DO WHILE(KEXIT.NE.ControlConfirm)          ! ControlConfirm=21
         call ITextColour('Yellow','BBlue')
         call IWinWordWrap('JUST')
         call IWinOpenTitle(0,0,NWDTH,NHIGH,BTITLE)
         call IFormDefine('W',NBUTTONS,ifx,ify,ifw,ift)

!   Place the buttons
         DO I=1,NBUTTONS
           call IFrameOptions(4,15)     ! TitleForeCol, TextWhiteBold
           call IFrameOptions(5,5)      ! TitleBackCol, TextBlue
           call IFormPutButton(I,BUTTONS(I),I)       ! ControlConfirm=21
           call IFormAttribute(I,' ','Black','White')
           call IFormFrame(I,BSIZE,'BWhite','Black')   ! Button3D1=7
         END DO

!   Show everthing in forms
         call IFormShow

!   Edit the forms and use buttons
         call IFormEdit(IFINIT,IFEXIT)
         KEXIT=InfoInput(55)        ! LastGINExit = 55
         NTARGET=KEXIT
         IF(NTARGET.GE.1.AND.NTARGET.LE.NBUTTONS-2) THEN

!   Selected a data target
           KEXIT=ControlConfirm
         ELSE IF (NTARGET.EQ.NBUTTONS) THEN

!   Selected cancel button
           ACCEPT=.FALSE.
           KEXIT=ControlConfirm
         ELSE IF (NTARGET.EQ.NBUTTONS-1) THEN

!   Selected accept button
           ACCEPT=.TRUE.
           KEXIT=ControlConfirm
         ELSE IF (KEXIT.EQ.50) THEN
           CALL IScreenBackground('blue','blue')
           call IWinClose(1)
           KEXIT=22
         ELSE
           CALL IScreenBackground('blue','blue')
           CALL IScreenBell('2')
           IFINIT=IFEXIT
         END IF
         IF (KEXIT.EQ.ControlConfirm) THEN
           CALL IScreenBackground('blue','blue')
           call IWinClose(1)
         END IF
       END DO
       CALL InMouseOptions(MouseExit,IntNo)       ! MouseExit=2;IntNo=0
       CALL IScreenBackground('blue','blue')
       CALL IWinClose(1)
       RETURN
      END SUBROUTINE

!   BTITLE is a title imported as an argument
!   i.e.'Buttons for Saturation and Pressure Dependent Data' or HOME
!
      BLOCK DATA B3KODEA
      INCLUDE 'BAEDPARM.INC'
      COMMON /B3PSEUD/ KODEA,TEM,SPG,
     &  FRCI(12),PRSCI(12),TEMCI(12),RMWTI(12),
     &  ZEDD(LP8,LP9),CMPGD(LP8,LP9)
      DATA TEMCI /672.37,
     A   547.57, 227.27, 343.04, 549.76, 665.68,
     B   734.65, 765.32, 828.77, 845.37, 913.37, 1023.89/
      DATA PRSCI /1306.0,
     A  1071.0, 493.00, 667.80, 707.80, 616.30,
     B   529.10, 550.70, 490.40, 488.60, 436.90, 360.60/
      END

!     FILDAT.FOR
!                    Designed by
!                    Raymond J. Heemstra
!
      SUBROUTINE FILDAT(FILENAME)
!
!  display date and time of the file in FILENAME
!
      COMMON/DATA01/ NLINE,NROW,NCOL,NCOLOR,ICHRA,ICHRB
      CHARACTER*(*) FILENAME
      CHARACTER*80 BUFFER(6)
      CHARACTER*21   DATTIM ,APM*1
      CHARACTER*3    MONSTR(12)
      INTEGER IHRS,MINS,MONTH,IDAY,IYEAR
      LOGICAL THERE
      DATA   MONSTR/'Jan','Feb','Mar','Apr','May','Jun',
     1              'Jul','Aug','Sep','Oct','Nov','Dec'/
      IHRS=0
      MINS=0
      APM='A'

!  get date and time
      CALL IOsDirInfo(' ','jnktest.csv',1,IFDATE,IFSIZE)
      CALL IOsFileDate(IFDATE,IYEAR,MONTH,IDAY) ! good after year 2000
      CALL IOutStringXY(10,3,'jnktest.csv'//'-  /  /    ')
      CALL IOutIntegerXY(22,3,IDAY,2)
      CALL IOutIntegerXY(25,3,MONTH,2)
      CALL IOutIntegerXY(28,3,IYEAR,4)
      PAUSE '1'

!  convert to a string
      CALL IOsCommandSilent('DIR jnktest.csv>FILTEMP.TMP')
      PAUSE '3'
!      call system('dir *.csv>mytemp.tmp')
      INQUIRE(FILE='FILTEMP.TMP',EXIST=THERE)
      IF (THERE) THEN
        OPEN(9,FILE='FILTEMP.TMP',STATUS='UNKNOWN')
        DO I=1,6
          DATTIM=' '
          BUFFER(I)=' '
          read (9,'(A16)',ERR=110) DATTIM(1:16)
          BUFFER(I)(1:16)=DATTIM(1:16)
        END DO
        CLOSE (9,STATUS='DELETE')
        READ(DATTIM(1:16),'(I2,1X,I2,1X,I2,2X,I2,1X,I2,A1)',ERR=110)
     &               MONTH,IDAY,IYEAR,IHRS,MINS,APM
      ELSE
        CALL AboutB4(1,'FILTEMP.TMP does not exist','Notice')
      END IF
      GO TO 111
110   CONTINUE
      CALL AboutB4(6,BUFFER,'Debug Information')
      RETURN
111   CONTINUE
!      IHRS=IHRS+6        ! IHRS = (GMT-6) ?? Anyway it works, or does it?
      IF(APM.EQ.'A'.OR.APM.EQ.'a') THEN
        DATTIM = '  -'//MONSTR(MONTH)//'-        :   AM'
      ELSE
        DATTIM(20:20) = 'P'
      END IF
!      IF (IHRS.GT.11) DATTIM(20:20) = 'P'
      CALL IntegerToString(IDAY,DATTIM(1:2),'(I2)')
      CALL IntegerToString(IYEAR,DATTIM(8:11),'(I4)')
!      IHRS = MOD(IHRS,12)
!      IF (IHRS.EQ.0) IHRS = 12
      CALL IntegerToString(IHRS,DATTIM(14:15),'(I2)')
      CALL IntegerToString(MINS,DATTIM(17:18),'(I2)')
      IF (DATTIM(17:17).EQ.' ') DATTIM(17:17) = '0'
!
!  display on bottom screen line
!
!      CALL IOutStringXY(1,NLINE,DATTIM)
      CALL IOutStringXY(5,2,'Import file: '//TRIM(FILENAME)//DATTIM)
      PAUSE '2'
      RETURN
      END

!     Last change:  RJH  28 May 98    3:28 pm
!     FSTORE.FOR
!
      FUNCTION FSTORE(FNAME)
      LOGICAL B4FILE,FSTORE,AnswerB4,THERE
      CHARACTER*(*) FNAME
      CHARACTER STRINGS*27,PROMPTS*9,FileName*64,TITLE*16
        FSTORE=.FALSE.

!  ************  Enter the New file selection ******************
        STRINGS='Please give a new file name'
        PROMPTS='File name'
        FileName=' '
        FileName=FNAME
        TITLE='New file request'
        IF (B4FILE(STRINGS,PROMPTS,FileName,TITLE)) THEN
          INQUIRE(FILE=FileName,EXIST=THERE)
          IF (THERE) THEN
            IF (AnswerB4(1,
     &        'File already exists!  Wish to replace?','Alert')) THEN
              FSTORE=.TRUE.
              FNAME=FileName
            ELSE
              CALL AboutB4(1,'Please enter another file name!','Alert')
            END IF
          ELSE
            FSTORE=.TRUE.
            FNAME=FileName
          END IF
        END IF
      END

!     CHECKIJK.FOR
!
      SUBROUTINE CHECKIJK(NWELLS,WELNAM,NPW,IDWEL,
     &        IDWELX,LWX,LWY,LWZ,
     &      ISET,NWELLDEF,LASTWELL,I1NEWOLD,
     &     WELLNAME,IDNOWELL,IQN1,IQN2,IQN3,LAYER)
      INCLUDE 'BAEDPARM.INC'
!
!   Use WELNAM with a IDWEL number from WELLS and corresponding IDWELX
!   number with correct IJK locations LWX,LWY,& LWZ from NODES, to then
!   select a corresponding WELLNAME series with its IDNOWELL node-ID
!   series from the RECURRENT group, and then to check each IQN1,IQN2,
!   & IQN3 value against the corresponding LWX, LWY, & LWZ value.
!
      CHARACTER*8 WELNAM(NWX)
      INTEGER NPW(NWX),IDWELX(NWX,NODX)
      DIMENSION LWX(NWX,NODX),LWY(NWX,NODX),LWZ(NWX,NODX)
      CHARACTER*5 WELLNAME(LP11,LP112)
      INTEGER I1NEWOLD(LP11,LP112),IDNOWELL(LP11,LP112),
     &  IQN1(LP11,LP112),IQN2(LP11,LP112),IQN3(LP11,LP112),
     &  LAYER(LP11,LP112)

      CHARACTER*80 BUFFER(5),MESSAGE(3)
      LOGICAL MATCH,AnswerB4
      MATCH=.FALSE.

!  Go through the well list
      DO NW=1,NWELLS
        NODE=0
        DO NR=LASTWELL+1,NWELLDEF
        I1=I1NEWOLD(NR,ISET)
        I1NOD=IDNOWELL(I1,ISET)
          IF (WELLNAME(I1NOD,ISET).EQ.WELNAM(NW) ) THEN
            MATCH=.TRUE.
!  Find number of nodes in target well name
            NM=NPW(NW)
          ELSE
            MATCH=.FALSE.
          END IF
          IF (MATCH.AND.NODE.LT.NM) THEN
!  Check each node of target name.
            NODE=NODE+1
            IF ( (IQN1(I1NOD,ISET).NE.LWX(NW,NODE)).OR.
     &           (IQN2(I1NOD,ISET).NE.LWY(NW,NODE)).OR.
     &           (IQN3(I1NOD,ISET).NE.LWZ(NW,NODE)) ) THEN
              WRITE(BUFFER(1),'(A3,I3,A7,A5,A8,I3,A8)') 'No.',NW,
     &         ' well "',WELNAM(NW),
     &         '", with ',NODE,' node(s)'
              WRITE(BUFFER(2),'(A,3I4)') 'Recurrent node: ',
     &         IQN1(I1NOD,ISET),IQN2(I1NOD,ISET),IQN3(I1NOD,ISET)
              WRITE(BUFFER(3),'(A,3I4)') 'True well node: ',
     &         LWX(NW,NODE),LWY(NW,NODE),LWZ(NW,NODE)
              WRITE(BUFFER(4),*)
     &          'The recurrent node values do not match the well node.'
              WRITE(BUFFER(5),*) 'Do you wish them to be fixed?'
              IF ( AnswerB4(5,BUFFER,'Well location correction'//
     &                              ' for "'// TRIM(WELNAM(NW))//
     &                                '", nodes do not match')) THEN
                IQN1(I1NOD,ISET)=LWX(NW,NODE)
                IQN2(I1NOD,ISET)=LWY(NW,NODE)
                IQN3(I1NOD,ISET)=LWZ(NW,NODE)
                IF ((IQN3(I1NOD,ISET)-1+LAYER(I1NOD,ISET)).GT.LP3) THEN
                  WRITE(MESSAGE(1),'(A,I3)') 'From old NL value of ',
     &                 LAYER(I1NOD,ISET)
                  LAYER(I1NOD,ISET)=LP3-IQN3(I1NOD,ISET)+1
                  WRITE(MESSAGE(2),'(A,I3)') '  To new NL value of ',
     &                 LAYER(I1NOD,ISET)
                  CALL AboutB4(2,MESSAGE,
     &            'Notice 2: Resetting NL value for '//TRIM(WELNAM(NW)))
                END IF
              END IF
            END IF
!  Check on NL value only
            IF ((IQN3(I1NOD,ISET)-1+LAYER(I1NOD,ISET)).GT.LP3) THEN
              WRITE(MESSAGE(1),'(A,I3)') 'From old NL value of ',
     &              LAYER(I1NOD,ISET)
              LAYER(I1NOD,ISET)=LP3-IQN3(I1NOD,ISET)+1
              WRITE(MESSAGE(2),'(A,I3)') '  To new NL value of ',
     &              LAYER(I1NOD,ISET)
              CALL AboutB4(2,MESSAGE,
     &         'Notice 1: Resetting NL value for '//TRIM(WELNAM(NW)))
            END IF
          END IF
        END DO
      END DO
      END SUBROUTINE
