C  *********************************************************
C  **  (c) Interactive Software Services Ltd. 1989-1995   **
C  ** --------------------------------------------------- **
C  ** Licenced INTERACTER users are granted permission to **
C  ** incorporate this code within their own applications **
C  ** --------------------------------------------------- **
C  **   I.S.S. can be contacted on +44 (0) 1543 503611    **
C  **                       or Fax +44 (0) 1543 574566    **
C  **           or Internet support@issltd.demon.co.uk    **
C  *********************************************************
C
C  INTERACTER Symbolic Names File.
C
C  Group IF : Information Routines
C
C  Subroutine  : InfoAttribute
C  Description : Text attributes information
C
      INTEGER         BoldText, FlashingText, ItalicText, ReverseVideo,
     1                UnderlineText, ForeTextCol, BackTextCol,
     2                BoldRequest, FlashingRequest, ItalicRequest,
     3                ReverseRequest, UnderlineRequest,
     4                ForeColRequest, BackColRequest, ClearToBack
C
      PARAMETER       (BoldText        =  1)
      PARAMETER       (FlashingText    =  2)
      PARAMETER       (ItalicText      =  3)
      PARAMETER       (ReverseVideo    =  4)
      PARAMETER       (UnderlineText   =  5)
      PARAMETER       (ForeTextCol     =  6)
      PARAMETER       (BackTextCol     =  7)
      PARAMETER       (BoldRequest     =  8)
      PARAMETER       (FlashingRequest =  9)
      PARAMETER       (ItalicRequest   = 10)
      PARAMETER       (ReverseRequest  = 11)
      PARAMETER       (UnderlineRequest= 12)
      PARAMETER       (ForeColRequest  = 13)
      PARAMETER       (BackColRequest  = 14)
      PARAMETER       (ClearToBack     = 15)
C
C  Subroutine  : InfoCursor
C  Description : Cursor position/state information
C
      INTEGER         CursorColumn, CursorRow, SavedColumn,
     1                SavedRow, CursorState
C
      PARAMETER       (CursorColumn    =  1)
      PARAMETER       (CursorRow       =  2)
      PARAMETER       (SavedColumn     =  3)
      PARAMETER       (SavedRow        =  4)
      PARAMETER       (CursorState     =  5)
C
      INTEGER         NotSaved, UnderlineOff,
     1                UnderlineOn, BlockOff,
     2                BlockOn
C
      PARAMETER       (NotSaved        =  0)
      PARAMETER       (UnderlineOff    =  0)
      PARAMETER       (UnderlineOn     =  1)
      PARAMETER       (BlockOff        =  2)
      PARAMETER       (BlockOn         =  3)
C
C  Subroutine  : InfoError
C  Description : Last error information
C
      INTEGER         LastError, IOErrorCode, OsErrorCode
C
      PARAMETER       (LastError       =  1)
      PARAMETER       (IOErrorCode     =  2)
      PARAMETER       (OsErrorCode     =  3)
C
      INTEGER         ErrFileOpen, ErrFileIO, ErrFileClose,
     1                ErrLargeNum, ErrPrintGfx, ErrScreenLoadSave,
     2                ErrMaxWindow, ErrWinBuffer, ErrWinCoOrds,
     3                ErrNoSubstring, ErrDecPoint, ErrBadChar,
     4                ErrOSCommand, ErrBadClear, ErrStrTooWide,
     5                ErrBadUnits, ErrWinOffScreen, ErrNumToStr,
     6                ErrMenuOpt, ErrBadRadius, ErrBadSideLen,
     7                ErrNoWidHgt, ErrNoProgName, ErrCumPlotSize,
     8                ErrChrSymSetSize,ErrNoScreenMode,ErrBadScreenFile,
     9                ErrBordersCross, ErrBlankInput, ErrAllProtected,
     A                ErrBadFieldType, ErrFieldUndefined,
     1                ErrFullDataArea, ErrPageSize, ErrOldPCImage,
     2                ErrOutOfRange, ErrIFDWarn, ErrNotFormFile,
     3                ErrColourFail, ErrFileListSize, ErrBadMode,
     4                ErrBadColour, ErrContHeights, ErrBadArea,
     5                ErrNullMenu, ErrNoDriver, ErrNoGraphType,
     6                ErrDataSetNum, ErrFillComplex, ErrFormWindow,
     7                ErrSearchBox
C
      PARAMETER       (ErrFileOpen       =  1)
      PARAMETER       (ErrFileIO         =  2)
      PARAMETER       (ErrFileClose      =  3)
      PARAMETER       (ErrLargeNum       =  4)
      PARAMETER       (ErrPrintGfx       =  5)
      PARAMETER       (ErrScreenLoadSave =  6)
      PARAMETER       (ErrMaxWindow      =  7)
      PARAMETER       (ErrWinBuffer      =  8)
      PARAMETER       (ErrWinCoOrds      =  9)
      PARAMETER       (ErrNoSubstring    = 10)
      PARAMETER       (ErrDecPoint       = 11)
      PARAMETER       (ErrBadChar        = 12)
      PARAMETER       (ErrOSCommand      = 13)
      PARAMETER       (ErrBadClear       = 14)
      PARAMETER       (ErrStrTooWide     = 15)
      PARAMETER       (ErrBadUnits       = 16)
      PARAMETER       (ErrWinOffScreen   = 17)
      PARAMETER       (ErrNumToStr       = 18)
      PARAMETER       (ErrMenuOpt        = 19)
      PARAMETER       (ErrBadRadius      = 20)
      PARAMETER       (ErrBadSideLen     = 21)
      PARAMETER       (ErrNoWidHgt       = 22)
      PARAMETER       (ErrNoProgName     = 23)
      PARAMETER       (ErrCumPlotSize    = 24)
      PARAMETER       (ErrChrSymSetSize  = 25)
      PARAMETER       (ErrNoScreenMode   = 26)
      PARAMETER       (ErrBadScreenFile  = 27)
      PARAMETER       (ErrBordersCross   = 28)
      PARAMETER       (ErrBlankInput     = 29)
      PARAMETER       (ErrAllProtected   = 30)
      PARAMETER       (ErrBadFieldType   = 31)
      PARAMETER       (ErrFieldUndefined = 32)
      PARAMETER       (ErrFullDataArea   = 33)
      PARAMETER       (ErrPageSize       = 34)
      PARAMETER       (ErrOldPCImage     = 35)
      PARAMETER       (ErrOutOfRange     = 36)
      PARAMETER       (ErrIFDWarn        = 37)
      PARAMETER       (ErrNotFormFile    = 38)
      PARAMETER       (ErrColourFail     = 39)
      PARAMETER       (ErrFileListSize   = 40)
      PARAMETER       (ErrBadMode        = 41)
      PARAMETER       (ErrBadColour      = 42)
      PARAMETER       (ErrContHeights    = 43)
      PARAMETER       (ErrBadArea        = 44)
      PARAMETER       (ErrNullMenu       = 45)
      PARAMETER       (ErrNoDriver       = 46)
      PARAMETER       (ErrNoGraphType    = 47)
      PARAMETER       (ErrDataSetNum     = 48)
      PARAMETER       (ErrFillComplex    = 49)
      PARAMETER       (ErrFormWindow     = 50)
      PARAMETER       (ErrSearchBox      = 51)
C
C  Subroutine  : InfoField
C  Description : Form field information
C
      INTEGER         FieldColumn, FieldRow, FieldWidth, FieldType,
     1                FieldAttribute, FieldForeCol,
     2                FieldBackCol, InputCtrl, ExitCode,
     3                MenuSize, MenuOptionNum,
     4                MenuOptionMax, FieldFrameType, FieldFrameFore,
     5                FieldFrameBack
C
      PARAMETER       (FieldColumn     =  1)
      PARAMETER       (FieldRow        =  2)
      PARAMETER       (FieldWidth      =  3)
      PARAMETER       (FieldType       =  4)
      PARAMETER       (FieldAttribute  =  5)
      PARAMETER       (FieldForeCol    =  6)
      PARAMETER       (FieldBackCol    =  7)
      PARAMETER       (InputCtrl       =  8)
      PARAMETER       (ExitCode        =  9)
      PARAMETER       (MenuSize        = 10)
      PARAMETER       (MenuOptionNum   = 11)
      PARAMETER       (MenuOptionMax   = 12)
      PARAMETER       (FieldFrameType  = 13)
      PARAMETER       (FieldFrameFore  = 14)
      PARAMETER       (FieldFrameBack  = 15)
C
C  Subroutine  : InfoFilename
C  Description : Default filename information
C
      INTEGER         DefaultPrintDump, DefaultHardCopy,
     1                DefaultCharSet, DefaultSymbolSet,
     2                CharSetDir, SymbolSetDir, FormDefsDir
C
      PARAMETER       (DefaultPrintDump=  1)
      PARAMETER       (DefaultHardCopy =  2)
      PARAMETER       (DefaultCharSet  =  3)
      PARAMETER       (DefaultSymbolSet=  4)
      PARAMETER       (CharSetDir      =  5)
      PARAMETER       (SymbolSetDir    =  6)
      PARAMETER       (FormDefsDir     =  7)
C
C  Subroutine  : InfoForm
C  Description : General Forms Manager information
C
      INTEGER         MaxNumField, CharSpaceLeft, NextFieldId,
     1                LastErrorLine, CharSpaceUsed, FormWinWidth,
     2                FormWinHeight
C
      PARAMETER       (MaxNumField     =  1)
      PARAMETER       (CharSpaceLeft   =  2)
      PARAMETER       (NextFieldId     =  3)
      PARAMETER       (LastErrorLine   =  4)
      PARAMETER       (CharSpaceUsed   =  5)
      PARAMETER       (FormWinWidth    =  6)
      PARAMETER       (FormWinHeight   =  7)
C
C  Subroutine  : InfoFrame
C  Description : Text frame information
C
      INTEGER         FrameType, UsingBoxChars
C
      PARAMETER       (FrameType       =  1)
      PARAMETER       (UsingBoxChars   =  2)
C  Note : 101-107, see IFrameOptions in intercg.inc
C  For frame types see IFrameType also in intercg.inc
C
C  Subroutine  : InfoGraphics
C  Description : Graphics mode information
C
      INTEGER         GraphicsX, GraphicsY, GraphicsChWidth,
     1                GraphicsChHeight, GraphicsMouseX, GraphicsMouseY,
     2                GraphicsAreaMinX, GraphicsAreaMinY,
     3                GraphicsAreaMaxX, GraphicsAreaMaxY,
     4                GraphicsUnitMinX, GraphicsUnitMinY,
     5                GraphicsUnitMaxX, GraphicsUnitMaxY
C
      PARAMETER       (GraphicsX       =  1)
      PARAMETER       (GraphicsY       =  2)
      PARAMETER       (GraphicsChWidth =  3)
      PARAMETER       (GraphicsChHeight=  4)
      PARAMETER       (GraphicsMouseX  =  5)
      PARAMETER       (GraphicsMouseY  =  6)
      PARAMETER       (GraphicsAreaMinX=  7)
      PARAMETER       (GraphicsAreaMinY=  8)
      PARAMETER       (GraphicsAreaMaxX=  9)
      PARAMETER       (GraphicsAreaMaxY= 10)
      PARAMETER       (GraphicsUnitMinX= 11)
      PARAMETER       (GraphicsUnitMinY= 12)
      PARAMETER       (GraphicsUnitMaxX= 13)
      PARAMETER       (GraphicsUnitMaxY= 14)
C
C  Subroutine  : InfoGrHardCopy
C  Description : Graphics hardcopy information
C
      INTEGER         DriverSelected
C
C  Note : 6 - 32 same as InfoGrScreen
      PARAMETER       (DriverSelected   =100)
C  Note : 101-126 as for IGrHardCopyOptions(1-26,n)
C
C  Subroutine  : InfoGrScreen
C  Description : Screen graphics capabilities
C
      INTEGER         GraphicsAvail, AreaClear,
     1                AndPlotMode, OrPlotMode, EorPlotMode,
     2                BrokenLines, RGBEncoding,
     3                PaletteBack, PaletteFore,
     4                StippleFillRect, StippleFillTri,
     5                StippleFillCirc, SolidFillRect,
     6                SolidFillTri   , SolidFillCirc,
     7                BitBlock, ImageSave,
     8                GrPopUpMode, HardTextSize,
     9                IndepTextGr, GinMode,
     1                StippleFillArc , SolidFillArc, PaletteChange,
     2                StippleFillPoly, SolidFillPoly,
     3                ColNumAvailable, ColNumMax,
     4                AspectRatio, TextHandle,
     5                PrevColReq , ColourReq,
     6                LineTypeReq, PlotModeReq
C
      PARAMETER       (GraphicsAvail   =  1)
      PARAMETER       (AreaClear       =  2)
      PARAMETER       (AndPlotMode     =  3)
      PARAMETER       (OrPlotMode      =  4)
      PARAMETER       (EorPlotMode     =  5)
      PARAMETER       (BrokenLines     =  6)
      PARAMETER       (RGBEncoding     =  7)
      PARAMETER       (PaletteBack     =  8)
      PARAMETER       (PaletteFore     =  9)
      PARAMETER       (StippleFillRect = 10)
      PARAMETER       (StippleFillTri  = 11)
      PARAMETER       (StippleFillCirc = 12)
      PARAMETER       (SolidFillRect   = 13)
      PARAMETER       (SolidFillTri    = 14)
      PARAMETER       (SolidFillCirc   = 15)
      PARAMETER       (BitBlock        = 16)
      PARAMETER       (ImageSave       = 17)
      PARAMETER       (GrPopUpMode     = 18)
      PARAMETER       (HardTextSize    = 19)
      PARAMETER       (IndepTextGr     = 20)
      PARAMETER       (GINMode         = 21)
      PARAMETER       (StippleFillArc  = 22)
      PARAMETER       (SolidFillArc    = 23)
      PARAMETER       (PaletteChange   = 24)
      PARAMETER       (StippleFillPoly = 25)
      PARAMETER       (SolidFillPoly   = 26)
      PARAMETER       (ColNumAvailable = 30)
      PARAMETER       (ColNumMax       = 31)
      PARAMETER       (AspectRatio     = 32)
      PARAMETER       (TextHandle      = 33)
      PARAMETER       (PrevColReq      = 34)
      PARAMETER       (ColourReq       = 35)
      PARAMETER       (LineTypeReq     = 36)
      PARAMETER       (PlotModeReq     = 37)
C
      INTEGER         PlotNormal, PlotOr, PlotAnd, PlotEor
C
      PARAMETER       (PlotNormal      =  0)
      PARAMETER       (PlotOr          =  1)
      PARAMETER       (PlotAnd         =  2)
      PARAMETER       (PlotEor         =  3)
C
C  Subroutine  : InfoHardware
C  Description : General hardware-related information
C
      INTEGER         AutoModeSwitch, DensityNum,
     1                PrintDense1, PrintDense2,
     2                PrintDense3, PrintDense4,
     2                PlotPens, TINCapab, GINCapab,
     3                DisplayType, PrinterType, PlotterType,
     4                MouseType, DigiType,
     4                DisplayExp , PrinterExp , PlotterExp ,
     5                MouseExp , DigiExp ,
     6                GScreenDump, DataComp, VESAsupport
C
      PARAMETER       (AutoModeSwitch  =  1)
      PARAMETER       (DensityNum      =  2)
      PARAMETER       (PrintDense1     =  3)
      PARAMETER       (PrintDense2     =  4)
      PARAMETER       (PrintDense3     =  5)
      PARAMETER       (PrintDense4     =  6)
      PARAMETER       (PlotPens        =  7)
      PARAMETER       (TINCapab        =  8)
      PARAMETER       (GINCapab        =  9)
      PARAMETER       (DisplayType     = 10)
      PARAMETER       (PrinterType     = 11)
      PARAMETER       (PlotterType     = 12)
      PARAMETER       (MouseType       = 13)
      PARAMETER       (DigiType        = 14)
      PARAMETER       (DisplayExp      = 20)
      PARAMETER       (PrinterExp      = 21)
      PARAMETER       (PlotterExp      = 22)
      PARAMETER       (MouseExp        = 23)
      PARAMETER       (DigiExp         = 24)
      PARAMETER       (GScreenDump     = 30)
      PARAMETER       (DataComp        = 31)
      PARAMETER       (VESAsupport     = 32)
C
      INTEGER         HardWare, ISSDump
C
      PARAMETER       (HardWare         = 1)
      PARAMETER       (ISSDump          = 2)
C
C  Subroutine  : InfoInput
C  Description : Input handling information
C
      INTEGER         NumFunKeys, ImmKeyDetect, KeypadMode,
     1                EditMode, LastExitKey,
     2                KeypadType, LastGINExit,
     3                PopUps, LastDigiExit,
     4                SingleSelect, ExitMouseButton,
     5                MouseTextCol, MouseTextRow,
     6                ExitCursPos, MultiTagChar,
     7                EventMask, PauseKey, ExitOutside,
     8                Gravity, MouseTime
C
C  Note : 1-50, see InControlKey in interin.inc
      PARAMETER       (NumFunKeys      = 51)
      PARAMETER       (ImmKeyDetect    = 52)
      PARAMETER       (KeypadMode      = 53)
      PARAMETER       (EditMode        = 54)
      PARAMETER       (LastExitKey     = 55)
      PARAMETER       (KeypadType      = 56)
      PARAMETER       (LastGINExit     = 57)
      PARAMETER       (PopUps          = 58)
      PARAMETER       (LastDigiExit    = 59)
      PARAMETER       (SingleSelect    = 60)
      PARAMETER       (ExitMouseButton = 61)
      PARAMETER       (MouseTextCol    = 62)
      PARAMETER       (MouseTextRow    = 63)
      PARAMETER       (ExitCursPos     = 64)
      PARAMETER       (MultiTagChar    = 65)
      PARAMETER       (EventMask       = 66)
      PARAMETER       (PauseKey        = 67)
      PARAMETER       (ExitOutside     = 68)
      PARAMETER       (Gravity         = 69)
      PARAMETER       (MouseTime       = 70)
C  Note : 101-106, see InMouseOptions in interin.inc
C
      INTEGER         OverMode, InsMode,
     1                Nokeypad, SharedKP,  SeparateKP,
     2                SinglePop, LinkedPop,
     3                MoveSelect, MoveOnly,
     4                LeftGrav, RightGrav
C
      PARAMETER       (OverMode        =  0)
      PARAMETER       (InsMode         =  1)
      PARAMETER       (NoKeypad        = -1)
      PARAMETER       (SharedKP        =  0)
      PARAMETER       (SeparateKP      =  1)
      PARAMETER       (SinglePop       =  1)
      PARAMETER       (LinkedPop       =  2)
      PARAMETER       (MoveSelect      =  1)
      PARAMETER       (MoveOnly        =  2)
      PARAMETER       (LeftGrav        =  0)
      PARAMETER       (RightGrav       =  1)
C
C  Subroutine  : InfoOpSystem
C  Description : Operating System Information
C
      INTEGER         OSType, NumCLArgs, OSVersion,
     1                MatchManyChar, MatchSingleChar, DirSepChar,
     2                FileCaseSense, FileSuffix, CurDirIsRoot,
     3                DiskInA, DiskInB
C
      PARAMETER       (OSType          =  1)
      PARAMETER       (NumCLArgs       =  2)
      PARAMETER       (OSVersion       =  3)
      PARAMETER       (MatchManyChar   =  4)
      PARAMETER       (MatchSingleChar =  5)
      PARAMETER       (DirSepChar      =  6)
      PARAMETER       (FileCaseSense   =  7)
      PARAMETER       (FileSuffix      =  8)
      PARAMETER       (CurDirIsRoot    =  9)
      PARAMETER       (DiskInA         = 10)
      PARAMETER       (DiskInB         = 11)
C  And for RISC OS users ...
      INTEGER          DiskIn0, DiskIn1
C
      PARAMETER       (DiskIn0         = 10)
      PARAMETER       (DiskIn1         = 11)
C
      INTEGER         DOS, RISCOS, VMS, Unix, Win16, Win32
C
      PARAMETER       (DOS             =  1)
      PARAMETER       (RISCOS          =  2)
      PARAMETER       (VMS             =  3)
      PARAMETER       (Unix            =  4)
      PARAMETER       (Win16           =  5)
      PARAMETER       (Win32           =  6)
C
C  Subroutine  : InfoScreen
C  Description : Current screen mode information
C
      INTEGER         ScrMode, ScrMaxModes
C
      PARAMETER       (ScrMode         =  1)
C  Note : 2-5, see InfoScreenMode below
      PARAMETER       (ScrMaxModes     =  6)
C  Note : 101-124, see IScrDumpOptions in intersc.inc
C
C  Subroutine  : InfoScreenMode
C  Description : Screen mode information, for any mode
C
      INTEGER         ModeType, TextColumns, TextRows,
     1                HorizPixels,VertPixels,NumColours
C
      PARAMETER       (ModeType        =  1)
      PARAMETER       (TextColumns     =  2)
      PARAMETER       (TextRows        =  3)
      PARAMETER       (HorizPixels     =  4)
      PARAMETER       (VertPixels      =  5)
      PARAMETER       (NumColours      =  6)
C
      INTEGER         Redundant, TextOnly,
     1                TextAndGraphics, TextOrGraphics
C
      PARAMETER       (Redundant       = -1)
      PARAMETER       (TextOnly        =  1)
      PARAMETER       (TextAndGraphics =  2)
      PARAMETER       (TextOrGraphics  =  3)
C
C  Subroutine  : InfoVersion
C  Description : INTERACTER version number
C
      INTEGER         IntVersion
C
      PARAMETER       (IntVersion      =  1)
C
C  Subroutine  : InfoWindow
C  Description : Text window manager information
C
      INTEGER         WinCurNumber, WinAvailable,
     1                WinBufferSpace, WinLeftColumn,
     2                WinTopRow, WinWidth, WinHeight,
     3                WinTopNumber, WinCursorX, WinCursorY,
     4                WinFrameMode, WinPopupMode,
     5                WinClearMode, WinTitle, WinLenFindStr,
     6                WinTagChar, WinTitleMode
C
      PARAMETER       (WinCurNumber    =  1)
      PARAMETER       (WinAvailable    =  2)
      PARAMETER       (WinBufferSpace  =  3)
      PARAMETER       (WinLeftColumn   =  4)
      PARAMETER       (WinTopRow       =  5)
      PARAMETER       (WinWidth        =  6)
      PARAMETER       (WinHeight       =  7)
      PARAMETER       (WinTopNumber    =  8)
      PARAMETER       (WinCursorX      =  9)
      PARAMETER       (WinCursorY      = 10)
      PARAMETER       (WinFrameMode    = 11)
      PARAMETER       (WinPopupMode    = 12)
      PARAMETER       (WinClearMode    = 13)
      PARAMETER       (WinTitle        = 14)
      PARAMETER       (WinLenFindStr   = 15)
      PARAMETER       (WinTagChar      = 16)
      PARAMETER       (WinTitleMode    = 17)
C
      INTEGER         WindowLeft, WindowCentre, WindowRight
C
      PARAMETER       (WindowLeft      =  1)
      PARAMETER       (WindowCentre    =  2)
      PARAMETER       (WindowRight     =  3)
C
C  Subroutine  : InfoWinString
C  Description : Text window manager character information
C
      INTEGER         WinFindStr
C
      PARAMETER       (WinFindStr      =  1)
