C  *********************************************************
C  **  (c) Interactive Software Services Ltd. 1989-1995   **
C  ** --------------------------------------------------- **
C  ** Licenced INTERACTER users are granted permission to **
C  ** incorporate this code within their own applications **
C  ** --------------------------------------------------- **
C  **   I.S.S. can be contacted on +44 (0) 1543 503611    **
C  **                       or Fax +44 (0) 1543 574566    **
C  **           or Internet support@issltd.demon.co.uk    **
C  *********************************************************
C
C  INTERACTER Symbolic Names File.
C
C  Group KM : Keyboard/Mouse Event Handling Routines.
C
C  Subroutine  : InEventSelect
C  Description : Non-Keyboard event selection
C
      INTEGER         AllEvents, ButtonDown, ButtonUp,
     1                MouseMoveText, MouseMoveGraph, ResizeExpose
C
      PARAMETER       (AllEvents        = 0)
      PARAMETER       (ButtonDown       = 1)
      PARAMETER       (ButtonUp         = 2)
      PARAMETER       (MouseMoveText    = 3)
      PARAMETER       (MouseMoveGraph   = 4)
      PARAMETER       (ResizeExpose     = 6)
C
C  Subroutine  : InKeyEvent
C  Description : Keyboard and mouse events
C
      INTEGER         KeyBackspace, KeyTab, KeyReturn, KeyEscape,
     1                KeyDelete, KeyCursorUp, KeyCursorDown,
     2                KeyCursorRight, KeyCursorLeft, KeyPageUp,
     3                KeyPageDown, KeyPageRight, KeyPageLeft,
     4                KeyUpExtreme, KeyDownExtreme, KeyLeftExtreme,
     5                KeyRightExtreme, KeyHome, KeyEnd, KeyInsert,
     6                KeyDeleteUnder, KeyShiftTab, Keypad0, Keypad1,
     7                Keypad2, Keypad3, Keypad4, Keypad5, Keypad6,
     8                Keypad7, Keypad8, Keypad9, KeypadMinus,
     9                KeypadPoint, KeypadPlus, KeypadDivide,
     A                KeypadMultiply, KeypadHash, KeypadEnter,
     B                KeyPrint
      INTEGER         KeyF1      ,KeyF2      ,KeyF3      ,KeyF4      ,
     1                KeyF5      ,KeyF6      ,KeyF7      ,KeyF8      ,
     2                KeyF9      ,KeyF10     ,KeyF11     ,KeyF12     ,
     3                KeyF13     ,KeyF14     ,KeyF15     ,KeyF16     ,
     4                KeyF17     ,KeyF18     ,KeyF19     ,KeyF20     ,
     3                KeyShiftF1 ,KeyShiftF2 ,KeyShiftF3 ,KeyShiftF4 ,
     4                KeyShiftF5 ,KeyShiftF6 ,KeyShiftF7 ,KeyShiftF8 ,
     5                KeyShiftF9 ,KeyShiftF10,KeyShiftF11,KeyShiftF12,
     6                KeyShiftF13,KeyShiftF14,KeyShiftF15,KeyShiftF16,
     7                KeyShiftF17,KeyShiftF18,KeyShiftF19,KeyShiftF20,
     3                KeyCtrlF1  ,KeyCtrlF2  ,KeyCtrlF3  ,KeyCtrlF4  ,
     4                KeyCtrlF5  ,KeyCtrlF6  ,KeyCtrlF7  ,KeyCtrlF8  ,
     5                KeyCtrlF9  ,KeyCtrlF10 ,KeyCtrlF11 ,KeyCtrlF12 ,
     6                KeyCtrlF13 ,KeyCtrlF14 ,KeyCtrlF15 ,KeyCtrlF16 ,
     7                KeyCtrlF17 ,KeyCtrlF18 ,KeyCtrlF19 ,KeyCtrlF20 ,
     3                KeyAltF1   ,KeyAltF2   ,KeyAltF3   ,KeyAltF4   ,
     4                KeyAltF5   ,KeyAltF6   ,KeyAltF7   ,KeyAltF8   ,
     5                KeyAltF9   ,KeyAltF10  ,KeyAltF11  ,KeyAltF12  ,
     6                KeyAltF13  ,KeyAltF14  ,KeyAltF15  ,KeyAltF16  ,
     7                KeyAltF17  ,KeyAltF18  ,KeyAltF19  ,KeyAltF20
      INTEGER         LeftButtonDown, MiddleButtonDown, RightButtonDown,
     1                LeftButtonUp, MiddleButtonUp, RightButtonUp,
     2                MouseMove, ResizeEvent
      INTEGER         KeyAltBackspace,KeyAltTab,KeyAltReturn,
     1                KeyAltEscape
C
      PARAMETER       (KeyBackSpace    =   8)
      PARAMETER       (KeyTab          =   9)
      PARAMETER       (KeyReturn       =  13)
      PARAMETER       (KeyEscape       =  27)
      PARAMETER       (KeyDelete       = 127)
      PARAMETER       (KeyCursorUp     = 128)
      PARAMETER       (KeyCursorDown   = 129)
      PARAMETER       (KeyCursorRight  = 130)
      PARAMETER       (KeyCursorLeft   = 131)
      PARAMETER       (KeyPageUp       = 132)
      PARAMETER       (KeyPageDown     = 133)
      PARAMETER       (KeyPageRight    = 134)
      PARAMETER       (KeyPageLeft     = 135)
      PARAMETER       (KeyUpExtreme    = 136)
      PARAMETER       (KeyDownExtreme  = 137)
      PARAMETER       (KeyRightExtreme = 138)
      PARAMETER       (KeyLeftExtreme  = 139)
      PARAMETER       (KeyHome         = 140)
      PARAMETER       (KeyEnd          = 141)
      PARAMETER       (KeyInsert       = 142)
      PARAMETER       (KeyDeleteUnder  = 143)
      PARAMETER       (KeyShiftTab     = 144)
      PARAMETER       (Keypad0         = 150)
      PARAMETER       (Keypad1         = 151)
      PARAMETER       (Keypad2         = 152)
      PARAMETER       (Keypad3         = 153)
      PARAMETER       (Keypad4         = 154)
      PARAMETER       (Keypad5         = 155)
      PARAMETER       (Keypad6         = 156)
      PARAMETER       (Keypad7         = 157)
      PARAMETER       (Keypad8         = 158)
      PARAMETER       (Keypad9         = 159)
      PARAMETER       (KeypadMinus     = 160)
      PARAMETER       (KeypadPoint     = 161)
      PARAMETER       (KeypadPlus      = 162)
      PARAMETER       (KeypadDivide    = 163)
      PARAMETER       (KeypadMultiply  = 164)
      PARAMETER       (KeypadHash      = 165)
      PARAMETER       (KeypadEnter     = 166)
      PARAMETER       (KeyPrint        = 170)
C
      PARAMETER       (KeyF1           = 171)
      PARAMETER       (KeyF2           = 172)
      PARAMETER       (KeyF3           = 173)
      PARAMETER       (KeyF4           = 174)
      PARAMETER       (KeyF5           = 175)
      PARAMETER       (KeyF6           = 176)
      PARAMETER       (KeyF7           = 177)
      PARAMETER       (KeyF8           = 178)
      PARAMETER       (KeyF9           = 179)
      PARAMETER       (KeyF10          = 180)
      PARAMETER       (KeyF11          = 181)
      PARAMETER       (KeyF12          = 182)
      PARAMETER       (KeyF13          = 183)
      PARAMETER       (KeyF14          = 184)
      PARAMETER       (KeyF15          = 185)
      PARAMETER       (KeyF16          = 186)
      PARAMETER       (KeyF17          = 187)
      PARAMETER       (KeyF18          = 188)
      PARAMETER       (KeyF19          = 189)
      PARAMETER       (KeyF20          = 190)
      PARAMETER       (KeyShiftF1      = 191)
      PARAMETER       (KeyShiftF2      = 192)
      PARAMETER       (KeyShiftF3      = 193)
      PARAMETER       (KeyShiftF4      = 194)
      PARAMETER       (KeyShiftF5      = 195)
      PARAMETER       (KeyShiftF6      = 196)
      PARAMETER       (KeyShiftF7      = 197)
      PARAMETER       (KeyShiftF8      = 198)
      PARAMETER       (KeyShiftF9      = 199)
      PARAMETER       (KeyShiftF10     = 200)
      PARAMETER       (KeyShiftF11     = 201)
      PARAMETER       (KeyShiftF12     = 202)
      PARAMETER       (KeyShiftF13     = 203)
      PARAMETER       (KeyShiftF14     = 204)
      PARAMETER       (KeyShiftF15     = 205)
      PARAMETER       (KeyShiftF16     = 206)
      PARAMETER       (KeyShiftF17     = 207)
      PARAMETER       (KeyShiftF18     = 208)
      PARAMETER       (KeyShiftF19     = 209)
      PARAMETER       (KeyShiftF20     = 210)
      PARAMETER       (KeyCtrlF1       = 211)
      PARAMETER       (KeyCtrlF2       = 212)
      PARAMETER       (KeyCtrlF3       = 213)
      PARAMETER       (KeyCtrlF4       = 214)
      PARAMETER       (KeyCtrlF5       = 215)
      PARAMETER       (KeyCtrlF6       = 216)
      PARAMETER       (KeyCtrlF7       = 217)
      PARAMETER       (KeyCtrlF8       = 218)
      PARAMETER       (KeyCtrlF9       = 219)
      PARAMETER       (KeyCtrlF10      = 220)
      PARAMETER       (KeyCtrlF11      = 221)
      PARAMETER       (KeyCtrlF12      = 222)
      PARAMETER       (KeyCtrlF13      = 223)
      PARAMETER       (KeyCtrlF14      = 224)
      PARAMETER       (KeyCtrlF15      = 225)
      PARAMETER       (KeyCtrlF16      = 226)
      PARAMETER       (KeyCtrlF17      = 227)
      PARAMETER       (KeyCtrlF18      = 228)
      PARAMETER       (KeyCtrlF19      = 229)
      PARAMETER       (KeyCtrlF20      = 230)
      PARAMETER       (KeyAltF1        = 231)
      PARAMETER       (KeyAltF2        = 232)
      PARAMETER       (KeyAltF3        = 233)
      PARAMETER       (KeyAltF4        = 234)
      PARAMETER       (KeyAltF5        = 235)
      PARAMETER       (KeyAltF6        = 236)
      PARAMETER       (KeyAltF7        = 237)
      PARAMETER       (KeyAltF8        = 238)
      PARAMETER       (KeyAltF9        = 239)
      PARAMETER       (KeyAltF10       = 240)
      PARAMETER       (KeyAltF11       = 241)
      PARAMETER       (KeyAltF12       = 242)
      PARAMETER       (KeyAltF13       = 243)
      PARAMETER       (KeyAltF14       = 244)
      PARAMETER       (KeyAltF15       = 245)
      PARAMETER       (KeyAltF16       = 246)
      PARAMETER       (KeyAltF17       = 247)
      PARAMETER       (KeyAltF18       = 248)
      PARAMETER       (KeyAltF19       = 249)
      PARAMETER       (KeyAltF20       = 250)
C
      PARAMETER       (LeftButtonDown  = 251)
      PARAMETER       (MiddleButtonDown= 252)
      PARAMETER       (RightButtonDown = 253)
      PARAMETER       (LeftButtonUp    = 254)
      PARAMETER       (MiddleButtonUp  = 255)
      PARAMETER       (RightButtonUp   = 256)
      PARAMETER       (MouseMove       = 257)
      PARAMETER       (ResizeEvent     = 259)
C     Note : 384-511 8-Bit Keyboard codes
      PARAMETER       (KeyAltBackspace = 520)
      PARAMETER       (KeyAltTab       = 521)
      PARAMETER       (KeyAltReturn    = 525)
      PARAMETER       (KeyAltEscape    = 539)
C     Note : 560-569 Alt/0 to Alt/9
C     Note : 577-602 Alt/A to Alt/Z
